
#include "ALRDEF.h"

typedef struct AL_GSTAT
{
	int cx,cy;		//Rs[W
	int bankNo;
	int mx,my;		//Rs[W
	int gx,gy;		//TCY
	int rx,ry;		//Sʒu
	WORD trstat;	//
	WORD trmode;	//@
	int wx,wy;		//gkTCY
	int ar;			//px
	int palshift;	//pbgVtg
	int RGB;		//
	int sqRGB;		//specular
}AL_GSTAT;

typedef struct AL_GFLAG
{
	int trcol;		//F
	int vtr;		//on F̏c
	int arunit;		//]̐x
	int zoomunit;	//gk̐x
	int tr100;		//on sx%P
	int rot;		//on S
}AL_GFLAG;


typedef struct AL_BANK
{
	int No;			//io[
	int cx,cy;		//W(ʏ0,0)
	int sx,sy;		//TCY
	int strsize;	//oN
	int bfsize;		//oÑobt@TCY(oN+pbg+VRAM)
	int flag;		//tO	&1 pbg/&2 VRAM/&256 oN̑
	int palt;		//pbgx
	int palmode;	//0tJ[[h /1 pbg[h
	char *str;		//oN
	RGBQUAD *pal;	//pbg(ۂ́AstroN)
	BYTE *pBit;		//f[^(strpbgTCY+oN)
} AL_BANK;

typedef struct CHARBOX
{
	int x,y;		//TCY
	UINT flag;		//&1 [yTCYgp
					//&2 F͈̔͌
} CHARBOX;

typedef struct PALFLAG
{
	BYTE not  : 1;
	BYTE mask : 1;
	BYTE limit: 1;
} PALFLAG;

//Al_graphŎgp֐̃|C^
typedef struct AL_FUNC
{
	int (*AL_pget)(BMSCR *, int, int);
	BYTE (*pal_app)(BMSCR *, BYTE, BYTE, BYTE, BYTE, BYTE,int);
	BOOL (*AL_lpset)(int, int, int);
	int (*bsave)(char *,BYTE *,int);
	int (*bload)(BYTE **, char *);
	void (*bms_setpal)(BMSCR *, int, void *);
}AL_FUNC;

//ALFARHSPŎgpϐ̃|C^
//QƂ݂̂ɂƂǂ߁AȂŉ
typedef struct AL_HSPVAL{
	int *dotS;			//hbgTCY
	int *Vheight;		//0=c1{ 1=c2{
	int *layer;			//1=C[ɕ`撆
	int *back_buffer;	//C[ON

	int *back_toNo;		//߂pbg
	int *back_to;		//0=߂Ȃ 1=߂

	int *grid_w;		//Obh
	int *grid_h;		//Obh
	int *grid_sw;		//ObhVtg
	int *grid_sh;		//ObhVtg
	int *dot_grid;		//1=hbgObhON
	int *sdot_grid_l;	//1=[yObhON
	int *useGrid;		//1=Obh\ON

	int *zone;			//`̃}[NTCY
	int *grid_max;		//1hbgObh\őzone

	BMSCR *bbm;			//C[BMSCR̃|C^
	HRGN *hrgn;
}AL_HSPVAL;

typedef struct AL_FRAME
{
	int cx,cy;			//\ʒu()
	int mx,my;			//Qƈʒu()
	int gx,gy;			//1R}̃TCY
	int time;			//\(ms)
}AL_FRAME;

typedef struct AL_ANIME
{
	BMSCR *bm;			//Ajf[^BMSCR
	int cnt;			//Aj̐
	AL_FRAME *frame;	//t[(AL_FRAME[cnt])
}AL_ANIME;

//gvOCɓnXe[^X
typedef struct ALR_STAT
{
	UINT flag;			//֐ĂяõtO
	int palNo;			//`悷pbgNo
	int bgpalNo;		//`ʒũpbgNo
	int pRGB;			//palNoBGR
	int mRGB;			//bgpalNoBGR
	int stat;			//yRg[̒l(0-256)
	int palA,palB;		//A̐F,B̐F
	int wid;			//݂̑
	int pen;			//݂̃y
	int ox,oy;			//݂̕`ʒułȂy̒Sʒu(x,y)
	int mx,my;			//݂̕`ʒułȂ}EXʒu(x,y)
	int cx,cy;			//Rs[捶W
	int areaX1,areaY1;	//`͈͍W
	int areaX2,areaY2;	//        EW

	int selX1,selY1;	//I͈͂܂̓Rs[W
	int selX2,selY2;	//                      EW

	BMSCR *work_bm;		//[Npobt@(CʂƑSe)
	BYTE *data;			//Alfar.ini֎󂯓nf[^
	int dataSize;		//*datãTCY
	AL_HSPVAL *alhsp;	//AL_SET̃|C^
	CHARBOX *charbox;	//XvCg[h̃LTCY
	int viewbank;		//gp̃oN(1-12)
	AL_BANK *bank;		//AL_BANK[256]̃|C^(13=ZN^[C 14=Rs[͈)
	PALFLAG *palflag;	//PALFLAG[256]̃|C^
	AL_ANIME *anime;	//ۑ̃Ajf[^
	AL_FUNC *func;
}ALR_STAT;

typedef struct ARE_EDITSTAT
{
	int leftx,lefty;
	int sizex,sizey;
	int *prt;
}ARE_EDITSTAT;

typedef struct ARE_PRTSET
{
	int type;		//IuWFNg̎
	int def;		//l
	int min,max;	//ŏ,ő(typeALEOBJ_INPUT̂Ƃ̂ݎgp)
}ARE_PRTSET;

//ۑAǂݍݎɓnl
typedef struct ALR_FILE
{
	char *name;			//t@C(tpX)
	char *mask;			//gq("."t 啶)
	BYTE *data;			//[ht@C̓e(1MByte)
	int size;			//[ht@CTCY
}ALR_FILE;

typedef struct AL_TEXTSTAT
{
	int x,y;			//ԊuAsԊu
	int bold;			//O
}AL_TEXTSTAT;


/*
int AL_pget(BMSCR *bm, int x, int y)
	BMSCR *	BMSCR
	int,int	W(x,y)
	return 	pbgNo

	x,ỹpbg𓾂܂
	͈͊O(}[NO)̏ꍇ-1Ԃ܂

BYTE pal_app(BMSCR *, BYTE r, BYTE g, BYTE b, BYTE ps, BYTE pe int not)
	BMSCR *
	BYTE, BYTE, BYTE	RGB
	BYTE, BYTE			pbg͈̔́Bʏ0`255w
	int 1=sgppbgLɂ
	return 	pbgNo

	^RGBɍł߂pbgԂ܂
	ɒxł

BOOL AL_lpset(int x, int y, int No);
	int,int	W(x,y)
	int	pbgNo	

	ALFAR̃[yɕ`悵܂
	y̑͂ݏoy擙(~LT[Ȃ)ł
	̖߂gpKv܂

int bsave(char *filename, BYTE *data, int size)
	char *	t@C
	BYTE *	ۑobt@̃|C^
	int		ۑTCY
	return	0 
			1 s

int bload(BYTE **data, char *filename)
	BYTE **	t@Ceobt@̃|C^󂯎|C^
	char *	t@C
	return	0 sTCY0
			1` TCY

	Ńobt@mۂAt@Cǂݍ݂܂
	pς񂾂freeŊJĂ

	yz
	BYTE *data;
	char *filename;
		F
	bload(&data,filename);
		F
	free(data);


*/
