
//-lgdi32 h2_gif.o -Wl,--image-base,0x64080000

/*
	DotPainterALFARpDLL
	AL_graph(AOt)
*/
#define FILEEXIST(s) (::GetFileAttributes(s) != 0xFFFFFFFF


#define VERSION "1.31a"
#define BANK_MAX 256
#define SAVEBANK_MAX 13
#define ALRPSET_MAX 64

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdlib.h>
#include <math.h>
#include "..\Hspdll.h"
#include "Hspsdk.c"
#include "AL_graph.h"
#include "ALR.h"
#include "RGBtoHSV.c"



#define N_NOM_PSET		0	//ʏ
#define N_R_PSET		1	//
#define N_ADD_PSET		2	//Z
#define N_DEC_PSET		13	//Z
#define N_MUL_PSET		3	//Z
#define N_GR_PSET		4	//ڂ
#define N_LIGHT_PSET	5	//邭
#define N_DARK_PSET		6	//Â
#define N_SHIFTp_PSET	7	//Vtg+
#define N_SHIFTm_PSET	8	//Vtg-
#define N_MIX_PSET		9	//~LT[
#define N_CHG_PSET		10	//F

#define N_PREVIEW_PSET	256	//vr[
#define APP_COPY		257
#define APP_COPYHSV		258
#define APP_COPYHSL		259
#define APP_COPYYMC		260
#define APP_COPY2		261	//pbgłl߂

#define PI 3.141592653589793
#define GETMASK(x) ((palflag[x].mask^rvMask) >>tmMask)

int pw_data[17][16]={	//[][]
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	1, 3, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 4, 4, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	3, 5, 5, 5, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 4, 6, 6, 4, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	3, 5, 7, 7, 7, 5, 3, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	2, 6, 6, 8, 8, 6, 6, 2, 0, 0, 0, 0, 0, 0, 0, 0,
	3, 7, 7, 9, 9, 9, 7, 7, 3, 0, 0, 0, 0, 0, 0, 0,
	4, 8, 8,10,10,10,10, 8, 8, 4, 0, 0, 0, 0, 0, 0,
	5, 9, 9,11,11,11,11,11, 9, 9, 5, 0, 0, 0, 0, 0,
	4, 8,10,10,12,12,12,12,10,10, 8, 4, 0, 0, 0, 0,
	3, 7, 9,11,11,13,13,13,11,11, 9, 7, 3, 0, 0, 0,
	4, 8,10,12,12,14,14,14,14,12,12,10, 8, 4, 0, 0,
	5, 9,11,13,13,15,15,15,15,15,13,13,11, 9, 5, 0,
	4, 8,10,12,14,14,16,16,16,16,14,14,12,10, 8, 4
};

int sin360[360];
int cos360[360];
int sin512[512];
int cos512[512];

PALFLAG palflag[256];
BYTE HSVset[1024];

AL_BANK *al_bank;
int exBankmax=32;
int mod2_tb[513];

ALR_STAT alrstat;
AL_HSPVAL alhsp;
CHARBOX charbox;
int *ALR_flag;
int *ARN_flag;
int ALRpsetcnt=0;

typedef UINT (*ALR_PSETFUNC)(BMSCR *,int,int,ALR_STAT *);
typedef UINT (*ALR_EDITFUNC)(BMSCR *,void *,ALR_STAT *);
typedef UINT (*ALR_LOADFUNC)(BMSCR *,void *,ALR_FILE *,ALR_STAT *);
typedef UINT (*ALR_SAVEFUNC)(BMSCR *,void *,ALR_FILE *,ALR_STAT *);
int getALfunc();


ALR_PSETFUNC ALRpset[ALRPSET_MAX];


EXPORT BOOL WINAPI DllMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason){
		case DLL_PROCESS_ATTACH:
			int i;

			for(i=0; i<180; i++) sin360[i]=sin(i *PI/180)*65536+0.5;
			for(i=0; i<180; i++) sin360[i+180]=-sin360[i];
			for(i=0; i<360; i++) cos360[(i+270)%360]= sin360[i];

			for(i=0; i<256; i++) sin512[i]=sin(i *PI/256)*65536+0.5;
			for(i=0; i<256; i++) sin512[i+256]=-sin512[i];
			for(i=0; i<512; i++) cos512[(i+384)&511]= sin512[i];

			ZeroMemory(palflag  ,sizeof(palflag));
			ZeroMemory(HSVset  ,sizeof(HSVset));

			//al_bank[-1]łokȗlɈm
			al_bank=(AL_BANK *)malloc(sizeof(AL_BANK)*(exBankmax+1));
			ZeroMemory(al_bank ,sizeof(AL_BANK)*(exBankmax+1));
			al_bank++;

			for(i=0; i<256; i++) mod2_tb[i+256]=i*i;
			for(i=0; i<256; i++) mod2_tb[i+1]=mod2_tb[511-i];
			mod2_tb[512]=256*256;

			srand(GetTickCount());
			ZeroMemory(&alrstat,sizeof(ALR_STAT));
			ZeroMemory(&alhsp,sizeof(AL_HSPVAL));
			ZeroMemory(&charbox,sizeof(CHARBOX));
			alrstat.alhsp=&alhsp;
			alrstat.charbox=&charbox;
			alrstat.bank=al_bank;
			alrstat.palflag=palflag;
			alrstat.func=(AL_FUNC *)getALfunc();


		break;
	default:
		break;
	}
	return TRUE;
}

EXPORT BOOL WINAPI AL_version (int p1, int p2, int p3 ,char *refstr)
{
	strcpy(refstr,VERSION);

	return 0;
}
//------------------------------------------------

static int palA=0;			//
static int palB=0;			//
static int penWid=1;		//
static int penAL=0;			//
static int mSTAT=0;			//ߗȂǂ̐ݒ
static int tmMask=0;		//1 }XN̈ꎞ
static int rvMask=0;		//1 }XN̔]
static int sprayerStat=0;	//Xv[
static BYTE *chgtable;

static BYTE *areapBit;		//GÃ|C^
static int areaBFW= 0;		//1sӂ̃TCY
static int areaX1 = 0;		//n_
static int areaY1 = 0;
static int areaX2 =31;		//I_
static int areaY2 =31;
static int areaW  =32;		//
static int areaH  =32;

static int *penMASK;		//1hbOɕ`悵ɂ͕`悵Ȃ
static char *pMESH;			//bVf[^̃|C^
static char *pMESHPOS;		//bV̎Qƈʒuł̃|C^

static int meshShiftX=0;
static int meshShiftY=0;
static int meshRand=0;		//1 bV_
static int meshRevers=0;	//1 bV]
static int Btrans=0;		//1 B
static int back_mesh[8]={0,0,0,0,0,0,0,0};

int mBFW,mW,mH,mPIXSIZE;	//AL_setŐݒ肳f[^
BMSCR *mbm;					//
BYTE *mpBMP;				//
RGBQUAD *mpRGB;				//


BMSCR *charBm;			//^pbgp|C^

int LD_stat=0;

BMSCR *mBbm;			//C[̃|C^
HDC lupe_hdc;



//------------------------------------------------
//////////////////////////////////////////////////
int rint(double x)
{
	int i;
	if (x<0) i=(int)(x-0.5); else i=(int)(x+0.5);
	return i;
}

int AL_bankSearch(int p1)
{
	int i; int a=-1;
	for(i=0; i<exBankmax; i++)
	{
		if (al_bank[i].No==p1){a=i; break;}
	}
	return a;
}
int AL_bankNew(int p1)
{
	AL_BANK *_al_bank;
	int i,sizeB,sizeA;

	p1=AL_bankSearch(p1);
	if (p1>-1) return p1;

	p1=-1;
	for(i=0; i<exBankmax; i++)
	{
		if ((al_bank[i].flag&256)==0){ p1=i; break; }
	}
	if (p1==-1){
		p1=exBankmax;

		//₷
		sizeB=sizeof(AL_BANK)*exBankmax;	//O
		sizeA=sizeB+sizeof(AL_BANK)*33;		//
		exBankmax+=32;

		_al_bank=(AL_BANK *)malloc(sizeA);
		FillMemory(_al_bank,sizeA,0);
		_al_bank++;
		CopyMemory(_al_bank,al_bank,sizeB);
		free(al_bank-1);
		al_bank=_al_bank;
		alrstat.bank=al_bank;
	}

	return p1;
}

EXPORT BOOL WINAPI AL_bankfree (int p1, int p2, int p3, int p4)
{
int i=p1;
	p1=AL_bankSearch(p1);

	if ( (al_bank[p1].flag&256)&&(p1!=-1) )
	{

		if (al_bank[p1].bfsize>0){
			if (al_bank[p1].str != NULL) free(al_bank[p1].str);

			else
			{
				char er[512];
				sprintf(er,"p1 = %d\nʒu = %d\nTCY = %d",i,p1,al_bank[p1].bfsize);
				MessageBox(NULL,er,"AL_bankfreeG[",0);
			}
		}

		ZeroMemory(&al_bank[p1],sizeof(AL_BANK));

		return 0;
	}
	else
	{
		return -1;
	}
}

//Rs[ʂ̎w
EXPORT BOOL WINAPI AL_set (BMSCR *bm, int p1, int p2, int p3)
{
	int p=AL_bankSearch(p1);

	if (p1==0 || al_bank[p].pBit==0 || p==-1)
	{
		mPIXSIZE=(bm->palmode==0)*2+1;			//13
		mBFW	=bm->sx*mPIXSIZE +3 & 0xFFFC;	//1ӂ̃obt@TCY
		mpBMP	=bm->pBit;
		mpRGB	=bm->pal;
		mW		=bm->sx;						//̃EBhẼTCY
		mH		=bm->sy;
		mbm		=bm;
	}
	else
	{
		mPIXSIZE    =(bm->palmode==0)*2+1;
		mBFW	=al_bank[p].sx*mPIXSIZE +3 & 0xFFFC;
		mpBMP	=al_bank[p].pBit;
		al_bank[p].pal==0 ? mpRGB=bm->pal: mpRGB=al_bank[p].pal;
		mW		=al_bank[p].sx;
		mH		=al_bank[p].sy;
	}

	return 0;
}

EXPORT BOOL WINAPI AL_banksave (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	/////////////////////
		BMSCR *bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		char *bankname=hei->HspFunc_prm_gets();
		int p=hei->HspFunc_prm_getdi(0);	//No
		int p2=hei->HspFunc_prm_getdi(0);	//pbgx
		int p3=hei->HspFunc_prm_getdi(1|2);	//&1 pbg
											//&2 VRAM
		if (*hei->er) return *hei->er;
	/////////////////////

	int size,gsize,strsize,vram_size,pal_size,y,cy,p1;
	int pixsize;

	if (bm->cx<0 || bm->cy<0) return -1;
	if (bm->cx+bm->gx > bm->sx || bm->cy+bm->gy > bm->sy) return -1;


	p1=AL_bankNew(p);
	if (al_bank[p1].bfsize!=0) free(al_bank[p1].str);

	strsize=strlen(bankname);
	if (strsize>1024) strsize=1024;

	pixsize=(bm->palmode==0)*2+1;

	al_bank[p1].flag=p3|256;
	if (p3&1) pal_size=1024; else pal_size=0;
	al_bank[p1].cx=bm->cx;
	al_bank[p1].cy=bm->cy;
	if (p3&2){
		al_bank[p1].sx=bm->gx;
		al_bank[p1].sy=bm->gy;
		vram_size=(bm->gx*pixsize +3 & 0xFFFC)*bm->gy;
	}else{
		al_bank[p1].sx=0;
		al_bank[p1].sy=0;
		vram_size=0;
	}
	al_bank[p1].palmode=bm->palmode;
	al_bank[p1].bfsize=strsize+pal_size+vram_size;
	al_bank[p1].No=p;
	al_bank[p1].palt=p2;
	al_bank[p1].str=(char *)malloc(al_bank[p1].bfsize);
	al_bank[p1].strsize=strsize;

	if (p3&1) al_bank[p1].pal=(RGBQUAD *)(al_bank[p1].str+strsize); else al_bank[p1].pal=0;
	if (p3&2) al_bank[p1].pBit=(BYTE *)(al_bank[p1].str+strsize+pal_size); else al_bank[p1].pBit=0;

	if (strsize>0) CopyMemory(al_bank[p1].str,bankname,strsize);
	if (p3&1) CopyMemory(al_bank[p1].pal,bm->pal,1024);
	if (p3&2) {
		size=bm->sx*pixsize +3 & 0xFFFC;
		gsize=bm->gx*pixsize +3 & 0xFFFC;
		cy=bm->sy-bm->gy-bm->cy;
		for(y=0; y<bm->gy; y++){
			CopyMemory(al_bank[p1].pBit+y*gsize,bm->pBit+size*(cy+y)+bm->cx*pixsize,gsize);
		}
	}

	return 0;
}

EXPORT BOOL WINAPI AL_bankcopy (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	/////////////////////
		_p1=hei->HspFunc_prm_geti();		//Rs[
		_p2=hei->HspFunc_prm_geti();		//Rs[

		if (*hei->er) return *hei->er;
	/////////////////////
	int p1,p2;

	if (_p1==_p2) return 1;
	p2=AL_bankSearch(_p2); if (p2==-1) return 1;
	p1=AL_bankNew(_p1); if (al_bank[p1].bfsize!=0) free(al_bank[p1].str);
	
	CopyMemory(&al_bank[p1],&al_bank[p2],sizeof(AL_BANK));
	al_bank[p1].No=_p1;

	al_bank[p1].str=(char *)malloc(al_bank[p1].bfsize);
	if (al_bank[p1].pal >0) al_bank[p1].pal =(RGBQUAD *)( al_bank[p1].str+al_bank[p1].strsize );
	if (al_bank[p1].pBit>0) al_bank[p1].pBit=(BYTE *)( al_bank[p1].str+al_bank[p1].strsize+(al_bank[p1].pal>0)*1024 );
	CopyMemory(al_bank[p1].str,al_bank[p2].str,al_bank[p2].bfsize);

	return 0;
}

//p2==1 pbg[hȂ
EXPORT BOOL WINAPI AL_bankload (BMSCR *bm, int p1, int p2, BYTE *pRGB)
{
	int bf,bbf,x,y,gx,gy,i,tcx,tcy,mcy,cx,cy,palmode;
	int pixsize=(bm->palmode==0)*2+1;
	BYTE *mpRGB;

	p1=AL_bankSearch(p1);
	palmode=al_bank[p1].palmode;
	if (al_bank[p1].bfsize==0 || p1==-1 || bm->palmode!=palmode) return -1;

	gx=al_bank[p1].sx;
	gy=al_bank[p1].sy;
	cx=al_bank[p1].cx;
	cy=al_bank[p1].cy;

	 if ((al_bank[p1].flag&2) && gx>0 && gy>0){
		if (gx==bm->sx && gy==bm->sy && cx==0 && cy==0){
			bf=(bm->sx*pixsize +3 & 0xFFFC )*bm->sy;
			CopyMemory(bm->pBit,al_bank[p1].pBit,bf);
		}else{
			if(gx+cx > bm->sx) gx=bm->sx-cx;
			if(gy+cy > bm->sy) gy=bm->sy-cy;
			tcx=cx;
			tcy=bm->sy -1 -cy;
			mcy=al_bank[p1].sy -1;

			bf= bm->sx*pixsize +3 & 0xFFFC;
			bbf=al_bank[p1].sx*pixsize +3 & 0xFFFC;
			for(y=0; y<gy; y++)
				CopyMemory(bm->pBit+bf*(tcy-y)+tcx,al_bank[p1].pBit+bbf*(mcy-y),gx*pixsize);
		}
	}

	if (p2==0 && (al_bank[p1].flag&1)==1 && bm->palmode==1){
		mpRGB=(BYTE *)al_bank[p1].pal;
		for(i=0; i<256; i++)
		{
			*(pRGB +i*3 +0)=*(mpRGB +i*4 +2);
			*(pRGB +i*3 +1)=*(mpRGB +i*4 +1);
			*(pRGB +i*3 +2)=*(mpRGB +i*4 +0);
		}
		bms_setpal(bm,256,pRGB);
	}

	return 0;
}
EXPORT BOOL WINAPI AL_banksize (PVAL2 *pval, int p1, int p2, int p3)
{
	int size;
	int *iv;
	p1=AL_bankSearch(p1);

	if (al_bank[p1].flag==0 || p1==-1) return 0;	//oN݂Ȃ
	if (pval->flag==2){
		//ϐϐ̏ꍇ̓oNRs[
		size=al_bank[p1].strsize;
		if (size>0) CopyMemory(pval->pt,al_bank[p1].str,size);
		pval->pt[size]=0;	//I[
	}else{
		iv=(int *)pval->pt;
		iv[0]=al_bank[p1].cx;
		iv[1]=al_bank[p1].cy;
		iv[2]=al_bank[p1].sx;
		iv[3]=al_bank[p1].sy;
		iv[4]=al_bank[p1].palt;
	}
	return -1;
}

//p1 \oNNoꂽz 0ŏI
//p2 ߂pbgNo
EXPORT BOOL WINAPI AL_banklayer (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	///////////////
		BMSCR *bm; int *p1,p2;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		p1=(int *)hei->HspFunc_prm_getv();
		p2=hei->HspFunc_prm_getdi(0);
	///////////////

	int i=0,bcnt,x=0,y=0;
	int b,bx,by,pxl;
	int bfx,sx,sy;
	BYTE *pBit;
	int *bNo;

	while(p1[i]) i++;
	bcnt=i; i=0;

	bNo=(int *)malloc(bcnt*4);
	while(p1[i]){
		x=AL_bankSearch(p1[i++]);
		if (x!=-1) bNo[y++]=x;
	}
	bcnt=y;

	sx=bm->sx;
	sy=bm->sy;


	switch(bm->palmode){
		case 0:
			RGBQUAD *rgb;

			bfx=sx*3 +3 & 0xFFFC;
			for(y=0; y<sy; y++){
				pBit=bm->pBit+(sy-1-y)*bfx;

				for(x=0; x<sx; x++){
					i=0; pxl=p2;
					while(i<bcnt && pxl==p2){
						b=bNo[i++];
						bx=x-al_bank[b].cx;
						by=y-al_bank[b].cy;

						if ( bx<0 || by<0 || bx>=al_bank[b].sx || by>=al_bank[b].sy )
							pxl=p2;
						else
							pxl=*(al_bank[b].pBit+(al_bank[b].sy-1-by)*(al_bank[b].sx+3&0xFFFC)+bx);
					}
					if (pxl==p2) continue;
					CopyMemory(pBit+x*3,al_bank[b].pal+pxl,3);
				//	rgb =al_bank[b].pal;
				//	pBit[x+0]=rgb[pxl].rgbBlue;
				//	pBit[x+1]=rgb[pxl].rgbGreen;
				//	pBit[x+2]=rgb[pxl].rgbRed;
				}
			}
		break;
		case 1:
			bfx=sx +3 & 0xFFFC;
			for(y=0; y<sy; y++){
				pBit=bm->pBit+(sy-1-y)*bfx;

				for(x=0; x<sx; x++){
					i=0; pxl=p2;
					while(i<bcnt && pxl==p2){
						b=bNo[i++];
						bx=x-al_bank[b].cx;
						by=y-al_bank[b].cy;

						if ( bx<0 || by<0 || bx>=al_bank[b].sx || by>=al_bank[b].sy )
							pxl=p2;
						else
							pxl=*(al_bank[b].pBit+(al_bank[b].sy-1-by)*(al_bank[b].sx+3&0xFFFC)+bx);
					}
					if (pxl==p2) continue;
					pBit[x]=pxl;
				}
			}
		break;
	}

	free(bNo);

	return 0;
}

//p1	ۑBankNO̔z
//		0͕ۑȂ
EXPORT BOOL WINAPI ABK_save (int *p1, char *filename, int p2, int p3)
{
	int size,i,bf,p,x,y;
	BYTE *ABK,*ABKp;
	int use[SAVEBANK_MAX],useNo[SAVEBANK_MAX];
	AL_BANKHEAD abh;
	AL_BANKDATA abd;


	ZeroMemory(&use	,sizeof(use));

	i=0; size=0; abh.bankcnt=0;
	while(p1[i]!=0)
	{
		p=AL_bankSearch(p1[i]);

		if (p!=-1 && al_bank[p].sx>0 && al_bank[p].sy>0){
			bf=(al_bank[p].sx +3 & 0xFFFC)*al_bank[p].sy;
			bf+=al_bank[p].strsize;
			size+=bf+1024+sizeof(AL_BANKDATA);
			use[abh.bankcnt]=p;
			useNo[abh.bankcnt]=p1[i];
			abh.bankcnt++;
		}
		i++;
	}


	size+=sizeof(AL_BANKHEAD);
	ABK=(BYTE *)malloc(size);
	ZeroMemory(ABK,size);
	ABKp=ABK;
	
	strcpy(abh.str,"AL_BANK\0");
	abh.headsize=sizeof(AL_BANKHEAD);
	
	CopyMemory(ABKp,&abh,sizeof(AL_BANKHEAD));	//G[

	ABKp+=sizeof(AL_BANKHEAD);
	for(i=0; i<abh.bankcnt; i++)
	{
		p=use[i];
		x=al_bank[p].sx;
		y=al_bank[p].sy;
		if (x>0){
			bf=( x+3 & 0xFFFC )*y +1024;
			//wb_
			abd.size=bf+sizeof(AL_BANKDATA)+al_bank[p].strsize;
			abd.headsize=sizeof(AL_BANKDATA);
			abd.No=useNo[i];
			abd.palt=al_bank[p].palt;
			abd.strsize=al_bank[p].strsize;
			abd.sx=x;
			abd.sy=y;
			CopyMemory(ABKp,&abd,sizeof(AL_BANKDATA));
			ABKp+=sizeof(AL_BANKDATA);

			//oN
			if (al_bank[p].strsize>0) CopyMemory(ABKp,al_bank[p].str,al_bank[p].strsize);
			ABKp+=al_bank[p].strsize;

			//f[^(pbg{sNZ)
			CopyMemory(ABKp,al_bank[p].pal,bf);
			ABKp+=bf;
		}
	}
	if (abh.bankcnt>0) bsave(filename,ABK,size);
	free(ABK);

	return -abh.bankcnt;
}
EXPORT BOOL WINAPI ABK_load (int *p1, char *filename, int p2, int p3)
{
	int a,i,c,p,strsize,size;
	BYTE *ABK,*ABKp;
	AL_BANKHEAD *abh;
	AL_BANKDATA *abd;

	if (bload(&ABK,filename)==0) return -1;
 	ABKp=ABK;

	abh=(AL_BANKHEAD *)ABKp;
	if ( abh->str[0]!='A' || abh->str[1]!='L') return -2;
	ABKp+=sizeof(AL_BANKHEAD);

	i=0;
	while(p1[i]!=0 && i<SAVEBANK_MAX){ AL_bankfree(p1[i],0,0,0); i++; }

	c=0;
	for (i=0; i<abh->bankcnt; i++)
	{
		abd=(AL_BANKDATA *)ABKp;
		ABKp+=sizeof(AL_BANKDATA);

		size=abd->size - sizeof(AL_BANKDATA);
		strsize=abd->strsize;

		for (a=0; a<SAVEBANK_MAX; a++){
			if (p1[a]==abd->No){
				p=AL_bankNew(abd->No);
				al_bank[p].No=abd->No;
				al_bank[p].sx=abd->sx;
				al_bank[p].sy=abd->sy;
				al_bank[p].flag=1|2|256;
				al_bank[p].palt=abd->palt;
				al_bank[p].palmode=1;
				al_bank[p].bfsize=size;
				al_bank[p].str=(char *)malloc(size);
				al_bank[p].strsize=strsize;
				al_bank[p].pal=(RGBQUAD *)(al_bank[p].str+strsize);
				al_bank[p].pBit=((BYTE *)al_bank[p].pal)+1024;
				CopyMemory(al_bank[p].str,ABKp,size);
				c++;
				break;
			}
		}
		ABKp+=size;
	}

	free(ABK);

	return -c;
}


//A̐Fݒ
EXPORT BOOL WINAPI palA_set (int p1, int p2, int p3, int p4)
{
	alrstat.palA=p1;
	palA=p1;
	return 0;
}
//B̐Fݒ
EXPORT BOOL WINAPI palB_set (int p1, int p2, int p3, int p4)
{
	alrstat.palB=p1;
	palB=p1;
	return 0;
}
//yݒ
//-1	̂܂
//p1	
//p2	
//p3	y
EXPORT BOOL WINAPI pen_stat (int p1, int p2, int p3, int p4)
{
	if (p1!=-1){
		penAL=p1;
		ARN_flag=ALR_flag+(p1-16);
	}
	if (p2!=-1){
		p2==0 ? penWid =1 : penWid =p2;
		alrstat.wid=penWid;
	}
	if (p3!=-1) alrstat.pen=p3;

	return 0;
}

//Xv[ݒ
//1 (0%) ` $7FFF (100%)
//0Ŗ
EXPORT BOOL WINAPI SP_stat (int p1, int p2, int p3, int p4)
{
	sprayerStat=p1;

	return 0;
}

//ߗȂǂ̐ݒ
EXPORT BOOL WINAPI AL_stat (int p1, int p2, int p3, int p4)
{
	alrstat.stat=p1;
	mSTAT=p1; return 0;
}

//͈͐ݒ(n_)
EXPORT BOOL WINAPI _AL_pos (int p1, int p2, int p3, int p4)
{
	areaX1=p1;
	areaY1=p2;
	alrstat.areaX1=areaX1;
	alrstat.areaY1=areaY1;

	return 0;
}
//͈͐ݒ(TCY)
EXPORT BOOL WINAPI _AL_area (BMSCR *bm, int p1, int p2, int p3)
{
	areapBit=bm->pBit;
	areaBFW=bm->sx +3 & 0xFFFC;
	areaW=p1;
	areaH=p2;
	areaX2=areaX1+areaW-1;		//I_
	areaY2=areaY1+areaH-1;
	alrstat.areaX2=areaX2;
	alrstat.areaY2=areaY2;
	
	if (areaX1+areaW > bm->sx){
		areaW=bm->sx-areaX1;
		areaX2=bm->sx-1;
	}
	if (areaY1+areaH > bm->sy){
		areaH=bm->sy-areaY1;
		areaY2=bm->sy-1;
	}
	return 0;
}
EXPORT BOOL WINAPI AL_backset (BMSCR *bm, int p1, int p2, int p3)
{
	mBbm=bm;
	alhsp.bbm=mBbm;
	return 0;
}

//p1 gvOC̎
//p2 ֐
//p3 tO
//p4 Ԃl擾ϐ(ȗ)
EXPORT BOOL WINAPI ALR_setflag (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	int stat=0;
	///////////////
		BMSCR *bm; int p1,p2,p3,p4;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		p1=hei->HspFunc_prm_getdi(0);
		p2=hei->HspFunc_prm_getdi(0);
		p3=hei->HspFunc_prm_getdi(0);
		p4=hei->HspFunc_prm_getdi(0);
/*
		switch(*hei->nptype){
			case 1: p4=hei->HspFunc_prm_getdi(0); break;
			case 4: p4=hei->HspFunc_prm_getv(); break;
			default: break;
		}
*/
		if (*hei->er) return *hei->er;
	///////////////
	
	alrstat.flag=p3;
	switch(p1)
	{
		int *i;
		//gy
		case 0:	
			stat=(ALRpset[p2])(bm,0,0,&alrstat);
			break;

		//gҏW
		case 1:
			stat=((ALR_EDITFUNC)p2)(bm,(void *)p4,&alrstat);
			break;

		case 2:
			i=(int *)p4;
			stat=((ALR_LOADFUNC)p2)(bm,(void *)i[0],(ALR_FILE *)i[1],&alrstat);
			break;

		case 3:
			i=(int *)p4;
			stat=((ALR_SAVEFUNC)p2)(bm,(void *)i[0],(ALR_FILE *)i[1],&alrstat);
			break;

		//}EXʒu
		case 256:
			alrstat.mx=p2;
			alrstat.my=p3;
			break;

		//gҏW̐ݒ
		case 257:
			alrstat.selX1=bm->cx;
			alrstat.selY1=bm->cy;
			alrstat.selX2=bm->cx+bm->gx-1;
			alrstat.selY2=bm->cy+bm->gy-1;

			break;

		//[Nݒ
		case 512:
			alrstat.work_bm=bm;
			break;

		default:
			break;
	}
	alrstat.flag=0;

	return -stat;
}

EXPORT BOOL WINAPI ALR_iniload (int *p1, int p2, int p3, int p4)
{
	alrstat.data=(BYTE *)p1;
	alrstat.dataSize=p2;
	return 0;
}
EXPORT BOOL WINAPI ALR_inisave (int *p1, int p2, int p3, int p4)
{
	p1[0]=(int)alrstat.data;
	p1[1]=alrstat.dataSize;
	alrstat.data=0;
	alrstat.dataSize=0;
	return 0;
}



//////////////////////////////////////////////////
//gȂpbg̐ݒ
EXPORT BOOL WINAPI notpal_set (int p1, int p2, int p3 ,int p4)
{
	if (p2==-1)
		return -palflag[p1 &255].not;
	else
		palflag[p1 &255].not=p2 &1;

	return 0;
}
//}XN̐ݒ
EXPORT BOOL WINAPI mask_set (int p1, int p2, int p3 ,int p4)
{
	if (p1==-1) tmMask=1;
	if (p1==-2) tmMask=0;
	if (p1==-3) rvMask=1;
	if (p1==-4) rvMask=0;
	if (p1<0) return 0;

	if (p2==-1)
		return -palflag[p1 &255].mask;
	else
		palflag[p1 &255].mask=p2 &1;

	return 0;
}
//~bg̐ݒ
EXPORT BOOL WINAPI limit_set (int p1, int p2, int p3 ,int p4)
{
	if (p2==-1)
		return -palflag[p1 &255].limit;
	else
		palflag[p1 &255].limit=p2 &1;

	return 0;
}
EXPORT BOOL WINAPI getPalptr (int *p1, int p2, int p3 ,int p4)
{
	*p1=(int)palflag;
	return 0;
}

//Fϊe[ũ|C^
//p2	1 0`255ŏ
EXPORT BOOL WINAPI colorchg_set (BYTE *p1, int p2, int p3 ,int p4)
{
	int i;
	chgtable=p1;
	if (p2==1){
		for (i=0; i<256; i++) *(chgtable+i)=i;
	}

	return 0;
}

//ߎF
int colordim=0;
int stHSV=-1;
int stRGB=-1;
int stSE=-1;

BYTE pal_app2 (BMSCR *bm, BYTE r, BYTE g, BYTE b, BYTE ps, BYTE pe,int not)
{
	register int p,i;
	int sp=0x7FFFFFFF;
	static BYTE s;
	int RGB,SE;
	BYTE *mpRGB;
	mpRGB =(BYTE *)bm->pal;
	mpRGB +=ps*4;

	RGB=(r<<16)+(g<<8)+b;
	SE=(ps<<8)+pe;
	if (stRGB==RGB && stSE==SE) return s;
	stRGB=RGB;
	stSE=SE;

	for(i=ps ;i<=pe ; i++)
	{
		p =mod2_tb[*mpRGB     -b+256]+
		   mod2_tb[*(mpRGB+1) -g+256]+
		   mod2_tb[*(mpRGB+2) -r+256];
		mpRGB+=4;
		if (p<sp){
			if (not&&palflag[i].not==1) continue;
			sp=p;
			s=i;
		}
	}
	return s;
}
//HSPĂяop
EXPORT BOOL WINAPI pal_app (BMSCR *bm, BYTE r, BYTE g, BYTE b)
{
	return -pal_app2(bm,r,g,b,0,255,1);
}
EXPORT BOOL WINAPI pal_bfapp (int *p1, BYTE r, BYTE g, BYTE b)
{
	BMSCR bm;
	bm.pal=(RGBQUAD *)p1;
	return -pal_app2(&bm,r,g,b,0,255,1);
}

//RGBtOZbg
//HSVe[u쐬
EXPORT BOOL WINAPI app_reset (BMSCR *bm, int p1, int p2 ,int p3)
{
	int rgb[3];
	int i;
	BYTE *pPal;
	pPal=(BYTE *)bm->pal;

	colordim=p1;
	stRGB=-1;
	stHSV=-1;
	stSE=-1;

	if (p1==0) return 0;
	for(i=0; i<256; i++){
		rgb[0]=pPal[i*4+2];
		rgb[1]=pPal[i*4+1];
		rgb[2]=pPal[i*4+0];
		switch(p1){
			case 1: RGBtoHSV(rgb,0,0,0); break;
			case 2: RGBtoHSL(rgb,0,0,0); break;
			case 3: RGBtoYUV(rgb,0,0,0); break;
		}
		HSVset[i*4+0]=rgb[0];
		HSVset[i*4+1]=rgb[1];
		HSVset[i*4+2]=rgb[2];
	}

	return 0;
}


BYTE hsv_app (BMSCR *bm, BYTE r, BYTE g, BYTE b, BYTE ps, BYTE pe,int not)
{
	int rgb[3];
	int p,i,h,s,v;
	int sp=0x7FFFFFFF;
	static BYTE appPalette;
	int HSV,SE;
	int a,x1,y1,x2,y2;
	BYTE *mpHSV;
	mpHSV =HSVset+ps*4;

	rgb[0]=r;
	rgb[1]=g;
	rgb[2]=b;

	switch(colordim){
		case 1: RGBtoHSV(rgb,0,0,0); break;
		case 2: RGBtoHSL(rgb,0,0,0); break;
		case 3: RGBtoYUV(rgb,0,0,0); break;
	}
	h=rgb[0];
	s=rgb[1];
	v=rgb[2];

	HSV=(h<<16)+(s<<8)+v;
	SE=(ps<<8)+pe;
	if (stHSV==HSV && stSE==SE) return appPalette;
	stHSV=HSV;
	stSE=SE;

	switch(colordim){
	case 1: y1=v; break;
	case 2: y1=(128-abs(v-128))*2; break;
	case 3:
		for(i=ps; i<=pe; i++){
		p =mod2_tb[mpHSV[0]-h+256]+mod2_tb[mpHSV[1]-s+256]+mod2_tb[mpHSV[2]-v+256]; mpHSV+=4;
		if (p<sp){
			if (palflag[i].not==not) continue;
			sp=p; appPalette=i;
		}
		}
		return appPalette;
	}

	for(i=ps; i<=pe; i++)
	{
		x1=min(h-*mpHSV&255,*mpHSV-h&255)*y1*s>>15;
		x2=(mpHSV[1]-s)*y1>>8;

		p =mod2_tb[ x1 +256 ]+
		   mod2_tb[ x2 +256 ]+
		   mod2_tb[ mpHSV[2]-v +256 ];

/*
		x1=s*sin512[h*2];
		y1=s*cos512[h*2];
		x2=mpHSV[1]*sin512[ *mpHSV*2 ];
		y2=mpHSV[1]*cos512[ *mpHSV*2 ];

		p =mod2_tb[ (x1-x2>>17)*v/256 +256 ]+
		   mod2_tb[ (y1-y2>>17)*v/256 +256 ]+
		   mod2_tb[ mpHSV[2]-v  +256 ];
*/
		mpHSV+=4;
		if (p<sp){
			if (palflag[i].not==not) continue;
			sp=p;
			appPalette=i;
		}
	}
	return appPalette;
}

//tJ[̃obt@pbg[h̃obt@փRs[
//pos Rs[
//gmode TCY
//p1,p2 Rs[
//p3=1 hsv
//p4=0 sgppbg̈ꎞ

EXPORT BOOL WINAPI full_app (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	BMSCR *bm;
	BYTE r,g,b;
	BYTE *f_bw,*p_bw,*p;
	int x,y,cx,cy,gx,gy,sx,sy,bfw;
	int p1,p2,p3,p4;

	///////////////////////
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		p1=hei->HspFunc_prm_getdi(0);
		p2=hei->HspFunc_prm_getdi(0);
		p3=hei->HspFunc_prm_getdi(0);
		p4=hei->HspFunc_prm_getdi(0);
		if (*hei->er) return *hei->er;

	app_reset(bm,p3,0,0);
	cx=bm->cx; cy=bm->cy;
	gx=bm->gx; gy=bm->gy;
	sx=bm->sx; sy=bm->sy;

	if (cx<0){ gx+=cx; p1-=cx; cx=0; }
	if (cy<0){ gy+=cy; p2-=cy; cy=0; }
	if (gx<=0 || gy<=0) return 0;

	if (cx+gx>sx) gx=sx-cx;
	if (cy+gy>sy) gy=sy-cy;

	if (gx+p1>mW) gx=mW-p1;
	if (gy+p2>mH) gy=mH-p2;

	bfw=sx +3 & 0xFFFC;

	for(y=0; y<gy; y++)
	{
		f_bw=mBFW*(mH-1-(y+p2)) +mpBMP;		//Rs[
		p_bw=bfw*(sy-1-(y+cy)) +bm->pBit;	//Rs[
		for(x=0; x<gx; x++)
		{
			p=f_bw+(x+p1)*3;
			if (p3>0)
				*(p_bw+x+cx)=hsv_app(bm,p[2],p[1],p[0],0,255,p4);
			else
				*(p_bw+x+cx)=pal_app2(bm,p[2],p[1],p[0],0,255,p4);
		}
	}

	return 0;
}
//////////////////////////////////////////////////

//^Cp^[̓o^
EXPORT BOOL WINAPI mesh_set (char *p1, int p2, int p3 ,int p4)
{
	pMESH=p1;
	return 0;
}

//^Cp^[̈ʒuݒ X,Y,shiftX,shiftY
EXPORT BOOL WINAPI mesh_pos (int p1, int p2, int p3 ,int p4)
{
	pMESHPOS=(p1<<4)+(p2<<12)+pMESH;
	
	meshShiftX=p3;
	meshShiftY=p4;

	return 0;
}

//p1=1	_
//p1=2	]
//p1=4	B̐F𓧖
EXPORT BOOL WINAPI mesh_stat (int p1, int p2, int p3 ,int p4)
{
	meshRand	=   p1&1;
	meshRevers	= ((p1&2)>>1)*255;
	Btrans		=  (p1&4)>>2;
	
	return 0;
}

//^Cp^[̃`FbN
//return=  0 A̐F
//return=255 B̐F
int mesh_if (int p1, int p2)
{
	int x=0,y=0,i;
//	if (pMESHPOS==pMESH) return 0;
	if (meshRand==1){
		i=rand();
		x=i&15;
		y=i>>4;
	}

	return *( (p1+meshShiftX+x &15) +(p2+meshShiftY+y &15)*256 +pMESHPOS )^meshRevers;
}

//p1,p2 x,y
//p3,p4 bV̍W
int mesh_if2 (int p1, int p2 ,int p3, int p4)
{
	return *( (p1 &15) +(p2 &15)*256 +((p3<<4)+(p4<<12)+pMESH) );
}

EXPORT BOOL WINAPI mesh_tmpstat (int p1, int p2, int p3, int p4)
{
	int i=0;

	// [0]`[3] 񓧉ߕ
	// [4]`[7] ߕ

	if (p1==-1)
		i=back_mesh[p2];
	else
		back_mesh[p1]=p2;

	return -i;
}

//p3 =1 ߕ
int mesh_tmpif (int p1, int p2, int p3)
{
	char *pTmpm;
	int rvs,x,y;
	p3*=4;
	x=(back_mesh[p3+0]>>4)&15;
	y=back_mesh[p3+0]&15;
	pTmpm=(x<<4)+(y<<12)+pMESH;

	rvs=(back_mesh[p3+1]&1)*255;

	return *( (p1+back_mesh[p3+2] &15) +(p2+back_mesh[p3+3]&15)*256 +pTmpm )^rvs;
}


//////////////////////////////////////////////////



BOOL pget2 (BMSCR *bm, int p1, int p2)
{
	if (p1 <areaX1 || p2 <areaY1 || p1 > areaX2 || p2 > areaY2) return -1;
	return *(bm->pBit + (bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1);
}

BOOL pgetRGB (BMSCR *bm, int x, int y, BYTE *R, BYTE *G, BYTE *B)
{
	int c;
	RGBQUAD *mpRGB;
	mpRGB =bm->pal;
	
	c=*(bm->pBit + (bm->sy -1-y)*(bm->sx +3 & 0xFFFC) +x);

	*R=mpRGB[c].rgbRed;
	*G=mpRGB[c].rgbGreen;
	*B=mpRGB[c].rgbBlue;
}

//////////////////////////////


BOOL imemset (BYTE *m, unsigned int c, int s)
{
	int p;
	int *im,*em;
	BYTE *mm;

	im=(int *)m;
	em=(int *)(m+(s&0xFFFFFFFC));
	while(im<em){ *im=c; im++; }

	p=s&3;
	if (p>0)
	{
		mm=m+(s&0xFFFFFFFC);

		*mm=c&0xFF;
		if (p>1) *(mm+1)=(c&0x0000FF00)>>8;
		if (p>2) *(mm+2)=(c&0x00FF0000)>>16;
	}
}

///////////////////////////////////////////////////////

int *dotS;			//hbgTCY
int *Vheight;			//0=c1{ 1=c2{
int *layer;			//C[ʒu(0=\ 1=)
int *back_buffer;		//C[ON

int *grid_w;			//Obh
int *grid_h;			//Obh
int *grid_sw;			//ObhVtg
int *grid_sh;			//ObhVtg
int *lgrid_w;
int *lgrid_h;
int *lgrid_sw;
int *lgrid_sh;
int *dot_grid;			//1hbgObhON
int *sdot_grid_l;		//[yObhON
int *exgrid;
int *useGrid;
int *zone;
int *grid_max;

int *back_toNo;			//߂pbg
int *back_to;			//0=߂Ȃ 1=߂

int *lupe_x;			//[ÿʒu
int *lupe_y;			//
int lupe_on=0;

BMSCR *lupe_bm;			//[ỹ|C^
HRGN *halrgn;


BOOL AL_lboxf(int x1, int y1, int w, int h, unsigned int c, int type)
{
	int bw;
	BYTE *cy;
	BYTE *ey;
	int x,y;

	bw=lupe_bm->sx +3 & 0xFFFC;
	cy=lupe_bm->pBit +(lupe_bm->sy -1-y1)*bw +x1;
	ey=cy-h*bw;

	switch (type){
		case 0://̎lp
			while(cy>ey){
				memset(cy,c,w);
				cy-=bw;
			}
			break;
		case 1://s͗l
			if ((x1+y1&1) ==1) c=(c<<8)+(c>>24);
			while(cy>ey){
				imemset(cy,c,w);
				c=(c<<8)+(c>>24);
				cy-=bw;
			}
			break;
		case 2://^Cp^[ ߕ
			y=y1;
			while(cy>ey){
				x=0;
				while(x<w){
					if (mesh_tmpif(x1+x,y,1)==0)
						*(cy+x)=c>>8&255;
					else
						*(cy+x)=c&255;
					x++;
				}
				cy-=bw;
				y++;
			}
		case 3://^Cp^[
			y=y1;
			while(cy>ey){
				x=0;
				while(x<w){
					if (mesh_tmpif(x1+x,y,0)!=0)
						*(cy+x)=c>>8&255;
					else
						*(cy+x)=c&255;
					x++;
				}
				cy-=bw;
				y++;
			}
			break;
	}

	BitBlt( lupe_hdc, x1 -lupe_bm->xx, y1 -lupe_bm->yy, w, h, lupe_bm->hdc,x1,y1, SRCCOPY );
}

EXPORT BOOL WINAPI AL_lswitch (int p1, int p2, int p3, int p4)
{
	lupe_on=p1;
	return 0;
}

EXPORT BOOL WINAPI AL_lset1 (BMSCR *bm, int p1, int p2, int p3)
{
	lupe_x=(int *)p1;		//[ÿʒu
	lupe_y=(int *)p2;		//
	lupe_bm=bm;			//[ỹ|C^

	return 0;
}
EXPORT BOOL WINAPI AL_lset2 (int *p1, int p2, int p3, int p4)
{
	dotS		=(int *) p1[ 0];	//hbgTCY
	Vheight		=(int *) p1[ 1];	//0=c1{ 1=c2{
	layer		=(int *) p1[ 2];	//1=C[ɕ`撆
	back_buffer	=(int *) p1[ 3];	//C[ON

	back_toNo	=(int *) p1[ 4];	//߂pbg
	back_to		=(int *) p1[ 5];	//0=߂Ȃ 1=߂

	grid_w		=(int *) p1[ 6];	//Obh
	grid_h		=(int *) p1[ 7];	//Obh
	grid_sw		=grid_w+1;			//ObhVtg
	grid_sh		=grid_h+1;			//ObhVtg
	lgrid_w		=grid_w+2;
	lgrid_h		=grid_h+2;
	lgrid_sw	=grid_w+3;
	lgrid_sh	=grid_h+3;

	dot_grid	=(int *) p1[ 9];	//1hbgObhON
	sdot_grid_l	=(int *) p1[10];	//[yObhON
	exgrid		=(int *) p1[11];	//[ypObhON
	useGrid		=(int *) p1[12];	//Obh\

	zone		=(int *) p1[13];	//`̃}[NTCY
	grid_max	=(int *) p1[14];	//1hbgObh\őzone
	halrgn		=(HRGN *) p1[15];	//[Wnh

	alhsp.dotS		=dotS;
	alhsp.Vheight	=Vheight;
	alhsp.layer		=layer;
	alhsp.back_buffer=back_buffer;

	alhsp.back_toNo	=back_toNo;
	alhsp.back_to	=back_to;
                         
	alhsp.grid_w	=grid_w;
	alhsp.grid_h	=grid_h;
	alhsp.grid_sw	=grid_sw;
	alhsp.grid_sh	=grid_sh;
	alhsp.dot_grid	=dot_grid;
	alhsp.sdot_grid_l=sdot_grid_l;
	alhsp.useGrid	=useGrid;
                         
	alhsp.zone		=zone;
	alhsp.grid_max	=grid_max;
	alhsp.hrgn		=halrgn;

	return 0;
}

//gy̒ǉ
//p1֐|C^
//tO
EXPORT BOOL WINAPI add_ALRpset(int p1, int p2, int p3, int p4)
{
	if (p2){
		ALR_flag=(int *)p2;
		return 0;
	}
	if (ALRpsetcnt>ALRPSET_MAX) return -ALRPSET_MAX;
	ALRpset[ALRpsetcnt]=(ALR_PSETFUNC)p1;
	ALRpsetcnt++;
	return -ALRpsetcnt;
}

//ALFAR̃[yւ̕`
BOOL AL_lpset (int p1, int p2, int p3)
{
	if (lupe_hdc==NULL) return 0;
	int x=0,y=0;
	int x1,y1;
	BYTE c;
	int dotSh;
	
	dotSh=*dotS << *Vheight;
	x1=(p1 -areaX1)* *dotS	+ *lupe_x;
	y1=(p2 -areaY1)* dotSh	+ *lupe_y;


	if (*zone <= *grid_max & *dot_grid & *useGrid){
		x=1;
		y=1;
	}else if (*sdot_grid_l & *useGrid){
		x=(p1+1) % *grid_w ==*grid_sw;
		y=(p2+1) % *grid_h ==*grid_sh;
	}else if (*exgrid & *useGrid){
		x=(p1+1 -areaX1) % *lgrid_w ==*lgrid_sw;
		y=(p2+1 -areaY1) % *lgrid_h ==*lgrid_sh;
	}


	if (*layer==0 && *back_buffer==1 && *back_to!=0)
	{
		c=*(mBbm->pBit +(mBbm->sy -1-p2)*(mBbm->sx +3 & 0xFFFC) +p1);

		if (*back_toNo!=p3)
		{
			if (back_mesh[0]!=0)
				AL_lboxf(x1, y1, *dotS-x, dotSh-y, c<<8|p3 ,3);
			else
				AL_lboxf(x1, y1, *dotS-x, dotSh-y, p3, 0);
		}
		else
		{
			if (back_mesh[4]!=8)
				AL_lboxf(x1, y1, *dotS-x, dotSh-y, c<<8|p3 ,2);
			else
				AL_lboxf(x1, y1, *dotS-x, dotSh-y, (c<<24)|(p3<<16)|(c<<8)|p3 ,1);
		}
	}
	else
	{
		AL_lboxf(x1, y1, *dotS-x, dotSh-y, p3, 0);
	}

	return 0;
}





/*
	p1Cp2	ʒu
	p3	pbgNo(0-255)
*/
EXPORT BOOL WINAPI AL_pset (BMSCR *bm, int p1, int p2, int p3)
{
	*(bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1)=p3;
	AL_lpset(p1,p2,p3);

	return 0;
}

//
EXPORT BOOL WINAPI tr_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *m;
	BYTE R,G,B;
	BYTE ps=0,pe=255;
	RGBQUAD *cpRGB;
	cpRGB =bm->pal;
	
	m= bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1;
	
	B  =cpRGB[*m].rgbBlue;
	G  =cpRGB[*m].rgbGreen;
	R  =cpRGB[*m].rgbRed;

	B +=(cpRGB[p3].rgbBlue -B )*mSTAT >>8;
	G +=(cpRGB[p3].rgbGreen-G )*mSTAT >>8;
	R +=(cpRGB[p3].rgbRed  -R )*mSTAT >>8;

	if (charbox.flag&2){ ps=*m&0xF0; pe=ps+15; }

	*m=pal_app2(bm,R,G,B,ps,pe,1);
	AL_lpset(p1,p2,*m);
	
	return 0;
}

//Z
EXPORT BOOL WINAPI add_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *m;
	BYTE ps=0,pe=255;
	int R,G,B;
	RGBQUAD *cpRGB;
	cpRGB =bm->pal;
	
	m= bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1;
	
	B =cpRGB[*m].rgbBlue  +(cpRGB[p3].rgbBlue  *mSTAT >>8);
	G =cpRGB[*m].rgbGreen +(cpRGB[p3].rgbGreen *mSTAT >>8);
	R =cpRGB[*m].rgbRed   +(cpRGB[p3].rgbRed   *mSTAT >>8);

	if (B>255) B=255;
	if (G>255) G=255;
	if (R>255) R=255;

	if (charbox.flag&2){ ps=*m&0xF0; pe=ps+15; }

	*m=pal_app2(bm,R,G,B,ps,pe,1);
	AL_lpset(p1,p2,*m);


	return 0;
}
//Z
EXPORT BOOL WINAPI dec_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *m;
	BYTE ps=0,pe=255;
	int R,G,B;
	RGBQUAD *cpRGB;
	cpRGB =bm->pal;
	
	m= bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1;
	
	B =cpRGB[*m].rgbBlue  -(cpRGB[p3].rgbBlue  *mSTAT >>8);
	G =cpRGB[*m].rgbGreen -(cpRGB[p3].rgbGreen *mSTAT >>8);
	R =cpRGB[*m].rgbRed   -(cpRGB[p3].rgbRed   *mSTAT >>8);

	if (B<0) B=0;
	if (G<0) G=0;
	if (R<0) R=0;

	if (charbox.flag&2){ ps=*m&0xF0; pe=ps+15; }

	*m=pal_app2(bm,R,G,B,ps,pe,1);
	AL_lpset(p1,p2,*m);
	
	return 0;
}

//]Z
EXPORT BOOL WINAPI mul_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *m;
	BYTE ps=0,pe=255;
	int R,G,B;
	RGBQUAD *cpRGB;
	cpRGB =bm->pal;
	m= bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1;
	
	B =cpRGB[*m].rgbBlue  -((255-cpRGB[p3].rgbBlue)  *mSTAT >>8);
	G =cpRGB[*m].rgbGreen -((255-cpRGB[p3].rgbGreen) *mSTAT >>8);
	R =cpRGB[*m].rgbRed   -((255-cpRGB[p3].rgbRed)   *mSTAT >>8);

	if (B<0) B=0;
	if (G<0) G=0;
	if (R<0) R=0;

	if (charbox.flag&2){ ps=*m&0xF0; pe=ps+15; }

	*m=pal_app2(bm,R,G,B,ps,pe,1);
	AL_lpset(p1,p2,*m);
	
	return 0;
}

//邭
//p3	-1 e[u쐬
//	 1 e[ugȂ
EXPORT BOOL WINAPI light_pset (BMSCR *bm, int p1, int p2, int p3)
{
	int c;
	BYTE R,G,B;
	BYTE ps=0,pe=255;

	RGBQUAD *cpRGB;
	static BYTE grTB[256];
	cpRGB =bm->pal;

	c= *(bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1);
	if (p3!=0){
		int i,s=0,e=256;
		if (p3==1){s=c; e=c+1;}
		for (i=s; i<e; i++){
			B  =cpRGB[i].rgbBlue;
			G  =cpRGB[i].rgbGreen;
			R  =cpRGB[i].rgbRed;

			B +=(255-B)*mSTAT >>8;
			G +=(255-G)*mSTAT >>8;
			R +=(255-R)*mSTAT >>8;
			if (charbox.flag&2){ ps=i&0xF0; pe=ps+15; }
			grTB[i]=pal_app2(bm,R,G,B,ps,pe,1);
		}
		if (p3==-1) return 0;
	}
	AL_pset(bm,p1,p2,grTB[c]);

	return 0;
}

//Â
//p3	-1 e[u쐬
//	 1 e[ugȂ
EXPORT BOOL WINAPI dark_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE c,R,G,B;
	BYTE ps=0,pe=255;
	RGBQUAD *cpRGB;
	static BYTE grTB[256];

	cpRGB =bm->pal;

	c= *(bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1);
	if (p3!=0){
		int i,s=0,e=256;
		if (p3==1){s=c; e=c+1;}
		for (i=s; i<e; i++){
			B  =cpRGB[i].rgbBlue;
			G  =cpRGB[i].rgbGreen;
			R  =cpRGB[i].rgbRed;

			B=(256-mSTAT)*B >>8;
			G=(256-mSTAT)*G >>8;
			R=(256-mSTAT)*R >>8;
			if (charbox.flag&2){ ps=i&0xF0; pe=ps+15; }
			grTB[i]=pal_app2(bm,R,G,B,ps,pe,1);
		}
		if (p3==-1) return 0;
	}
	AL_pset(bm,p1,p2,grTB[c]);

	return 0;
}

//ڂ
//p3 ڂ
EXPORT BOOL WINAPI gr_pset (BMSCR *bm, int p1, int p2, int p3)
{
	RGBQUAD *cpRGB; cpRGB =bm->pal;
	BYTE ps=0,pe=255;
	int R,G,B;
	int c,x,y,z,w,mX,mY;
	int i=0;

	if (p3>10) return -1;

	if (charbox.flag&2){
		c=pget2(bm,p1,p2);
		ps=c&0xF0; pe=ps+15;
	}

	if (p3>0){
		R=0; G=0; B=0;
		z =p3*2+1;
		w =z/2;
		mX=p1-w+z;
		mY=p2-w+z;
		
		for (y=p2-w ;y<mY ;y++)
		{
			for (x=p1-w ;x<mX ;x++)
			{
				c  =pget2(alrstat.work_bm,x,y);
				if (c>=0){
					i++;
					B +=cpRGB[c].rgbBlue;
					G +=cpRGB[c].rgbGreen;
					R +=cpRGB[c].rgbRed;
				}
			}
		}
		if (i>0){
			AL_pset(bm,p1,p2,pal_app2(bm,R/i,G/i,B/i,ps,pe,1));
		}
		return 0;
	}

	x=p1; y=p2;
	c =pget2(alrstat.work_bm,x,y);
	if (c>=0){
		i++;
		B  =cpRGB[c].rgbBlue; G  =cpRGB[c].rgbGreen; R  =cpRGB[c].rgbRed;
	}

	x++;
	c =pget2(alrstat.work_bm,x,y);
	if (c>=0){
		i++;
		B +=cpRGB[c].rgbBlue; G +=cpRGB[c].rgbGreen; R +=cpRGB[c].rgbRed;
	}

	x-=2;
	c =pget2(alrstat.work_bm,x,y);
	if (c>=0){
		i++;
		B +=cpRGB[c].rgbBlue; G +=cpRGB[c].rgbGreen; R +=cpRGB[c].rgbRed;
	}

	x=p1; y++;
	c =pget2(alrstat.work_bm,x,y);
	if (c>=0){
		i++;
		B +=cpRGB[c].rgbBlue; G +=cpRGB[c].rgbGreen; R +=cpRGB[c].rgbRed;
	}

	y-=2;
	c =pget2(alrstat.work_bm,x,y);
	if (c>=0){
		i++;
		B +=cpRGB[c].rgbBlue; G +=cpRGB[c].rgbGreen; R +=cpRGB[c].rgbRed;
	}
	
	if (i>0) AL_pset(bm,p1,p2,pal_app2(bm,R/i,G/i,B/i,ps,pe,1));

	return 0;
}

//PAL++
EXPORT BOOL WINAPI sp_pset (BMSCR *bm, int p1, int p2, int p3)
{
	int i;
	BYTE *m;
	m=bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1;
	
	for(i=0; i<p3; i++)
	{
		if (palflag[*m].limit==1) break;
		*m=*m+1&255;
	}

	AL_lpset(p1,p2,*m);

	return 0;
}

//PAL--
EXPORT BOOL WINAPI sm_pset (BMSCR *bm, int p1, int p2, int p3)
{
	int i;
	BYTE *m;
	m=bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1;
	
	for(i=0; i<p3; i++)
	{
		if (palflag[*m-1 &255].limit==1) break;
		*m=*m-1&255;
	}

	AL_lpset(p1,p2,*m);

	return 0;
}

//~LT[
EXPORT BOOL WINAPI mx_pset (BMSCR *bm, int p1, int p2, int p3)
{
	int x,y,c1,c2;
	c1=*(bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1);

	switch ( rand()&7 ){
		case 0:
			x=p1;	y=p2-1;	break;
		case 1:
			x=p1;	y=p2+1;	break;
		case 2:
			x=p1-1;	y=p2;	break;
		case 3:
			x=p1+1;	y=p2;	break;
		case 4:
			x=p1-1;	y=p2-1;	break;
		case 5:
			x=p1-1;	y=p2+1;	break;
		case 6:
			x=p1+1;	y=p2-1;	break;
		case 7:
			x=p1+1;	y=p2+1;	break;
	}
	
	c2=pget2(bm,x,y);

	if (c2 != -1){
		if ( (palflag[c2].mask^rvMask) >>tmMask == 1) return 0;
		AL_pset(bm,x,y,c1);
		AL_pset(bm,p1,p2,c2);
	}

	return 0;
}
//F
EXPORT BOOL WINAPI chg_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *m;
	m=bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1;
	*m=*(chgtable+*m);
	AL_lpset(p1,p2,*m);

	return 0;
}

//g
BOOL WINAPI ALP_EXpset(BMSCR *bm, int p1, int p2, int palNo, int p3)
{
	BYTE *m;
	BYTE ps=0,pe=255;
	int R,G,B;
	UINT rgbe;
	UINT *cpRGB;

	cpRGB =(UINT *)bm->pal;

	m= bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1;

	alrstat.palNo=palNo;
	alrstat.bgpalNo=*m;
	alrstat.pRGB=cpRGB[palNo];
	alrstat.mRGB=cpRGB[*m];
	rgbe=(ALRpset[p3-16])(bm,p1,p2,&alrstat);

	if (charbox.flag&2){ ps=*m&0xF0; pe=ps+15; }

	if (rgbe&0x2000000){
		int *f=penMASK+(( bm->sx +31 &0xFFE0 )*p2+p1>>5);
		*f = (*f|(1<<(p1&31)))^(1<<(p1&31));
	}		

	if (rgbe&0x1000000)
		*m=rgbe&255;
	else
		*m=pal_app2(bm,rgbe&255,rgbe>>8&255,rgbe>>16&255,ps,pe,1);

	AL_lpset(p1,p2,*m);
	return 0;
}

////////////////////////
/*
	p1 X
	p2 Y
	p3 y
*/
BOOL Expset (BMSCR *bm, int p1, int p2, int p3)
{
	int a;
	BYTE *m;

	m=bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1;

	if ( (palflag[*m].mask^rvMask) >>tmMask == 1) return 1;

	if (mesh_if(p1,p2)==0){
		a=palA;
	}else{
		if (Btrans==1) return 0;
		a=palB;
	}
	if (charbox.x>0){
		int x,y;
		if (charbox.flag&1)
		{
			x=(p1+charBm->cx-*lupe_x)/charbox.x*charbox.x;
			y=(p2+charBm->cy-*lupe_y)/charbox.y*charbox.y;
			x=*(charBm->pBit +((charBm->sy -1-y)*(charBm->sx +3 & 0xFFFC) )+x);
		}else{
			x=p1/charbox.x*charbox.x;
			y=p2/charbox.y*charbox.y;
			x=*(bm->pBit +((bm->sy -1-y)*(bm->sx +3 & 0xFFFC) )+x);
		}
		a=(x&0xF0)+(a&15);
	}

	if (sprayerStat!=0){
		if (sprayerStat< rand()) return 0;
	}

	switch (p3){
		case N_NOM_PSET:	//ʏ
			AL_pset(bm,p1,p2,a);
			break;
			
		case N_R_PSET:		//
			tr_pset(bm,p1,p2,a);
			break;
			
		case N_ADD_PSET:	//Z
			add_pset(bm,p1,p2,a);
			break;
			
		case N_DEC_PSET:	//Z
			dec_pset(bm,p1,p2,a);
			break;

		case N_MUL_PSET:	//Z
			mul_pset(bm,p1,p2,a);
			break;
			
		case N_GR_PSET:		//ڂ
			gr_pset(bm,p1,p2,mSTAT);
			break;
			
		case N_LIGHT_PSET:	//邭
			light_pset(bm,p1,p2,LD_stat);
			break;
			
		case N_DARK_PSET:	//Â
			dark_pset(bm,p1,p2,LD_stat);
			break;
			
		case N_SHIFTp_PSET:	//Vtg
			sp_pset(bm,p1,p2,mSTAT);
			break;

		case N_SHIFTm_PSET:	//Vtg
			sm_pset(bm,p1,p2,mSTAT);
			break;

		case N_MIX_PSET:	//~LT[
			mx_pset(bm,p1,p2,0);
			break;
			
		case N_CHG_PSET:	//F
			chg_pset(bm,p1,p2,0);
			break;

		case N_PREVIEW_PSET:	//vr[
			AL_lpset(p1,p2,a);
			break;

		default:
			ALP_EXpset(bm,p1,p2,a,p3);
			break;
	}

	return 0;
}

//p1,p2	_AL_pos̑Έʒu
//p3	
EXPORT BOOL WINAPI AL_wpset (BMSCR *bm, int p1, int p2, int p3)
{
	int w,x,y;
	int *f;
	int mx,my;	//Jnʒu
	int sx,endX,endY;
	int drawFlagOff=0;

	if (lupe_on==1) lupe_hdc=GetDC( lupe_bm->hwnd );	//AL_lboxfŎgp
	if (p3>=0x1000){ drawFlagOff=1; p3=p3&0xFF; }

	alrstat.ox=p1+areaX1;
	alrstat.oy=p2+areaY1;

	mx=p1-(penWid >>1)+areaX1;
	my=p2-(penWid >>1)+areaY1;
	endY=penWid+my;
	w=0;
	for (y=my; y<endY ;y++)
	{
		sx=(penWid-pw_data[penWid][w]>>1)+mx;
		endX=mx+penWid-sx+mx;
		for(x=sx; x<endX; x++)
		{
			//͈͔
			if (x>=areaX1 && y>=areaY1 && x<=areaX2 && y<=areaY2)
			{
				//`ς݃tO
				f=penMASK+(( bm->sx +31 &0xFFE0 )*y+x>>5);
				if( (*f & ( 1<<(x&31))) ==0 || drawFlagOff ==1){
					*f |= 1<<(x&31);
					Expset(bm,x,y,p3);
		}}}
		w++;
	}

	if (lupe_on==1) ReleaseDC( lupe_bm->hwnd,lupe_hdc );
	lupe_hdc=NULL;

	return 0;
}
EXPORT BOOL WINAPI preview_pset (BMSCR *bm, int p1, int p2, int p3)
{
	int w,x,y;
	int *f;
	int mx,my;	//Jnʒu
	int sx,endX,endY;
	
	lupe_hdc=GetDC( lupe_bm->hwnd );
	
	mx=p1-(p3 >>1)+areaX1;
	my=p2-(p3 >>1)+areaY1;
	endY=p3+my;
	w=0;
	for (y=my; y<endY ;y++)
	{
		sx=(p3-pw_data[p3][w]>>1)+mx;
		endX=mx+p3-sx+mx;
		for(x=sx; x<endX; x++)
		{
			if (x>=areaX1 && y>=areaY1 && x<=areaX2 && y<=areaY2)
			{
				Expset(bm,x,y,N_PREVIEW_PSET);
		}}
		w++;
	}
	ReleaseDC( lupe_bm->hwnd,lupe_hdc );
	lupe_hdc=NULL;

	return 0;
}

//posp1,p2֐(ׂAL_pos̑ΈʒuŎw)
EXPORT BOOL WINAPI AL_line (BMSCR *bm, int p1, int p2, int p3)
{
	int wx,wy;	//
	int wx2,wy2,i;
	int dx,dy;	//

	wx=p1-bm->cx;
	wy=p2-bm->cy;
	if (wx<0){ dx=-1; wx=-wx; }else{ dx=1; }
	if (wy<0){ dy=-1; wy=-wy; }else{ dy=1; }
	wx++; wy++;
	wx2=wx/2;
	wy2=wy/2;

	if (wx>wy){
		for (i=0; i<wx ;i++)
			AL_wpset(bm,
				i*dx              +bm->cx,
				(i*wy +wy2)/wx*dy +bm->cy,
				p3);
	}else{
		for (i=0; i<wy ;i++)
			AL_wpset(bm,
				(i*wx +wx2)/wy*dx +bm->cx,
				i*dy              +bm->cy,
				p3);
	}

	return 0;
}


//////////////////////////////



int h2color_R=0;
int h2color_G=0;
int h2color_B=0;
EXPORT BOOL WINAPI AL_color (int p1, int p2, int p3, int p4)
{
	h2color_R=p1;
	h2color_G=p2;
	h2color_B=p3;

	return 0;
}

EXPORT BOOL WINAPI AL_cpset (BMSCR *bm, int p1, int p2, int p3)
{
	*(bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1)=
	pal_app2(bm,h2color_R,h2color_G,h2color_B,0,255,1);
	
	return 0;
}


EXPORT BOOL WINAPI AL_box (BMSCR *bm, int p1, int p2, int p3)
{
	int cx,cy,wx,wy,x,y,endX,endY,i;

	cx=min(bm->cx,p1);
	cy=min(bm->cy,p2);
	wx=max(bm->cx,p1) -cx;
	wy=max(bm->cy,p2) -cy;

	endX=cx+wx;
	endY=cy+wy;

	i=lupe_on;
	lupe_on=0;
	for(x=cx; x<= endX; x++)
	{
		AL_wpset(bm,x,cy,p3);
		AL_wpset(bm,x,endY,p3);
	}
	for(y=cy+1; y< endY; y++)
	{
		AL_wpset(bm,cx,y,p3);
		AL_wpset(bm,endX,y,p3);
	}
	lupe_on=i;

	return 0;
}

//	pos AL_pos̑Έʒu
//	p1Cp2	I_
//	p3	
EXPORT BOOL WINAPI AL_boxf (BMSCR *bm, int p1, int p2, int p3)
{
	int cx,cy,wx,wy,x,y,endX,endY;

	cx=min(bm->cx,p1);
	cy=min(bm->cy,p2);
	wx=max(bm->cx,p1) -cx+1;
	wy=max(bm->cy,p2) -cy+1;
	cx+=areaX1;
	cy+=areaY1;

	if (cx<0){ wx+=cx; cx=0;}
	if (cy<0){ wy+=cy; cy=0;}
	if (wx+cx >bm->sx){wx =bm->sx-cx;}
	if (wy+cy >bm->sy){wy =bm->sy-cy;}
	alrstat.cx=cx;
	alrstat.cy=cy;

	endX=cx+wx;
	endY=cy+wy;

	for (y=cy; y<endY; y++){
		for (x=cx; x<endX; x++) Expset(bm,x,y,p3);
	}

	return 0;
}

EXPORT BOOL WINAPI AL_circle (BMSCR *bm, int p1, int p2, int p3)
{
	int x,y,p,mx,my,px,py,i,cx,cy;
	int xr,yr;	//a
	int xt,yt;	//a
	double xr2,yr2;
	double pr;

	xt=abs(p1-bm->cx)+2-penWid;
	yt=abs(p2-bm->cy)+2-penWid;

	if (p1>bm->cx) cx=bm->cx; else cx=p1;
	if (p2>bm->cy) cy=bm->cy; else cy=p2;

	xr=(xt+1)>>1;
	yr=(yt+1)>>1;
	xr2=xr*xr;
	yr2=yr*yr;

	mx=penWid/2+cx;
	my=penWid/2+cy;

	i=lupe_on; lupe_on=0;
	for(x=0; x<xr; x++)
	{
		p=xr-x;
		pr=(xr2-p*p)/xr2*yr2;
		p=sqrt(pr)-0.5;

		px=x+mx;		py=yr-p-1+my;	AL_wpset(bm,px,py,p3);
		px=xt-1-x+mx;					AL_wpset(bm,px,py,p3);
		px=x+mx;		py=yt-yr+p+my;	AL_wpset(bm,px,py,p3);
		px=xt-1-x+mx;					AL_wpset(bm,px,py,p3);
	}
	for(y=0; y<yr; y++)
	{
		p=yr-y;
		pr=(yr2-p*p)/yr2*xr2;
		p=sqrt(pr)-0.5;

		py=y+my;	px=xr-p-1+mx;	AL_wpset(bm,px,py,p3);
		py=yt-1-y+my;			AL_wpset(bm,px,py,p3);
		py=y+my;	px=xt-xr+p+mx;	AL_wpset(bm,px,py,p3);
		py=yt-1-y+my;			AL_wpset(bm,px,py,p3);
	}
	lupe_on=i;
	
	return 0;
}

EXPORT BOOL WINAPI AL_circlef (BMSCR *bm, int p1, int p2, int p3)
{
	int i,il;
	i=penWid; penWid=1;
	il=lupe_on; lupe_on=0;
	AL_circle(bm,p1,p2,p3);		//Ɏv΂d

	int y,p,px,py,x1,x2,cx,cy;
	int xr,yr;	//a
	int xt,yt;	//a
	double xr2,yr2;
	double pr;


	xt=abs(p1-bm->cx)+1;
	yt=abs(p2-bm->cy)+1;

	if (p1>bm->cx) cx=bm->cx; else cx=p1;
	if (p2>bm->cy) cy=bm->cy; else cy=p2;

	xr=(xt+1)>>1;
	yr=(yt+1)>>1;
	xr2=xr*xr;
	yr2=yr*yr;

	for(y=0; y<yr; y++)
	{
		p=yr-y;
		pr=(yr2-p*p)/yr2*xr2;
		p=sqrt(pr)*1024;
		p=(p-512)>>10;

		x1=xr-p-1+cx;
		x2=xt-xr+p+cx;
		
		for(px=x1; px<=x2; px++)
		{
			py=y+cy;	AL_wpset(bm,px,py,p3);
			py=yt-1-y+cy;	AL_wpset(bm,px,py,p3);
		}
	}
	penWid=i;
	lupe_on=il;
	
	return 0;
}


//p1,p2 AL_pos̑Έʒu
EXPORT BOOL WINAPI AL_Hpaint (BMSCR *bm, int p1, int p2, char p3)
{
	int x;
	BYTE mc;
	BYTE *w;

	w=bm->pBit+(bm->sy -1-p2-areaY1)*areaBFW+areaX1;
	if (p1> areaW || p2> areaH) return -1;
	mc=*(w+p1);
	if ( (palflag[mc].mask^rvMask) >>tmMask == 1) return -1;

	if (lupe_on==1) lupe_hdc=GetDC( lupe_bm->hwnd );

	Expset(bm,p1+areaX1,p2+areaY1,p3);
	for(x=p1-1; x>=0; x--)
	{
		if ( *(w+x) == mc)
			Expset(bm,x+areaX1,p2+areaY1,p3);
		else
			break;
	}
	for(x=p1+1; x<areaW; x++)
	{
		if ( *(w+x) == mc)
			Expset(bm,x+areaX1,p2+areaY1,p3);
		else
			break;
	}
	ReleaseDC( lupe_bm->hwnd,lupe_hdc );
	lupe_hdc=NULL;


	return 0;
}
EXPORT BOOL WINAPI AL_Vpaint (BMSCR *bm, int p1, int p2, char p3)
{
	int y;
	BYTE mc;
	BYTE *w;

	w=bm->pBit+(bm->sy -1-areaY1)*areaBFW+areaX1+p1;
	if (p1> areaW || p2> areaH) return -1;
	mc=*(w-p2*areaBFW);
	if ( (palflag[mc].mask^rvMask) >>tmMask == 1) return -1;
	if (lupe_on==1) lupe_hdc=GetDC( lupe_bm->hwnd );

	Expset(bm,p1+areaX1,p2+areaY1,p3);
	for(y=p2-1; y>=0; y--)
	{
		if ( *(w-y*areaBFW) == mc)
			Expset(bm,p1+areaX1,y+areaY1,p3);
		else
			break;
	}
	for(y=p2+1; y<areaH; y++)
	{
		if ( *(w-y*areaBFW) == mc)
			Expset(bm,p1+areaX1,y+areaY1,p3);
		else
			break;
	}
	ReleaseDC( lupe_bm->hwnd,lupe_hdc );
	lupe_hdc=NULL;

	return 0;
}

//p1,p2 AL_pos̑Έʒu
EXPORT BOOL WINAPI AL_paint (BMSCR *bm, int p1, int p2, int p3)
{
	unsigned int x,y,i,p,ret,cnt,p_cnt=0,p_mcnt=0;
	BYTE mc;		//n_̐F
	int *p_flag,*p_mflag;
	BYTE *pBF;
	int sx[]={ 0, 0,-1, 2};
	int sy[]={-1, 2,-1, 0};

	if (p1> areaW || p2> areaH) return -1;
	mc=*(bm->pBit +( (bm->sy -1-p2-areaY1)*areaBFW )+p1+areaX1);
	if ( (palflag[mc].mask^rvMask) >>tmMask == 1) return -1;
	

	//̈Ҕ
	pBF=(BYTE *)malloc(areaW*areaH);	if ( pBF==0 ) return -2;
	for (y=0 ;y<areaH ;y++)
	{
		CopyMemory(
			pBF+(y*areaW),
			bm->pBit+ (bm->sy -1-areaY1-y)*areaBFW+areaX1,
			areaW
		);
	}

	//yCgptOm
		if (bm->sx < bm->sy) x=bm->sx; else x=bm->sy;
		p_flag =(int *)calloc(x*4, 4);		if ( p_flag ==0 ) return -2;
		p_mflag=(int *)calloc(areaW*areaH, 4);	if ( p_mflag==0 ) return -2;

	
	x=p1;
	y=p2;

	*p_mflag=(x<<16)+y;
	p_mcnt=1;
	*(pBF+(y*areaW)+x)=mc^255;
	*p_flag=(x<<16)+y;
	p_cnt=2;
	ret=1;
	
	while(p_cnt>0){
		ret^=1;
		cnt=p_cnt; p_cnt=0;
	
	for(p=ret ;p<cnt+ret ;p+=2)
	{
		x =*( p_flag+p )>>16;
		y =*( p_flag+p )& 0xFFFF ;
		for(i=0 ;i<4 ;i++)
		{
			x+=sx[i];
			y+=sy[i];

			if (x>=0 && y>=0 && x<areaW && y<areaH)
			{
			if ( *(pBF+(y*areaW)+x) == mc){
				*(pBF+(y*areaW)+x)=mc^255;
				*(p_mflag+p_mcnt)=(x<<16)+y;
				p_mcnt++;

				*( p_flag+p_cnt+(ret^1) )=(x<<16)+y;
				p_cnt+=2;
			}}
		}
	}
	}

	for (i=0 ;i<p_mcnt ;i++)
	{
		x=(*(p_mflag+i)>>16	)+areaX1;
		y=(*(p_mflag+i)& 0xFFFF	)+areaY1;
		Expset(bm,x,y,p3);
	}

	free(p_flag);
	free(p_mflag);
	free(pBF);
	
	return 0;
}



///////////////////////////////////////////////////////

/*
	1/2⊮k
	gmodeŃTCY
	p1,p2	Rs[X,Y
	p3 0
	   1 ̂
	   2 ĉ
*/
EXPORT BOOL WINAPI scc2 (BMSCR *bm, int p1, int p2, int p3)
{
	int mx,my ,i,c ,x,y;
	int R,G,B;
	int im,is,xt,yt,st;
	BYTE ps=0,pe=255;
	RGBQUAD *mpRGB;

	switch (p3){
		case 1:
			mx=bm->gx>>1;
			my=bm->gy;
			im=2; is=1; xt=2; yt=1; st=1;
		break;
		case 2:
			mx=bm->gx;
			my=bm->gy>>1;
			im=4; is=2; xt=1; yt=2; st=1;
		break;
		default:
			mx=bm->gx>>1;
			my=bm->gy>>1;
			im=4; is=1; xt=2; yt=2; st=2;
		break;
	}
	mpRGB =bm->pal;


	for(y=0; y<my; y++)
	{
		for(x=0; x<mx; x++)
		{
			R=0; G=0; B=0;

			for(i=0; i<im; i+=is)
			{
				c=*(bm->pBit +(bm->sy -1-y*yt -p2 -(i>>1))*(bm->sx +3 & 0xFFFC) +x*xt +p1 +(i&1));

				R +=mpRGB[c].rgbRed;
				G +=mpRGB[c].rgbGreen;
				B +=mpRGB[c].rgbBlue;
			}
			
		*(bm->pBit +(bm->sy -1-y-p2)*(bm->sx +3 & 0xFFFC) +x +p1)=pal_app2(bm,R>>st,G>>st,B>>st,ps,pe,1);
		}
	}



	return 0;
}

//]
//p1,p2	Rs[X,Y
EXPORT BOOL WINAPI AL_rot (BMSCR *bm, int p1, int p2, int p3)
{
	int sx,sy;	//Jnʒu
	int hx,hy;	//
	int cx,cy;
	int gx,gy;
	int x,y;	//݈ʒu
	int px,py;	//Qƈʒu(65536{)
	int wx,wy;	//Qƈʒu
	int i;
	
	gx = bm->gx-1;
	gy = bm->gy-1;
//	sx =( gx<<16 )-gx*cos360[p3%90]-gy*sin360[p3%90] >>1;
//	sy =( gy<<16 )+gx*sin360[p3%90]-gy*cos360[p3%90] >>1;
	sx =( gx<<15 )-gx*cos360[p3]/2-gy*sin360[p3]/2;
	sy =( gy<<15 )+gx*sin360[p3]/2-gy*cos360[p3]/2;

/*
	if (p3/90==1){
		i=sx;
		sx=sy;
		sy=-i+(bm->gy<<16);
	}
	if (p3/90==2){
		sx=-sx+(bm->gx<<16);
		sy=(bm->gy-1<<16)-sy;
	}
	if (p3/90==3){
		i=sx;
		sx=(bm->gx-1<<16)-sy;
		sy=i-65536;
	}
*/
	hx = cos360[p3];
	hy = sin360[p3];
	cx = bm->sx +3 & 0xFFFC;
	cy = bm->sy -1-bm->cy;
	gx = bm->gx; if (gx+bm->cx > bm->sx) gx=bm->sx-bm->cx;
	gy = bm->gy; if (gy+bm->cy > bm->sy) gy=bm->sy-bm->cy;

	for(y=0; y< gy; y++)
	{
		px=hy*y+sx;
		py=hx*y+sy;
		for(x=0; x< gx; x++)
		{
			wx=px+32768>>16; px+=hx;
			wy=py+32768>>16; py-=hy;

//݂͂Vtg
//wx=wx%bm->gx; if(wx<0) wx+=bm->gx;
//wy=wy%bm->gy; if(wy<0) wy+=bm->gy;

			if (wx >= 0 && wy >= 0 && wx < bm->gx && wy < bm->gy)
				*(bm->pBit +(cy-y)*cx+x+bm->cx)=
				*(mpBMP + (mH -1 -p2 -wy)*mBFW +p1 +wx);
			else if (bm->gmode==0)	//͂ݏo0ɂ
				*(bm->pBit +(cy-y)*cx+x+bm->cx)=0;
		}
	}

	return 0;
}

/*
val.0	g
val.1	
val.2	Vtg
*/
int val[8];
EXPORT BOOL WINAPI AL_waveset (int *p1, int p2, int p3, int p4)
{
	int i;
	for(i=0; i<3; i++) val[i]=p1[i];
	return 0;
}
/*
AL_setŃRs[̉
posňʒu
gmodeŃTCY
*/

EXPORT BOOL WINAPI AL_wave (BMSCR *bm, int mCX, int mCY, int p4)
{
	int x,y,r,y2,i,p,ix,iy,py;
	int shift;
	int rx,ry,w2,h2;
	int cx,cy,p1,p2,p3;
	p1=val[0];
	p2=val[1];
	p3=val[2];

	cx = bm->sx +3 & 0xFFFC;
	cy = bm->sy -1-bm->cy;

	shift=-p3;
	w2=(bm->gx+1)/2;
	h2=(bm->gy+1)/2;
	
	for(y=0; y< h2; y++)
	{
		iy=h2-y;
		if (w2>h2) iy=iy*w2/h2;
		y2=iy*iy;
		for(x=0; x< w2; x++)
		{
			ix=w2-x;
			if (w2<h2) ix=ix*h2/w2;
		
			i = (shift + sqrt(ix*ix+y2))*512 /p1;
			r = sin512[i&511]*p2 >>16;

			p = atan2(ix,iy)*256/PI;
			p = p&511;

			rx= (r*sin512[p] >>16) +x;
			ry= (r*cos512[p] >>16) +y;
			py= y;
			
			for(i=0; i<4; i++)
			{
				if (rx<0 || ry<0 || rx>=bm->gx || ry>=bm->gy)
					*(bm->pBit +(cy-py)*cx +x +bm->cx)=0;
				else
					*(bm->pBit +(cy-py)*cx +x +bm->cx)=
					*(mpBMP + (mH -1 -mCY -ry)*mBFW +mCX +rx);

				x=bm->gx-1-x;
				rx=bm->gx-1-rx;
				if (i==1){ py=bm->gy-1-py; ry=bm->gy-1-ry; }
			}
		}
	}

	return 0;
}

EXPORT BOOL WINAPI charboxset(BMSCR *bm, int p1, int p2, int p3)
{
	charbox.x=p1;
	charbox.y=p2;
	charbox.flag=charbox.flag&2 | p3&1;

	charBm=bm;

	return 0;
}
EXPORT BOOL WINAPI charboxset_app(int p1, int p2, int p3, int p4)
{
	charbox.flag=charbox.flag&1 | ((p1&1)<<2);
	return 0;
}

//;gmodeŃGATCY
EXPORT BOOL WINAPI chk_charbox(BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *c;
	int w,h,x,y,ex,ey,bf,sx;
	int p;
	w=bm->sx;
	h=bm->sy;
	x=p1/bm->gx*bm->gx;
	y=p2/bm->gy*bm->gy;
	sx=x;
	ex=x+bm->gx;
	ey=y+bm->gy;
	bf=w +3 & 0xFFFC;

	if (ex>w) ex=w;
	if (ey>h) ey=h;

	p=*( bm->pBit +((h -1-y)*bf )+x ) >>4;
	while(y<ey){
		x=sx;
		c=(bm->pBit +(h -1-y)*bf)+sx;
		while(x<ex){
			if ((*c>>4)!=p){ p=16; break; }
			c++;
			x++;
		}
		if (p==16) break;
		y++;
	}

	return -p;
}

//p1	X
//p2	Y
//p3	pbg
EXPORT BOOL WINAPI RedrawCharbox(BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *c;
	int w,h,x,y,ex,ey,bf,sx;
	w=bm->sx;
	h=bm->sy;
	x=p1/charbox.x*charbox.x;
	y=p2/charbox.y*charbox.y;
	sx=x;
	ex=x+charbox.x;
	ey=y+charbox.y;
	bf=w +3 & 0xFFFC;

	if (ex>w) ex=w;
	if (ey>h) ey=h;

	//`̕KvȂ
	if( p3==(*(bm->pBit +((h -1-y)*bf )+x)>>4) ) return -1;

	while(y<ey){
		x=sx;
		c=(bm->pBit +(h -1-y)*bf)+sx;
		while(x<ex){
			*c=(*c&15)+(p3<<4);
			c++;
			x++;
		}
		y++;
	}

	return 0;
}

//posňʒu
//p1TCY
//p2
//pbg
EXPORT BOOL WINAPI RedrawCharbox2(BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *c;
	int w,h,x,y,ex,ey,bf;
	w=bm->sx;
	h=bm->sy;
	x=bm->cx;
	y=bm->cy;
	ex=x+p1;
	ey=y+p2;
	bf=w +3 & 0xFFFC;

	if (ex>w) ex=w;
	if (ey>h) ey=h;

	while(y<ey){
		x=bm->cx;
		c=(bm->pBit +(h -1-y)*bf)+x;
		while(x<ex){
			*c=(*c&15)+(p3<<4);
			c++;
			x++;
		}
		y++;
	}

	return 0;
}




///////////////////////////////////////////////////////

static WORD mes_fr[4]={0,0,0,0};
static short mes_va[4]={1,0,0,1};
static AL_TEXTSTAT al_textstat;

EXPORT BOOL WINAPI AL_mesmat(int p1, int p2, int p3, int p4)
{
	mes_va[0]=p1>>16;
	mes_va[1]=p2>>16;
	mes_va[2]=p3>>16;
	mes_va[3]=p4>>16;
	mes_fr[0]=p1&0xFFFF;
	mes_fr[1]=p2&0xFFFF;
	mes_fr[2]=p3&0xFFFF;
	mes_fr[3]=p4&0xFFFF;
	return 0;
}

EXPORT BOOL WINAPI AL_mesbold(int p1, int p2, int p3, int p4)
{
	al_textstat.bold=p1;
	return 0;
}
EXPORT BOOL WINAPI AL_mesline(int p1, int p2, int p3, int p4)
{
	al_textstat.x=p1;
	al_textstat.y=p2;
	return 0;
}

EXPORT BOOL WINAPI AL_mes (BMSCR *bm, unsigned char *mes, int p1, int p2)
{
	TEXTMETRIC tm;
	GLYPHMETRICS gm;
	MAT2 mat2;
	unsigned int i,code;
	int quality,qs;
	int lencnt;	//̃oCg
	int gfX,gfY,fY,x,y,w,h,sx,sy;
	int bfsize,bfw,bm_bfw;
	int a,b;
	int cx,cy;
	BYTE *pHBit,*pBF,*pGBit;
	int sSTAT,tSTAT,NV;
	int textH;
	HDC hdc=bm->hdc;

	ZeroMemory(&tm	,sizeof(TEXTMETRIC));
	ZeroMemory(&gm	,sizeof(GLYPHMETRICS));
	ZeroMemory(&mat2,sizeof(MAT2));

	LD_stat=1;

	mat2.eM11.value=mes_va[0];
	mat2.eM12.value=mes_va[1];
	mat2.eM21.value=mes_va[2];
	mat2.eM22.value=mes_va[3];

	mat2.eM11.fract=mes_fr[0];
	mat2.eM12.fract=mes_fr[1];
	mat2.eM21.fract=mes_fr[2];
	mat2.eM22.fract=mes_fr[3];

	if (*Vheight==1){
		a=(mes_va[3]<<16) + mes_fr[3] >>1;
		mat2.eM22.value=a >>16;
		mat2.eM22.fract=a &0xFFFF;
	}

	sSTAT=mSTAT;
	tSTAT=mSTAT;
	NV=p2;
	if (p2==N_NOM_PSET){ NV=N_R_PSET; tSTAT=256; }

	cx=bm->cx+areaX1;
	cy=bm->cy+areaY1;

	bm_bfw=bm->sx +3 & 0xFFFC;
	if (p1<=0) { quality=GGO_BITMAP; }
	if (p1==1) { quality=GGO_GRAY2_BITMAP; qs=6; }
	if (p1==2) { quality=GGO_GRAY4_BITMAP; qs=4; }
	if (p1>=3) { quality=GGO_GRAY8_BITMAP; qs=2; }

	GetTextMetrics(hdc,&tm);
	fY    =tm.tmDescent*((mat2.eM22.value<<16)+mat2.eM22.fract)+0xFFFF >>16;
	textH =bm->texty   *((mat2.eM22.value<<16)+mat2.eM22.fract)+0xFFFF >>16;
	textH+=al_textstat.y;

	//
	if (tm.tmWeight>=700 && al_textstat.bold) b=1; else b=0;
	
	gfX=cx;
	gfY=cy;
	lencnt=0;
	while(1)
	{
		i=mes[lencnt];
		if (i==0) break;
		code=i;
		lencnt++;
		if (( i>=129 && i<=159 )||( i>=224 && i<=252)){
		//Sp
			code = i<<8;
			code+= mes[lencnt];
			lencnt++;
		}else if (i==13){
		//s
			if (mes[lencnt]!=10) lencnt--;
			lencnt++;
			gfX =cx;
			gfY+=textH;
			//gfY+=gm.gmCellIncY;
			continue;
		}
		//obt@TCY𓾂ĂBITMAP𓾂
		bfsize=GetGlyphOutline(hdc,code,quality,&gm,0,0,&mat2);
		//Xy[X̓TCY0
		if (bfsize<=0){ gfX+=gm.gmCellIncX+al_textstat.x; continue; }

		pBF=(BYTE *)malloc(bfsize);
		GetGlyphOutline(hdc,code,quality,&gm,bfsize,pBF,&mat2);
		pGBit=pBF;
		
		w=gm.gmBlackBoxX;						//1̕
		h=gm.gmBlackBoxY;						//
		sx=gfX+gm.gmptGlyphOrigin.x;			//Jnʒu
		sy=gfY+(textH-gm.gmptGlyphOrigin.y)-fY;
		//--------------------------------------------------------------------
		if (p1==0)
		{			//X[WO
			bfw=(w+31 & 0xFFE0)/8;
			int psx=0,psy=0,pex=w,pey=h;

			if( sx < areaX1 )
			{
				psx=areaX1-sx;
				sx=areaX1-psx;
			}
			if( sy < areaY1 )
			{
				psy=areaY1-sy;
				sy=areaY1-psy;
				pGBit=pGBit+psy*bfw;
			}
			int ex=sx+w,ey=sy+h;

			if( ex > areaX2 ) pex-=ex-areaX2-1;
			if( ey > areaY2 ) pey-=ey-areaY2-1;

		//	if ( w<=0 || h<=0 ) continue;

			for (y=psy; y<pey; y++)
			{
				for(x=psx; x<pex; x++){
					a=*(pGBit+(x>>3))&(128>>(x&7));
					if ( a>0 || i==1 ){
						Expset(bm,x+sx,y+sy,p2);

						if(b==1){
							// obt@݂͂̕`
							//ŏdȂȂ悤
							if (a>0 && x+1==pex && x+sx+1<=areaX2) Expset(bm,x+sx+1,y+sy,p2);
							i=1;
						}
					}
					if ( a==0 ) i=0;
				}
				i=0;
				pGBit+=bfw;
		}

		}else{	//------

		bfw=(w+3 & 0xFFFC)-w&3;

		if(sx<areaX1){ a=areaX1-sx; w-=a; pGBit+=a; bfw+=a; sx=areaX1; }
		if(sy<areaY1){ a=areaY1-sy; h-=a; pGBit+=a*(gm.gmBlackBoxX+3 & 0xFFFC); sy=areaY1; }
		if( sx+w >areaX2 ){
			w=areaX2-sx+1;
			bfw+=gm.gmBlackBoxX-w;
		}
		if( sy+h >areaY2) h=areaY2-sy+1;

	//	if ( w<=0 || h<=0 ) continue;

		w+=sx;
		h+=sy;

		int c;
		for (y=sy; y<h; y++)
		{
			i=0;
			for(x=sx; x<w; x++){
				a=*pGBit<<qs;

				if(i>a) c=i; else c=a;
				pGBit++;
				if (c==  0) continue;
				_bo:
				if (c>=256){
					mSTAT=tSTAT;
					Expset(bm,x,y,p2);
				}else{
					mSTAT=c*tSTAT>>8;
					Expset(bm,x,y,NV);
				}
				if (b==1){
					i=a;
					if (x+1==w && x+1<=areaX2){ c=a; x++; goto _bo;}
				}
			}
			pGBit+=bfw;
		}
		}
		//--------------------------------------------------------------------

		free(pBF);
		gfX+=gm.gmCellIncX+al_textstat.x+b;
		gfY+=gm.gmCellIncY;

	}//while
	mSTAT=sSTAT;
	LD_stat=0;

	return 0;
}



EXPORT BOOL WINAPI AL_sin (int *p1, int p2, int p3, int p4)
{
	if (p3==0) p3=256;
	if (p3==1) p3=360;
	if (p3==2) p3=1024;
	p2=p2%p3; if (p2<0) p2+=p3;

	*p1=rint(sin(p2 *PI*2/p3)*65536);

	return 0;
}
EXPORT BOOL WINAPI AL_cos (int *p1, int p2, int p3, int p4)
{
	if (p3==0) p3=256;
	if (p3==1) p3=360;
	if (p3==2) p3=1024;
	p2=p2%p3; if (p2<0) p2+=p3;

	*p1=rint(cos(p2 *PI*2/p3)*65536);
	return 0;
}

//////////////////////////////////////////////////
/*
	p1,p2	Rs[W(X,Y)
	p3	߂pbgNo
		-1œ߂Ȃ
*/
EXPORT BOOL WINAPI AL_gcopy (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *cpBMP,*mspBMP,*lmt_cpBMP;
	RGBQUAD *cpRGB;
	int cx,cy,wx,wy,sw,mc_m,mc_c,tx,ty,y,sx,sy,i;
	int R,G,B,pen;
	BYTE ps=0,pe=255;
	HRGN h=*halrgn;

	if (mSTAT==0 && (penAL==N_R_PSET || penAL==N_ADD_PSET || penAL==N_DEC_PSET || penAL==N_MUL_PSET)) return 0;

	cpRGB =bm->pal;
	cx =bm->cx+areaX1;	//Rs[
	cy =bm->cy+areaY1;
	wx =bm->gx;			//TCY
	wy =bm->gy;
	sw =bm->sx +3 & 0xFFFC;

	if (cx<areaX1)		{ wx+=bm->cx; p1-=bm->cx; cx=areaX1; }
	if (cy<areaY1)		{ wy+=bm->cy; p2-=bm->cy; cy=areaY1; }
	if (wx+cx >areaX2)	{ wx =areaX2-cx+1; }
	if (wy+cy >areaY2)	{ wy =areaY2-cy+1; }

	if (p1<0)			{ wx+=p1; cx-=p1 ;p1=0; }
	if (p2<0)			{ wy+=p2; cy-=p2 ;p2=0; }
	if (wx+p1 >mW)		{ wx =mW-p1; }
	if (wy+p2 >mH)		{ wy =mH-p2; }

	alrstat.cx=cx;
	alrstat.cy=cy;
	alrstat.selX1=p1;
	alrstat.selY1=p2;
	alrstat.selX2=p1+wx-1;
	alrstat.selY2=p2+wy-1;
	mspBMP=mpBMP +mBFW *(mH -1-p2) +p1;	//Rs[̊Jnʒu
	cpBMP=bm->pBit +sw *(bm->sy -1-cy) +cx;

	int lmt_wx=wx;
	mc_m=mBFW +wx;
	mc_c=sw   +lmt_wx;
	sx=bm->cx;
	if ( mSTAT==256 && penAL==N_R_PSET) pen=0; else pen=penAL;

	//-------------------------------
	//pbgႢ̃Rs[̃e[u
	BYTE appTB[256];
	if( pen>=APP_COPY ){
		app_reset(bm,pen-APP_COPY,0,0);
		for(y=0; y<256; y++){
			B =mpRGB[y].rgbBlue;
			G =mpRGB[y].rgbGreen;
			R =mpRGB[y].rgbRed;
			//pbgȂ炻̂܂
			if (palflag[y].not==0 && R==cpRGB[y].rgbRed && G==cpRGB[y].rgbGreen && B==cpRGB[y].rgbBlue && pen!=APP_COPY2)
			{
				appTB[y]=y;
				continue;
			}
			if (pen==APP_COPY || pen==APP_COPY2)
				appTB[y]=pal_app2(bm,R,G,B,0,255,1);
			else
				appTB[y]=hsv_app(bm,R,G,B,0,255,1);
		}
		pen=APP_COPY;
	}
	//-------------------------------

	tx=cx-p1;
	ty=cy-p2;
	for (y =0; y<wy; y++){
		lmt_cpBMP=cpBMP+lmt_wx;
		sx=cx;
		sy=y+cy;
		while(cpBMP < lmt_cpBMP){
			if (*mspBMP != p3 && (palflag[*cpBMP].mask^rvMask) >>tmMask == 0 && mesh_if(sx,sy)==0 && (h==0||PtInRegion(h,sx-tx,sy-ty)))
			{

			if (charbox.flag&2){ ps=*cpBMP&0xF0; pe=ps+15; }

			switch(pen){
			case N_R_PSET:
				B  =cpRGB[*cpBMP].rgbBlue;
				G  =cpRGB[*cpBMP].rgbGreen;
				R  =cpRGB[*cpBMP].rgbRed;
				B +=(mpRGB[*mspBMP].rgbBlue -B )*mSTAT >>8;
				G +=(mpRGB[*mspBMP].rgbGreen-G )*mSTAT >>8;
				R +=(mpRGB[*mspBMP].rgbRed  -R )*mSTAT >>8;
				*cpBMP=pal_app2(bm,R,G,B,ps,pe,1);
				break;

			case N_ADD_PSET:
				B =cpRGB[*cpBMP].rgbBlue  +(mpRGB[*mspBMP].rgbBlue  *mSTAT >>8);
				G =cpRGB[*cpBMP].rgbGreen +(mpRGB[*mspBMP].rgbGreen *mSTAT >>8);
				R =cpRGB[*cpBMP].rgbRed   +(mpRGB[*mspBMP].rgbRed   *mSTAT >>8);
				if (B>255) B=255;
				if (G>255) G=255;
				if (R>255) R=255;
				*cpBMP=pal_app2(bm,R,G,B,ps,pe,1);
				break;

			case N_DEC_PSET:
				B =cpRGB[*cpBMP].rgbBlue  -(mpRGB[*mspBMP].rgbBlue  *mSTAT >>8);
				G =cpRGB[*cpBMP].rgbGreen -(mpRGB[*mspBMP].rgbGreen *mSTAT >>8);
				R =cpRGB[*cpBMP].rgbRed   -(mpRGB[*mspBMP].rgbRed   *mSTAT >>8);
				if (B<0) B=0;
				if (G<0) G=0;
				if (R<0) R=0;
				*cpBMP=pal_app2(bm,R,G,B,ps,pe,1);
				break;

			case N_MUL_PSET:
				B =cpRGB[*cpBMP].rgbBlue  -((255-mpRGB[*mspBMP].rgbBlue  )*mSTAT >>8);
				G =cpRGB[*cpBMP].rgbGreen -((255-mpRGB[*mspBMP].rgbGreen )*mSTAT >>8);
				R =cpRGB[*cpBMP].rgbRed   -((255-mpRGB[*mspBMP].rgbRed   )*mSTAT >>8);
				if (B<0) B=0;
				if (G<0) G=0;
				if (R<0) R=0;
				*cpBMP=pal_app2(bm,R,G,B,ps,pe,1);
				break;

			case N_SHIFTp_PSET:	//Vtg
				for(i=0; i<*mspBMP+mSTAT; i++)
				{
					if (palflag[*cpBMP].limit==1) break;
					*cpBMP=*cpBMP+1&255;
				}

				break;
			case N_SHIFTm_PSET:	//Vtg
				sm_pset(bm,p1,p2,mSTAT);
				for(i=0; i<*mspBMP+mSTAT; i++)
				{
					if (palflag[*cpBMP-1 &255].limit==1) break;
					*cpBMP=*cpBMP-1&255;
				}

				break;

			case APP_COPY:
			//pbgႢ̃obt@ԃRs[
				*cpBMP=appTB[*mspBMP];
				break;
			default:
				if (penAL>=16 && (*ARN_flag&4)==4){
					ALP_EXpset(bm,sx,sy,*mspBMP,penAL);
					break;
				}

				if(charbox.flag&2)
					*cpBMP=(*mspBMP&15)+ps;
				else
					*cpBMP=*mspBMP;

				break;
			}//switch
			}
			sx++;
			cpBMP++;
			mspBMP++;
		}//while
		mspBMP -=mc_m;
		cpBMP  -=mc_c;
	}

	return 0;
}

/*
AL_setŃRs[̉
objsizeŃRs[TCY
gmode ŃRs[TCY }CiXŔ]
p1,p2 Rs[W
p3 ߃pbg -1œ߂Ȃ
p4 1 bVL
   2 p5,p6ŃbV
*/

//EXPORT BOOL WINAPI AL_gzoom (BMSCR *bm, int p1, int p2, int p3)
EXPORT BOOL WINAPI AL_gzoom (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{

	int px,py,fx,fy,ex,ey,bf,x,y;
	int cx,cy,gx,gy,ox,oy;
	int _ox,_oy;
	int offx;
	BYTE *m,*cpBMP,*mm,*cm;

	//-----------------------------------------------------
	BMSCR *bm;
	int p1,p2,p3,p4,p5,p6;
	bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
	p1=hei->HspFunc_prm_getdi(0);
	p2=hei->HspFunc_prm_getdi(0);
	p3=hei->HspFunc_prm_getdi(0);
	p4=hei->HspFunc_prm_getdi(0);
	if (p4==2)
	{
		p5=hei->HspFunc_prm_getdi(0);
		p6=hei->HspFunc_prm_getdi(0);
	}
	if (*hei->er) return *hei->er;

	//-----------------------------------------------------

	cx=bm->cx;
	cy=bm->cy;
	gx=bm->gx;
	gy=bm->gy;
	ox=bm->ox; _ox=ox;
	oy=bm->oy; _oy=oy;

	if (gx==0 || gy==0 || ox<=0 || oy<=0) return 0;
	if (cx+abs(gx)<=0 || cy+abs(gy)<=0 || cx>=bm->sx || cy>=bm->sy) return 0;
	if (p1>=mW || p2>=mH) return 0;

	fx=(ox<<16)/gx;			//
	fy=(oy<<16)/gy;

	//Rs[͂ݏoC
	if (p1<0){ if(gx>0){cx-=p1*gx/_ox;} ox+=p1; p1=0; }
	if (p2<0){ if(gy>0){cy-=p2*gy/_oy;} oy+=p2; p2=0; }
	if (p1+ox>mW){ if(gx<0){cx+=(p1+ox-mW)*-gx/_ox;} ox=mW-p1; }
	if (p2+oy>mH){ if(gy<0){cy+=(p1+oy-mW)*-gy/_oy;} oy=mH-p2; }

	offx=(p1<<16);				//Rs[Jnʒu
	py=(p2<<16);		
	if (gx<0) offx=p1+ox<<16;
	if (gy<0) py=p2+oy<<16;
	offx+=(fx>>1);				//(fy>>1)Ȃ6{̂Ƃɂ
	py+=(fy>>1);

//	ex=abs(gx)+cx;
//	ey=abs(gy)+cy;
	ex=ox*abs(gx)/_ox+cx;
	ey=oy*abs(gy)/_oy+cy;

	//Rs[͂ݏoC
	if (cx<0){ offx+=-cx*fx; cx=0; }
	if (cy<0){ py+=-cy*fy; cy=0; }
	if (ex>bm->sx) ex=bm->sx;
	if (ey>bm->sy) ey=bm->sy;


	bf=bm->sx+3&0xFFFC;

	switch(p4){
		case 0:
			for(y=cy; y<ey; y++)
			{
				px=offx;
				mm=mpBMP+mBFW*(mH-1-(py>>16));
				cm=bm->pBit+bf*(bm->sy-1-y);
				for(x=cx; x<ex; x++)
				{
					cpBMP= cm+x;
					m= mm+(px>>16);
					px+=fx;
					if (*m==p3) continue;
					*cpBMP=*m;
				}
				py+=fy;
			}
		break;
		case 1:
			for(y=cy; y<ey; y++)
			{
				px=offx;
				mm=mpBMP+mBFW*(mH-1-(py>>16));
				cm=bm->pBit+bf*(bm->sy-1-y);
				for(x=cx; x<ex; x++)
				{
					cpBMP= cm+x;
					m= mm+(px>>16);
					px+=fx;

					if (*m==p3){
						if (mesh_tmpif(x,y,1)==0) continue;
					}else{
						if (mesh_tmpif(x,y,0)!=0) continue;
					}
					*cpBMP=*m;
				}
				py+=fy;
			}
		break;
		case 2:
			for(y=cy; y<ey; y++)
			{
				px=offx;
				mm=mpBMP+mBFW*(mH-1-(py>>16));
				cm=bm->pBit+bf*(bm->sy-1-y);
				for(x=cx; x<ex; x++)
				{
					cpBMP= cm+x;
					m= mm+(px>>16);
					px+=fx;
					if (*m==p3 || mesh_if2(x,y,p5,p6)!=0) continue;
					*cpBMP=*m;
				}
				py+=fy;
			}
		break;
	}

	return 0;
}



int Gstat=256;	//Xe[^X
int Gshift=0;
int Ggx,Ggy,Grot;
int *Gptr;
AL_GSTAT algstat;
AL_GFLAG gflag;

EXPORT BOOL WINAPI AL_Gflag (int *p1, int p2, int p3, int p4)
{
	memcpy(&gflag,p1,sizeof(gflag));
	return 0;
}

EXPORT BOOL WINAPI AL_Gstat (int *p1, int p2, int p3, int p4)
{
	memcpy(&algstat,p1,sizeof(algstat));
	if (p2!=0 || p3!=0 || p4!=0) *(int *)((int *)&algstat+p2)=p3;

	Gstat=algstat.trstat;

	Ggx=  algstat.gx;		//X Rs[TCY
	Ggy=  algstat.gy;		//Y
	Grot =algstat.ar;		//]p

	Gshift=algstat.palshift&255;

	Gptr=p1;				//nϐ̃|C^


	if (gflag.tr100){
		Gstat=Gstat*256/100;
	}



	return 0;
}

//----------------------------------------------//
/*
BOOL gp2_nom(BYTE *cpBMP, BYTE *_pBMP)
{
	int *cpiBMP;
	cpiBMP=(int *)cpBMP;
	*cpiBMP=(*cpiBMP&0xFF000000)|*((int *)mpRGB + *_pBMP);
}
*/
BOOL gp2_nom(BYTE *cpBMP, BYTE *_pBMP)
{
	*(cpBMP+0)=mpRGB[*_pBMP+Gshift&255].rgbBlue;
	*(cpBMP+1)=mpRGB[*_pBMP+Gshift&255].rgbGreen;
	*(cpBMP+2)=mpRGB[*_pBMP+Gshift&255].rgbRed;
}


BOOL gp2_tr(BYTE *cpBMP, BYTE *_pBMP,int sR,int sG,int sB)
{
	BYTE *R,*B,*G;

	B =cpBMP;
	G =cpBMP+1;
	R =cpBMP+2;
	*B +=((mpRGB[*_pBMP+Gshift&255].rgbBlue  *sB >>8) -*B )*Gstat >>8;
	*G +=((mpRGB[*_pBMP+Gshift&255].rgbGreen *sG >>8) -*G )*Gstat >>8;
	*R +=((mpRGB[*_pBMP+Gshift&255].rgbRed   *sR >>8) -*R )*Gstat >>8;

}

BOOL gp2_trF(BYTE *cpBMP, BYTE *_pBMP)
{
	BYTE *R,*B,*G;

	B =cpBMP;
	G =cpBMP+1;
	R =cpBMP+2;
	*B +=(*_pBMP     -*B )*Gstat >>8;
	*G +=(*(_pBMP+1) -*G )*Gstat >>8;
	*R +=(*(_pBMP+2) -*R )*Gstat >>8;
}

BOOL gp2_add(BYTE *cpBMP, BYTE *_pBMP,int sR,int sG,int sB)
{
/*
	register UINT R,B,G;

	B =*cpBMP     +(mpRGB[*_pBMP+Gshift&255].rgbBlue  *Gstat >>8);
	G =*(cpBMP+1) +(mpRGB[*_pBMP+Gshift&255].rgbGreen *Gstat >>8);
	R =*(cpBMP+2) +(mpRGB[*_pBMP+Gshift&255].rgbRed   *Gstat >>8);
	if (B>255) B=255;
	if (G>255) G=255;
	if (R>255) R=255;
	*cpBMP=B;	cpBMP++;
	*cpBMP=G;	cpBMP++;
	*cpBMP=R;
*/
	BYTE *R,*B,*G;
	B =cpBMP;
	G =cpBMP+1;
	R =cpBMP+2;
	*B =min( (mpRGB[*_pBMP+Gshift&255].rgbBlue  *Gstat *sB >>16)+*B ,255);
	*G =min( (mpRGB[*_pBMP+Gshift&255].rgbGreen *Gstat *sG >>16)+*G ,255);
	*R =min( (mpRGB[*_pBMP+Gshift&255].rgbRed   *Gstat *sR >>16)+*R ,255);


}

BOOL gp2_dec(BYTE *cpBMP, BYTE *_pBMP,int sR,int sG,int sB)
{
/*
	register int R,B,G;

	B =*cpBMP     -(mpRGB[*_pBMP+Gshift&255].rgbBlue  *Gstat >>8);
	G =*(cpBMP+1) -(mpRGB[*_pBMP+Gshift&255].rgbGreen *Gstat >>8);
	R =*(cpBMP+2) -(mpRGB[*_pBMP+Gshift&255].rgbRed   *Gstat >>8);
	if (B<0) B=0;
	if (G<0) G=0;
	if (R<0) R=0;
	*cpBMP=B;
	*(cpBMP+1)=G;
	*(cpBMP+2)=R;
*/
	BYTE *R,*B,*G;
	B =cpBMP;
	G =cpBMP+1;
	R =cpBMP+2;
	*B =max( (mpRGB[*_pBMP+Gshift&255].rgbBlue  *Gstat *sB >>16)+*B ,0);
	*G =max( (mpRGB[*_pBMP+Gshift&255].rgbGreen *Gstat *sG >>16)+*G ,0);
	*R =max( (mpRGB[*_pBMP+Gshift&255].rgbRed   *Gstat *sR >>16)+*R ,0);

//	int *cpiBMP;
//	cpiBMP=(int *)cpBMP;
//	*cpiBMP=(*cpiBMP&0xFF000000)|((R<<16)+(G<<8)+B);
}

BOOL gp2_invdec(BYTE *cpBMP, BYTE *_pBMP, int sR,int sG,int sB)
{
	register int R,B,G;

	B =*cpBMP     -((255 - mpRGB[*_pBMP+Gshift&255].rgbBlue  )*sB *Gstat >>16);
	G =*(cpBMP+1) -((255 - mpRGB[*_pBMP+Gshift&255].rgbGreen )*sG *Gstat >>16);
	R =*(cpBMP+2) -((255 - mpRGB[*_pBMP+Gshift&255].rgbRed   )*sR *Gstat >>16);
	if (B<0) B=0;
	if (G<0) G=0;
	if (R<0) R=0;
/*
	B =*cpBMP     * mpRGB[*_pBMP].rgbBlue  >>8;
	G =*(cpBMP+1) * mpRGB[*_pBMP].rgbGreen >>8;
	R =*(cpBMP+2) * mpRGB[*_pBMP].rgbRed   >>8;
*/

	*cpBMP=B;
	*(cpBMP+1)=G;
	*(cpBMP+2)=R;
}

BOOL gp2_mul(BYTE *cpBMP, BYTE *_pBMP,int sR,int sG,int sB)
{
	BYTE *R,*B,*G;
	B =cpBMP;
	G =cpBMP+1;
	R =cpBMP+2;
	*B = *B *mpRGB[*_pBMP+Gshift&255].rgbBlue  *sB >>16;
	*G = *G *mpRGB[*_pBMP+Gshift&255].rgbGreen *sG >>16;
	*R = *R *mpRGB[*_pBMP+Gshift&255].rgbRed   *sR >>16;
}

BOOL gp2_paladd(BYTE *cpBMP, BYTE *_pBMP ,int type,int vp,int pal)
{
	int i,p,x;

	if ((*cpBMP&vp)==pal || (type&0xF)>3)
	{
		*cpBMP=*_pBMP+Gshift&255;
	}
		else
	{
		//type=0 \[XɉZ
		//type=1 Rs[ɉZ
		//type=2 \[XɉZ
		//type=3 Rs[ɉZ

		if ((type&0xF)==0){ i=Gstat; *cpBMP=*_pBMP;}
		if ((type&0xF)==1){ i=Gstat; }
		if ((type&0xF)==2){ i=*cpBMP+Gstat; *cpBMP=*_pBMP; }
		if ((type&0xF)==3){ i=*_pBMP+Gstat; }
		if (type&0x10) i=-i;
		i>0 ? p=1 : p=-1; 

		for(x=0; x<abs(i); x++){
			if (palflag[*cpBMP+p &255].limit==1) break;
			*cpBMP+=p;
		}
	}
}

BOOL gp2_add2(BYTE *cpBMP, BYTE *_pBMP)
{
	register UINT R,B,G;
	register BYTE r,g,b;
	int *cpiBMP;

	B =(mpRGB[*_pBMP].rgbBlue  /2 + *cpBMP    ) /2;
	G =(mpRGB[*_pBMP].rgbGreen /2 + *(cpBMP+1)) /2;
	R =(mpRGB[*_pBMP].rgbRed   /2 + *(cpBMP+2)) /2;
	cpiBMP=(int *)cpBMP;
	*cpiBMP=(*cpiBMP&0xFF000000)|((R<<16)+(G<<8)+B);
}

BYTE *pGPM=NULL;
BOOL gp2_mask(BYTE *cpBMP, BYTE *_pBMP, BYTE *pG, int sR,int sG,int sB)
{
	int m,p;

	p=*pG+Gstat;
	if (p>255) p=255;
	*pG=p; m=Gstat;
	Gstat=p+1;
	gp2_tr(cpBMP,_pBMP,sR,sG,sB);
	Gstat=m;

/*
	switch(mode){
	case 0:
	break;
	}
*/
}

EXPORT BOOL WINAPI gp2_maskset(BMSCR *bm, int p1, int p2, int p3)
{
	static int x,y;
	if (p1==1){
		x=bm->sx;
		y=bm->sy;
		if (pGPM!=NULL) free(pGPM);
		pGPM=(BYTE *)malloc(x*y);
	}
	ZeroMemory(pGPM,x*y);
	return 0;
}

BOOL gp2_pset(BMSCR *bm,int x, int y)
{
	if (x<0 || x>=bm->sx || y<0 || y>=bm->sy) return 0;

	BYTE *p;
	int pixsize=(bm->palmode==0)*2+1;
	p=bm->pBit+(bm->sy-1-y)*(bm->sx*pixsize+3&0xFFFC)+x*pixsize;

	if (pixsize==3){
		*(p+0)=GetBValue(bm->color);
		*(p+1)=GetGValue(bm->color);
		*(p+2)=GetRValue(bm->color);
	}else{
		*p=GetRValue(bm->color);
	}
}


/*
BOOL (*effect_func[8])(BYTE *,BYTE *)={
	gp2_nom,
	gp2_tr,
	gp2_add,
	gp2_dec,
	gp2_invdec,
	gp2_add2
	};
*/

BOOL zoomchk(int *bmgx, int *bmgy){
	switch(gflag.zoomunit){
		case 0:
			*bmgx=algstat.wx;
			*bmgy=algstat.wy;
			break;
		case 1:
			*bmgx=algstat.wx*Ggx/100;
			*bmgy=algstat.wy*Ggy/100;
			break;
		case 2:
			*bmgx=algstat.wx*Ggx>>8;
			*bmgy=algstat.wy*Ggy>>8;
			break;
		default:
			*bmgx=algstat.wx*Ggx/gflag.zoomunit;
			*bmgy=algstat.wy*Ggy/gflag.zoomunit;
		break;
	}
}
//----------------------------------------------//
/*
	Gstat=p1[0];
	Ggx=  p1[2];	//X Rs[TCY
	Ggy=  p1[3];	//Y
	Grot =p1[4];	//]p
	Gshift=p1[6]&255;//pbgVtg
*/
/*
int mBFW,mW,mH,mPIXSIZE;		//AL_setŐݒ肳f[^
BMSCR *mbm;					//
BYTE *mpBMP;				//
RGBQUAD *mpRGB;				//

*/
/*------------------------------------------------
	pbg̉ʂtJ[̉ʂpos̈ʒuɃRs[
	EAL_GstatŃRs[TCYݒ
	EposŃItZbgW
	AL_gcopy2 p1,p2,p3

	p1,p2	Rs[W(X,Y)̃ItZbg
	p3 \{ 256=1{
------------------------------------------------*/


EXPORT BOOL WINAPI AL_gcopy2 (BMSCR *bm, int p1, int p2, int p3)
{
	int tx[4],ty[4];
	int i,x,y;
	int ox,oy,gx,gy,bfw,rx,ry,_rx,_ry;
	int sR,sG,sB;
	int c,s,_c,_s;
	int _gx,_gy,_Ggx,_Ggy;
	int minX,minY,maxX,maxY;
	int ix=0,iy=0;
	int px,py;
	int _px,_py;
	int cx,cy,_cx,_cy;	//Rs[ʒu
	int mx,my;			//Rs[̃TCY
	int bx=0,by=0;
	int pixsize=3;
	int bmgx,bmgy;
	int pal,palGstat;
	int in,out;
	int type;
	BYTE *pB,*pM,*pG;
	BYTE vp=0xFF;

	pal=gflag.trcol;
	if (p3==0) p3=256;

	if (gflag.vtr){ vp=0xF; pal=pal&0xF; }//c̓

	zoomchk(&bmgx,&bmgy);	//TCYϊ

	if (bm->palmode) pixsize=1;
	bfw = bm->sx*pixsize +3 & 0xFFFC;
	if(gflag.rot){
		cx = (algstat.cx*p3>>8)-algstat.rx +bm->cx;
		cy = (algstat.cy*p3>>8)-algstat.ry +bm->cy;
	}else{
		cx = ((algstat.cx-algstat.rx)*p3>>8) +bm->cx;
		cy = ((algstat.cy-algstat.ry)*p3>>8) +bm->cy;
	}
	_rx=algstat.rx; _ry=algstat.ry;
	bmgx=bmgx*p3>>8; bmgy=bmgy*p3>>8;
	AL_sin(&s,Grot,gflag.arunit,0);
	AL_cos(&c,Grot,gflag.arunit,0);
	p1+=algstat.mx;
	p2+=algstat.my;

	//Rs[̂͂ݏo`FbN
	mx=Ggx; my=Ggy;
	if (p1<0){ mx+=p1; p1=0; }
	if (p2<0){ my+=p2; p2=0; }
	if (p1+mx>mW) mx=mW-p1;
	if (p2+my>mH) my=mH-p2;

	gx=abs(bmgx);
	gy=abs(bmgy);

	//Rs[4_߂
	gx--; gy--;		//0.5hbg̎lpC[W
	if(gflag.rot){
		if (Ggx==0) rx=0; else rx=_rx*abs(bmgx)*2/Ggx-1;
		if (Ggy==0) ry=0; else ry=_ry*abs(bmgy)*2/Ggy-1;
		tx[0]=(cx+_rx<<17)-(rx*c-ry*s)>>1;
		ty[0]=(cy+_ry<<17)-(rx*s+ry*c)>>1;
	}else{
		tx[0]=((cx<<16)+32768)+(((Ggx*p3>>8)-1<<16)-(gx*c-gy*s)>>1);
		ty[0]=((cy<<16)+32768)+(((Ggy*p3>>8)-1<<16)-(gx*s+gy*c)>>1);
	}

	tx[1]=c*gx+tx[0];		ty[1]=s*gx+ty[0];
	tx[2]=c*gx-s*gy+tx[0];	ty[2]=s*gx+c*gy+ty[0];
	tx[3]=-s*gy+tx[0];		ty[3]=c*gy+ty[0];

	//ő啝߂
	maxX=tx[0]; minX=tx[0];	maxY=ty[0]; minY=ty[0];
	for(i=0; i<4; i++)
	{
		if (maxX<tx[i]) maxX=tx[i];
		if (minX>tx[i]) minX=tx[i];
		if (maxY<ty[i]) maxY=ty[i];
		if (minY>ty[i]) minY=ty[i];
	}
	if (algstat.trmode==259){
		Gptr[0]=tx[0]>>16; Gptr[2]=tx[1]>>16; Gptr[4]=tx[2]>>16; Gptr[6]=tx[3]>>16;
		Gptr[1]=ty[0]>>16; Gptr[3]=ty[1]>>16; Gptr[5]=ty[2]>>16; Gptr[7]=ty[3]>>16;
		Gptr[8]=minX>>16; Gptr[9]=maxX>>16; Gptr[10]=minY>>16; Gptr[11]=maxY>>16;
		return 0;
	}
	if (bmgx==0 || bmgy==0) return 0;
	if (mx<=0 || my<=0) return 0;

	
	//Rs[̃TCY
	gx=maxX-minX>>16;			//I_(TCY1hbgȂ)
	gy=maxY-minY>>16;
	_cx=minX>>16;				//Rs[̊Jnʒu
	_cy=minY>>16;

	//Rs[̊JnʒuiRs[̃TCYƓƂČvZj
	_gx=gx;
	_gy=gy;
	ox =( abs(bmgx)-1<<16 )-_gx*c-_gy*s >>1;
	oy =( abs(bmgy)-1<<16 )+_gx*s-_gy*c >>1;
	ox+=32768;
	oy+=32768;

	//Rs[͂ݏȍC
	if (_cx<0) { gx+=_cx; ix=-_cx; _cx=0; }
	if (_cy<0) { gy+=_cy; iy=-_cy; _cy=0; }
	if (_cx+gx>=bm->sx) gx=bm->sx-_cx-1;
	if (_cy+gy>=bm->sy) gy=bm->sy-_cy-1;
	if (gx<=0 || gy<=0) return 0;

	if (bmgx<0) bx=(Ggx<<16)-1;
	if (bmgy<0) by=(Ggy<<16)-1;

	i=algstat.trmode;
	if (Gstat==256 && algstat.trmode==1 && algstat.RGB==0xFFFFFF) i=0;
	if (bm->palmode){
		palGstat=(256-Gstat)>>4;
		if (algstat.trmode!=258 && algstat.trmode!=261) i=256;
		if (algstat.trmode==1){
			if (palGstat>0) i=257;
			if (palGstat>=16) return 0;
		}
		if (algstat.trmode>=17 && algstat.trmode<=20){ type=algstat.trmode-17; i=17; }
	}else{
		if (algstat.trmode>=17 && algstat.trmode<=20) i=0;
	}

	sR=(algstat.RGB>>16&0xFF)*256/255;
	sG=(algstat.RGB>> 8&0xFF)*256/255;
	sB=(algstat.RGB    &0xFF)*256/255;

	int bcx,bcy;	//Zp
					//Rs[̊Jnʒu
	bcx=_cx; bcy=_cy;
	if (bm->palmode==0) _cx=_cx*3;
	cy=bm->sy-1-cy;	_cy=bm->sy-_cy-1;

	_c=c*Ggx/bmgx;
	_s=s*Ggy/bmgy;
	double pxD,pyD;
	switch(i){
	case 0:
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_nom(pM+x*3,pB);
				}
			}
		}
		break;
	case 1:		//
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_tr(pM+x*3  ,pB,sR,sG,sB);
				}
			}
		}
		break;
	case 2:		//Z
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_add(pM+x*3 ,pB,sR,sG,sB);
				}
			}
		}
		break;
	case 3:		//Z
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_dec(pM+x*3 ,pB,sR,sG,sB);
				}
			}
		}
		break;
	case 4:		//]Z
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_invdec(pM+x*3 ,pB,sR,sG,sB);
				}
			}
		}
		break;
	case 5:		//Z
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_mul(pM+x*3 ,pB,sR,sG,sB);
				}
			}
		}
		break;

	case 16:	//Z
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[
			pG=pGPM+(y+bcy)*bm->sx+bcx;

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_mask(pM+x*3, pB, pG+x,sR,sG,sB);
				}
			}
		}
		break;

	case 17:		//pbgVtg `20:܂ŗ\
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					gp2_paladd(pM+x ,pB,sR,vp,pal);
				}
			}
		}
		break;

	case 256:	//pbg[h
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					*(pM+x)=*pB+Gshift&255;
				}
			}
		}
		break;

	case 257:	//pbg&bV[h
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal || mesh_if2(x+_cx,y+_cy,0,palGstat) != 0) continue;
					*(pM+x)=*pB+Gshift&255;
				}
			}
		}
		break;


	case 258:	//}XN[h(pbg[h)
		i=(bm->palmode==0)*2+1;
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;
					if ((*pB&vp)==pal) continue;
					*(pM+x*i)=Gstat&255;
				}
			}
		}
		break;
		//case 259:	//4_擾

	case 260:	//tJ[tJ[
		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;
			pM=bm->pBit +(_cy-y)*bfw+_cx;	//Rs[

			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +(p1 +_px)*3;
					gp2_trF(pM+x*3,pB);
				}
			}
		}
		break;

	case 261:
		//
		//color ŐFw
		//palmodecolorp1Ńpbgw
		in=1;
		out=0;

	case 262:
		//O
		if (i==262)
		{
			in=0;
			out=1;
		}


		BYTE *line;
		int backx;
		line=(BYTE *)malloc(gx+4);
		memset(line,0,gx);

		for(y=0; y<=gy; y++)
		{
			px = (y+iy)*s +ix*c +ox;
			py = (y+iy)*c -ix*s +oy;
			pxD=px/bmgx*Ggx;
			pyD=py/bmgy*Ggy;
			px=pxD+bx;
			py=pyD+by;

			backx=0;
			for(x=0; x<=gx; x++)
			{
				_px=px>>16; _py=py>>16;
				px += _c; py -= _s;

				if (_px >= 0 && _py >= 0 && _px < mx && _py < my)
				{
					pB=mpBMP + (mH -1 -p2 -_py)*mBFW +p1 +_px;

					if ((*pB&vp)==pal)
					{
						if ( *(line+x)==1 ) gp2_pset(bm,bcx+x,bcy+y-in);
						if ( backx==1 ) gp2_pset(bm,bcx+x-in,bcy+y);
						backx=0;
						*(line+x)=0;
						continue;
					}

					if ( *(line+x)==0 ) gp2_pset(bm,bcx+x,bcy+y-out);
					if ( backx==0 ) gp2_pset(bm,bcx+x-out,bcy+y);
					if ( x==gx ) gp2_pset(bm,bcx+x+out,bcy+y);
					if ( y==gy ) gp2_pset(bm,bcx+x,bcy+y+out);

					*(line+x)=1;
					backx=1;
				}
				else
				{
					if ( *(line+x)==1 ) gp2_pset(bm,bcx+x,bcy+y-in);
					if ( backx==1 ) gp2_pset(bm,bcx+x-in,bcy+y);
					backx=0;
					*(line+x)=0;
				}
			}
		}
		free(line);
		break;


	}

	return -16;
}

//pos ʒu
//p1,p2 Eʒu
//p3擾pzϐ̃|C^(p3.0 FĂ)
EXPORT BOOL WINAPI AL_getmask (BMSCR *bm, int p1, int p2, int p3)
{
	int x,y,i,cx,cy,bw,p;
	int cnt=0;
	BYTE *pM;
	int *sels=(int *)p3;
	p=sels[0]; sels[0]=0;

	i=(bm->palmode==0)*2+1;
	cx=bm->cx;
	cy=bm->cy;

	if (cx>p1){ i=cx; cx=p1; p1=i; }
	if (cy>p2){ i=cy; cy=p2; p2=i; }

	//͈͊O
	if (cx>=bm->sx || cy>=bm->sy || p1<0 || p2<0) return 0;

	if (cx<0) cx=0;
	if (cy<0) cy=0;
	if (p1>=bm->sx) p1=bm->sx-1;
	if (p2>=bm->sy) p2=bm->sy-1;

	bw=bm->sx*i +3 & 0xFFFC;
	pM=bm->pBit +(bm->sy-1-cy)*bw;

	for(y=cy; y<=p2; y++){
		for(x=cx; x<=p1; x++){
			if (*(pM+x*i)!=p){
				sels[*(pM+x*i)]=1;
				cnt++;
			}
		}
		pM-=bw;
	}

	return -cnt;
}

//EBhEɒڕϔ{Rs[
//AL_Gstat
EXPORT BOOL WINAPI gzoom2 (BMSCR *bm, int p1, int p2, int p3)
{
	HDC hdc;
	hdc=GetDC(bm->hwnd);
	StretchBlt(hdc,bm->cx,bm->cy,bm->gx,bm->gy,mbm->hdc,p1,p2,Ggx,Ggy,SRCCOPY);
	ReleaseDC(bm->hwnd,hdc);

	return 0;
}

//p1 F
EXPORT BOOL WINAPI AL_makemask (BMSCR *bm, BYTE p1, BYTE p2, BYTE p3)
{
	int wx,wy,sw,y;
	BYTE *lmt_cpBMPx;

	wx =bm->sx;			//TCY
	wy =bm->sy;
	sw =bm->sx +3 & 0xFFFC;
	
	p2=pal_app2(bm,0,0,0,0,255,1);
	p3=pal_app2(bm,255,255,255,0,255,1);
	
	BYTE *pBMP=bm->pBit +((wy -1)*sw );

	sw+=wx;
	
	for(y =0; y<wy; y++){
		lmt_cpBMPx=pBMP+wx;
		while(pBMP < lmt_cpBMPx){
			if (*pBMP == p1)
				*pBMP=p2;
			else
				*pBMP=p3;
			pBMP++;
		}
		pBMP-=sw;
	}
	
	
	return 0;
}

EXPORT BOOL WINAPI penMASK_set (BMSCR *bm, int p1, int p2, int p3)
{
	static int stsize=0;
	int size;
	
	size=(bm->sx +31 &0xFFE0)*bm->sy /8;

	if (stsize != size){
		if (penMASK != NULL) free(penMASK);
		stsize = size;
		penMASK=(int *)malloc(stsize);
		if (penMASK==NULL) return 1;
	}
	ZeroMemory(penMASK,stsize);

	return 0;
}

//////////////////////////////////
//pos n_
//p1,p2 I_

EXPORT BOOL WINAPI AL_mboxf (BMSCR *bm, int p1, int p2, int p3)
{

/*
	int cx,cy,wx,wy,x,y,endX,endY;
	cx=bm->cx;
	cy=bm->cy;
	wx=p1;
	wy=p2;
	if (cx<0){ wx+=cx; cx=0;}
	if (cy<0){ wy+=cy; cy=0;}
	if (wx+cx >bm->sx){wx =bm->sx-cx;}
	if (wy+cy >bm->sy){wy =bm->sy-cy;}
	endX=cx+wx;
	endY=cy+wy;
*/
	int endX,endY,bfx,x,y;
	
	endX=bm->cx+p1;
	endY=bm->cy+p2;
	bfx=bm->sx +3 & 0xFFFC;
	for (y=bm->cy; y<endY; y++){
		for (x=bm->cx+(y&1); x<endX; x+=2)
			*(bm->pBit +(bm->sy -1-y)*bfx +x)=p3;
	}

	return 0;
}

//////////////////////////////////
EXPORT BOOL WINAPI AL_end (int p1, int p2, int p3, int p4)
{
	int i;
	if (penMASK != NULL) free(penMASK);
	if (pGPM!=NULL) free(pGPM);
	for(i=0; i<BANK_MAX+exBankmax; i++) AL_bankfree(i,0,0,0);

	free(al_bank);

	return 0;
}
//////////////////////////////////




/*
$232͂Ȃ
EXPORT BOOL WINAPI AL_bmpload (HSPEXINFO *hei, int _p1, int _p2, BYTE *pRGB )
{
	///////////////
		BMSCR *bm;
		char *filename;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		filename=hei->HspFunc_prm_gets();

		if (*hei->er) return *hei->er;
	///////////////
*/

//p1 1 pbgݒ肵Ȃ
EXPORT BOOL WINAPI AL_bmpload (BMSCR *bm, char *filename, int p1,  BYTE *pRGB )
{
	BITMAPFILEHEADER *bmpfile;
	BITMAPINFOHEADER *bmpinfo;

	BYTE *pBMP,*pBit,*mpB,*mpRGB;
	BYTE *data;
	int filesize,bcnt,err,colors;
	int bfw,mBFW;
	int bcx=0,bcy=0;	//BMPǂݍ݊Jnʒu
	int cx,cy,sx,sy,gx,gy,bx,by;
	int i,x,y;

	cx=bm->cx;
	cy=bm->cy;
	sx=bm->sx;
	sy=bm->sy;
	
	filesize=bload(&data,filename);
	if (filesize<=0) return -1;

	bmpfile=(BITMAPFILEHEADER *)data;
	bmpinfo=(BITMAPINFOHEADER *)(data + 0xE);
	bcnt=bmpinfo->biBitCount;
	if (bcnt>8) return -2;

	colors=bmpinfo->biClrUsed; if (colors==0) colors=1<<bcnt;
	pBMP=data+0xE+bmpinfo->biSize+colors*4;
	bx=bmpinfo->biWidth;
	by=bmpinfo->biHeight;
	gx=bx;
	gy=by;
	bfw=bm->sx +3 & 0xFFFC;

	if (cx<0){ gx+=cx; bcx=-cx; cx=0; }
	if (cy<0){ gy+=cy; bcy=-cy; cy=0; }
	if (cx+gx>sx){ gx=sx-cx; }
	if (cy+gy>sy){ gy=sy-cy; }

	if (gx<=0 || gy<=0) return 0;

	i=bmpinfo->biCompression;
	if (i==BI_RGB){
		switch(bcnt){
			case 1: mBFW=(bx +31 &0xFFE0)/8; break;
			case 4: mBFW=(bx + 7 &0xFFF8)/2; break;
			case 8: mBFW= bx + 3 &0xFFFC;    break;
		}
		for(y=0; y<gy; y++){
			pBit=bm->pBit+(sy-1-y-cy)*bfw+cx;
			mpB=pBMP+(by-1-y-bcy)*mBFW;
			for(x=0; x<gx; x++){
				pBit[x]=bitpeek(mpB,x+bcx,bcnt);
			}
		}
		err=0;
	}else if (i==BI_RLE4 || i==BI_RLE8){
		err=3;
	}else{
		err=4;
	}

	//pbg
	if (err==0 && p1==0){
		mpRGB=data+0xE+bmpinfo->biSize;
		for(i=0; i<colors; i++){
			pRGB[i*3+0]=mpRGB[i*4+2];
			pRGB[i*3+1]=mpRGB[i*4+1];
			pRGB[i*3+2]=mpRGB[i*4+0];
		}
		bms_setpal(bm,256,pRGB);
	}

	free(data);

	return -err;
}


//p1	1	  2F
//		4	 16F
//		8	256F
//		0	F
//filename	̂ƂrbgԂ
//			+0x10 pbgFȓŔ͈͊Ogp
//			0x200+F  F𒴂Ă

EXPORT BOOL WINAPI AL_bmpsave (BMSCR *bm, char *filename, int p1, int p2)
{
	BITMAPINFOHEADER *bmpinfo;
	BYTE *bmp;
	BYTE *bmpData;
	BYTE *RGB;
	int size,palsize;
	int x,y,z,i,cc,ex,p;
	int ccnt=0;
	int bmpsw,sw8;
	BYTE pal[256],palt[256];
	BYTE c;
	//--------------------------------------

	ZeroMemory(&pal,256);
	ZeroMemory(&palt,256);

	//F
	cc=2;
	if (p1!=1) cc=16;

	//F̃JEg
	sw8=bm->sx +3 & 0xFFFC;

	if (p1!=8){
		for(y=0; y<bm->sy; y++)
		{
			x=(bm->sy -1-y)*sw8;
			ex=x+bm->sx;
			for(x; x<ex; x++)
			{
				c=*(bm->pBit +x);
				if (pal[c]==0){	pal[c]=1; ccnt++; }
	//			if (cc<ccnt) goto cnt_over;
			}
		}
	}
	cnt_over:
	if ( (p1==1&&ccnt>2) || (p1==4&&ccnt>16) ) return -(0x2000+ccnt);

	if (p1==8) cc=256;
	if (p1==0){
		cc=2; p1=1;
		if (ccnt> 2){ cc= 16; p1=4; }
		if (ccnt>16){ cc=256; p1=8; }
	}

	if (cc<=16){
		x=0;
		for(i=0; i<256; i++){ if (pal[i]==1){ pal[x]=i; x++; } }
		if (pal[ccnt-1]<cc){
			//gppbgF͈͓̔
			p2=0;
			for(i=0; i<16; i++){ palt[i]=i; pal[i]=i; }
		}else{
			//gppbgF͈̔͊O
			p2=0x1000;
			for(i=0; i<ccnt; i++) palt[ pal[i] ]=i;
		}
	}else{
		for(i=0; i<256; i++){ palt[i]=i; pal[i]=i; }
	}
	//rbg
	if (filename[0]==0) return -p1-p2;

	palsize=4<<p1;
	i=32/p1;
	x=8/p1;
	size=(bm->sx+(i-1))/i*i *bm->sy/x +0x36 +palsize;

	bmp=(BYTE *)calloc(size, 1);

	//t@Cwb_
	*(bmp  +0)='B';
	*(bmp  +1)='M';
	*(int *)(bmp+   2)=size;				//t@CTCY
	*(int *)(bmp+ 0xA)=0x36+palsize;

	bmpinfo=(BITMAPINFOHEADER *)(bmp+0xE);
	bmpinfo->biSize			=0x28;
	bmpinfo->biWidth		=bm->sx;		//
	bmpinfo->biHeight		=bm->sy;		//
	bmpinfo->biPlanes		=1;				//v[ =1
	bmpinfo->biBitCount		=p1;			//J[rbg
	bmpinfo->biCompression	=0;				//k^Cv
	bmpinfo->biSizeImage	=size-0x36-palsize;	//C[W̃oCg
	bmpinfo->biXPelsPerMeter=0;				//𑜓x
	bmpinfo->biYPelsPerMeter=0;				//𑜓x
	bmpinfo->biClrUsed		=1<<p1;			//J[
	bmpinfo->biClrImportant	=0;

	//pbg
	RGB=(BYTE *)bm->pal;
	x=cc*4; y=0;
	for(i=0 ;i<x ;i+=4)
	{
		*(bmp+ 0x36 +i +0) = *(RGB +pal[y]*4 +0);
		*(bmp+ 0x36 +i +1) = *(RGB +pal[y]*4 +1);
		*(bmp+ 0x36 +i +2) = *(RGB +pal[y]*4 +2);
		y++;
	}

	//f[^
	bmpData=bmp+0x36+palsize;

	if (p1==8) CopyMemory( bmpData,bm->pBit,sw8*bm->sy );

	if (p1==4)	//---------------------------
	{
		bmpsw=( bm->sx +7 & 0xFFF8 ) >>1;	//4rbgBMP̈̃TCY
		for(y=0; y<bm->sy; y++)
		{
			z=y*sw8;
			x=y*bmpsw;
			ex=x+(bm->sx+1)/2;
			for(x; x<ex; x++)
			{
				c=0;
				if(x+1>ex) p=bm->sx&1; else p=2;
				for(i=0; i<p; i++)
					c += palt[*(bm->pBit +z +i)]<<(1-i<<2);
				*(bmpData+x)=c;
				z+=2;
			}
		}
	}		//---------------------------
	if (p1==1)	//---------------------------
	{
		bmpsw=( bm->sx +31 & 0xFFE0 )>>3;	//1rbgBMP̈̃TCY
		for(y=0; y<bm->sy; y++)
		{
			z=y*sw8;
			x=y*bmpsw;
			ex=x+(bm->sx+7)/8;
			for(x; x<ex; x++)
			{
				c=0;
				if(x+1>ex) p=bm->sx&7; else p=8;
				for(i=0; i<p; i++)
					c += palt[*(bm->pBit +z +i)]<<(7-i);
				*(bmpData+x)=c;
				z+=8;
			}
		}
	}		//---------------------------


	i=bsave(filename,bmp,size);
	free(bmp);
	if (i==1) return -256;
	return -p1;
}



/////////////////////////////////////////

typedef struct TMP_BMP{
	BYTE *pBit;
	BYTE *pRGB;
	int bfw,sy,offx,offy;
	int dotArea;
	int palmode;
	bool tmp;
};

//cx,cy W(256{)
//ex,ey EW

int szoomM(TMP_BMP *tm, int cx, int cy, int ex, int ey)
{
	int x,y,ccx,ccy,eex,eey,i;
	int x_p,y_p,s,_x,pixsize;
	int r=0,g=0,b=0,p;
	BYTE *tBMP,*_tBMP;

	pixsize=(tm->palmode==0)*2+1;
	if (tm->palmode)
	{
		tBMP=tm->pRGB;
		_tBMP=tm->pBit;
	}
	else
	{
		tBMP=tm->pBit;
	}

	ccx=cx>>8; ccy=cy>>8;
	eex=ex>>8; eey=ey>>8;

	for(y=ccy; y<=eey; y++)
	{
		if (y==ccy) y_p=256-(cy&0xFF);		//n߂1
		else if (y==eey) y_p=ey&0xFF;		//I1
		else y_p=256;
		if (y_p==0) continue;
		_x=(tm->sy-1-y-tm->offy)*tm->bfw+(tm->offx+ccx)*pixsize;

		if (y_p==256)		//׍H...
		{
			for(x=ccx; x<=eex; x++)
			{
				if (x==ccx) x_p=256-(cx&0xFF);
				else if (x==eex) x_p=ex&0xFF;
				else
				{
					tm->palmode==1 ? i=_tBMP[_x]*4 :i=_x;

					b+=tBMP[i+0]*256;
					g+=tBMP[i+1]*256;
					r+=tBMP[i+2]*256; _x+=pixsize; continue; 
				}
				if (x_p==0) { _x+=pixsize; continue; }

				tm->palmode==1 ? i=_tBMP[_x]*4 :i=_x;

				b+=tBMP[i+0]*x_p;
				g+=tBMP[i+1]*x_p;
				r+=tBMP[i+2]*x_p;	_x+=pixsize;
			}
		}else{
			for(x=ccx; x<=eex; x++)
			{
				if (x==ccx) x_p=256-(cx&0xFF);
				else if (x==eex) x_p=ex&0xFF;
				else x_p=256;
				if (x_p==0) { _x+=pixsize; continue; }

				tm->palmode==1 ? i=_tBMP[_x]*4 :i=_x;

				s=x_p*y_p>>8;
				b+=tBMP[i+0]*s;
				g+=tBMP[i+1]*s;
				r+=tBMP[i+2]*s;	_x+=pixsize;
			}
		}
	}
	p=tm->dotArea>>8;

	return (r/p<<16)+(g/p<<8)+b/p;
}

/*
int mBFW,mW,mH,mPIXSIZE;		//AL_setŐݒ肳f[^
BMSCR *mbm;					//
BYTE *mpBMP;				//
RGBQUAD *mpRGB;				//

*/

EXPORT BOOL WINAPI AL_szoom(HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	int gx,gy,ox,oy,mx,my,tx,ty,cx,cy,ix,iy,pixsize;
	int _gx,_gy,_ox,_oy,sx,sy,smx,smy;
	int x,y,bfw,mbfw,rgb,t=0;
	BYTE *pBmp,*tBMP,*mpBmp;
	int p3;
	BMSCR *bm;
	TMP_BMP tmp;

	///////////////////////
		_gx =hei->HspFunc_prm_getdi(0);		//gkTCY
		_gy =hei->HspFunc_prm_getdi(0);
		p3  =hei->HspFunc_prm_getdi(-1);	//Rs[EChEID -1AL_set̒l gp
		mx  =hei->HspFunc_prm_getdi(0);		//Rs[W
		my  =hei->HspFunc_prm_getdi(0);
		_ox =hei->HspFunc_prm_getdi(0);		//Rs[TCY
		_oy =hei->HspFunc_prm_getdi(0);
		bm  =(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
	//	if (p3!=-1) mbm =(BMSCR *)hei->HspFunc_getbmscr(p3);
		if (*hei->er) return *hei->er;
	///////////////////////
	cx=bm->cx; cy=bm->cy;
	gx=_gx; gy=_gy;
	ox=_ox; oy=_oy;
	sx=0; sy=0; smx=0; smy=0;
	pixsize=(bm->palmode==0)*2+1;

	if (cx<0)			{ sx =-cx; gx+=cx; cx=0; }
	if (cy<0)			{ sy =-cy; gy+=cy; cy=0; }
	if (gx+cx >bm->sx)	{ gx =bm->sx-cx; }
	if (gy+cy >bm->sy)	{ gy =bm->sy-cy; }

	ix=_ox*256/_gx;
	iy=_oy*256/_gy;

	mpBmp=mpBMP+mBFW*(mH-1-my)+mx*mPIXSIZE;
/*
	if (*hei->actscr == p3){	//Rs[EBhEƃRs[EBhE
		tBMP=(BYTE *)malloc(ox*oy*pixsize);
		tmp.pBit=tBMP;
		tmp.bfw=ox*pixsize;
		tmp.sy=oy;
		tmp.offx=0;
		tmp.offy=0;
		tmp.tmp=true;

		tBMP+=(tmp.sy-1)*tmp.bfw;
		for(y=0; y<oy; y++){
			memcpy(tBMP,mpBmp,tmp.bfw);
			mpBmp-=mBFW;
			tBMP-=tmp.bfw;
		}
	}else{
*/
		tmp.pBit=mpBMP;
		tmp.bfw=mBFW;
		tmp.sy=mH;
		tmp.offx=mx;
		tmp.offy=my;
		tmp.tmp=false;
//	}

	//g厞
	if (_gx>_ox){ _gx--; _ox--; ix=256; }
	if (_gy>_oy){ _gy--; _oy--; iy=256; }
	tmp.dotArea=ix*iy;

	bfw=bm->sx*pixsize +3 & 0xFFFC;
	pBmp=bm->pBit+bfw*(bm->sy-1-cy)+cx*pixsize;

	tmp.palmode=mPIXSIZE==1;
	if (mPIXSIZE==1) tmp.pRGB=(BYTE *)mpRGB;

	for(y=0; y<gy; y++){
		ty=_oy*(y+sy)*256/_gy;
		for(x=0; x<gx; x++){
			tx=_ox*(x+sx)*256/_gx;

			rgb=szoomM(&tmp,tx,ty,tx+ix,ty+iy);
			if (bm->palmode==0)
			{
				pBmp[x*3+0]=rgb&0xFF;
				pBmp[x*3+1]=rgb>>8&0xFF;
				pBmp[x*3+2]=rgb>>16;
			}else
			{
				pBmp[x]=pal_app2(bm,rgb>>16,rgb>>8&0xFF,rgb&0xFF,0,255,1);
			}

		}
		pBmp-=bfw;
	}

	if (tmp.tmp==true) free(tmp.pBit);

	return 0;
}
/////////////////////////////////////////





//----------------------
BOOL d2_setpix(BYTE *bmp,BYTE *ecd,int bg_off, int off, int ds)
{
	BYTE R,G,B,E;

	R=*(ecd +off);
	G=*(ecd +off +ds);
	B=*(ecd +off +ds*2);
	E=*(ecd +off +ds*3);

	*(bmp +bg_off +0) = ((R & 128) >>7) + ((G & 128) >>6) + ((B & 128) >>5) + ((E & 128) >>4);
	*(bmp +bg_off +1) = ((R &  64) >>6) + ((G &  64) >>5) + ((B &  64) >>4) + ((E &  64) >>3);
	*(bmp +bg_off +2) = ((R &  32) >>5) + ((G &  32) >>4) + ((B &  32) >>3) + ((E &  32) >>2);
	*(bmp +bg_off +3) = ((R &  16) >>4) + ((G &  16) >>3) + ((B &  16) >>2) + ((E &  16) >>1);
	*(bmp +bg_off +4) = ((R &   8) >>3) + ((G &   8) >>2) + ((B &   8) >>1) + ((E &   8)    );
	*(bmp +bg_off +5) = ((R &   4) >>2) + ((G &   4) >>1) + ((B &   4)    ) + ((E &   4) <<1);
	*(bmp +bg_off +6) = ((R &   2) >>1) + ((G &   2)    ) + ((B &   2) <<1) + ((E &   2) <<2);
	*(bmp +bg_off +7) = ((R &   1)    ) + ((G &   1) <<1) + ((B &   1) <<2) + ((E &   1) <<3);
}
BOOL d2_maskpix(BYTE *bmp,BYTE *ecd, int bg_off, int off)
{
	BYTE m;

	m=*(ecd+off);
	m^=255;
	if (m &128) *(bmp +bg_off +0)=16;
	if (m & 64) *(bmp +bg_off +1)=16;
	if (m & 32) *(bmp +bg_off +2)=16;
	if (m & 16) *(bmp +bg_off +3)=16;
	if (m &  8) *(bmp +bg_off +4)=16;
	if (m &  4) *(bmp +bg_off +5)=16;
	if (m &  2) *(bmp +bg_off +6)=16;
	if (m &  1) *(bmp +bg_off +7)=16;
}

BOOL d2_putpix(BYTE *ecd,BYTE *bmp,int ecd_off,int off,int ds,BYTE mask,int cp)
{
	int i;
	BYTE dot[8],m;
	for (i=0; i<8; i++) dot[i]=*(bmp+off+i);

	m=0;
	if (mask==0) for(i=0; i<8; i++) m+=(dot[i]!=cp)<<(7-i);
	if (mask==255) m=255;

	i=0;
	if (mask==1) i=1; else *(ecd+ecd_off)=m;

	//RGBE
	*(ecd+ecd_off+ds*(1-i))=((dot[0]&1)<<7)+((dot[1]&1)<<6)+((dot[2]&1)<<5)+((dot[3]&1)<<4)+((dot[4]&1)<<3)+((dot[5]&1)<<2)+((dot[6]&1)<<1)+(dot[7]&1);
	*(ecd+ecd_off+ds*(2-i))=((dot[0]&2)<<6)+((dot[1]&2)<<5)+((dot[2]&2)<<4)+((dot[3]&2)<<3)+((dot[4]&2)<<2)+((dot[5]&2)<<1)+(dot[6]&2)+((dot[7]&2)>>1);
	*(ecd+ecd_off+ds*(3-i))=((dot[0]&4)<<5)+((dot[1]&4)<<4)+((dot[2]&4)<<3)+((dot[3]&4)<<2)+((dot[4]&4)<<1)+(dot[5]&4)+((dot[6]&4)>>1)+((dot[7]&4)>>2);
	*(ecd+ecd_off+ds*(4-i))=((dot[0]&8)<<4)+((dot[1]&8)<<3)+((dot[2]&8)<<2)+((dot[3]&8)<<1)+(dot[4]&8)+((dot[5]&8)>>1)+((dot[6]&8)>>2)+((dot[7]&8)>>3);
}

//DANTE98ŨLZbg^}bv`bv[h
//pbg[hp
EXPORT BOOL WINAPI ecd_load (BMSCR *bm, char *filename, int p1, BYTE *pRGB)
{
	HANDLE hFile;
	BYTE *ecd,*bmp;
	int x,y,z,p,cx,cy,i,bf;
	int off,bg_off;
	UINT ecdsize;
	DWORD _ecdsize;
	int r,g,b;
	BYTE R,G,B,E,m;

	hFile=CreateFile(filename,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
	ecdsize=GetFileSize(hFile,0);
	if (ecdsize==0) return -2;				//t@CȂ
	SetFilePointer(hFile,0,0,FILE_BEGIN);

	x=0;
	if (ecdsize==41008 ){ x= 256; y= 256; cx= 8; cy= 8; }	//LZbg
	if (ecdsize==102448){ x= 512; y= 320; cx=16; cy=10; }	//}bv`bv
	if (x==0){ CloseHandle(hFile); return -1; }		//DANTE98Ũt@Cł͂Ȃ

	ecd=(BYTE *)malloc(ecdsize);
	ReadFile(hFile,ecd,ecdsize,&_ecdsize,0);
	CloseHandle(hFile);

	//---------pbg
	r=0; g=0; b=0;
	for (i=0; i<48; i+=3)
	{
		R=*(ecd +i +0); *(pRGB +i +0)=R *17;	//=R<<4|R
		G=*(ecd +i +1); *(pRGB +i +1)=G *17;
		B=*(ecd +i +2); *(pRGB +i +2)=B *17;
		r+=R; g+=G; b+=B;
	}
	*(pRGB +48)=r/16*17;
	*(pRGB +49)=g/16*17;
	*(pRGB +50)=b/16*17;
	bms_setpal(bm,256,pRGB);

	//---------Ro[g
	bmp=bm->pBit;
	bf=0;
	int cz=cx*cy;
	for (i=0; i<cz; i++)
	{
		z=(i%cx<<5)+((cy-1-i/cx)*cx*1024);
		//Zǂݍ
		for(p=0; p<128; p++)
		{
			off=bf+p+176;
			bg_off=(p<<3&31)+((31-(p>>2))*x)+z;
			d2_setpix(bmp,ecd,bg_off,off,128);

			if (ecdsize==41008) d2_maskpix(bmp,ecd,bg_off,off-128);
		}
		bf+=640;
	}
	free(ecd);
	return 0;
}

//DANTE98ŨX^[^^Cg^ꖇG^퓬wĩ[h
//.dat/.ebd/.egd
EXPORT BOOL WINAPI D2_load (BMSCR *bm, char *filename, int p1, BYTE *pRGB)
{
	HANDLE hFile;
	BYTE *dat,*bmp;
	int x,y,sl,ds4,i;
	int cnt1,cnt2;
	int off,off1,off2,bg_off;
	UINT datsize;
	DWORD _datsize;
	int r,g,b;
	BYTE R,G,B,E,m;

	hFile=CreateFile(filename,GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL);
	datsize=GetFileSize(hFile,0);
	if (datsize==0) return -2;		//t@CȂ

	x=0;
	if (datsize==4850)  { x= 80; y= 96; ds4=960;   sl=2+ds4; }	//X^[
	if (datsize==12850) { x=160; y=128; ds4=2560;  sl=2+ds4; }
	if (datsize==41008) { x=640; y=128; ds4=10240; sl=0; }		//퓬wi
	if (datsize==128048){ x=640; y=400; ds4=32000; sl=0; }		//^Cg^ꖇG

	if (x==0){ CloseHandle(hFile); return -1; }			//DANTE98Ũt@Cł͂Ȃ

	SetFilePointer(hFile,0,0,FILE_BEGIN);
	dat=(BYTE *)malloc(datsize);
	ReadFile(hFile,dat,datsize,&_datsize,0);
	CloseHandle(hFile);

	//---------pbg
	r=0; g=0; b=0;
	for (i=0; i<48; i+=3)
	{
		R=*(dat +i +0);
		G=*(dat +i +1); 
		B=*(dat +i +2); 
		if (datsize==128048)
		{ *(pRGB +i +0)=R; *(pRGB +i +1)=G; *(pRGB +i +2)=B; }
		else
		{ *(pRGB +i +0)=R *17; *(pRGB +i +1)=G *17; *(pRGB +i +2)=B *17; }
		r+=R; g+=G; b+=B;
	}
	*(pRGB +48)=r/16*17; *(pRGB +49)=g/16*17; *(pRGB +50)=b/16*17;
	bms_setpal(bm,256,pRGB);

	sl+=48;

	bmp=bm->pBit;
	for(cnt1=0; cnt1<y; cnt1++)
	{
		off1=cnt1*x/8+sl;
		off2=(y-1-cnt1)*x;

		for(cnt2=0; cnt2<x/8; cnt2++)
		{
			off=cnt2+off1;
			bg_off=cnt2*8+off2;
			d2_setpix(bmp,dat,bg_off,off,ds4);
		}
	}

	if (datsize<12851)
	{
		sl-=ds4;
		for(cnt1=0; cnt1<y; cnt1++)
		{
			off1=cnt1*x/8+sl;
			off2=(y-1-cnt1)*x;
			for(cnt2=0; cnt2<x/8; cnt2++) d2_maskpix(bmp,dat,cnt2*8+off2,off1+cnt2);
		}
	}
	free(dat);


	return 0;
}

//DANTE98ŨL^}bv`bvRo[g
//pbg[hp
//ecd_save "t@C",p1
//p1 F̃pbgNO
EXPORT BOOL WINAPI ecd_save (BMSCR *bm, char *filename, int cp, int p2)
{
	int x,y,z,cx,cy,i,p,cnt1,cnt2,ecdmode,ecd_off,off,ecdsize;
	BYTE m;
	BYTE *ecd,*RGB,*bmp;

	ecdsize=0;
	x=bm->sx;
	y=bm->sy;
	if (x==256 && y==256){ ecdsize=41008;  cx= 8; cy= 8; ecdmode=0; }
	if (x==512 && y==320){ ecdsize=102448; cx=16; cy=10; ecdmode=1; }
	if (ecdsize==0) return -1;

	ecd=(BYTE *)malloc(ecdsize);

	RGB=(BYTE *)bm->pal;
	for(i=0; i<48; i++)
	{
		*(ecd+i*3+0)=*(RGB+i*4+2)>>4;
		*(ecd+i*3+1)=*(RGB+i*4+1)>>4;
		*(ecd+i*3+2)=*(RGB+i*4+0)>>4;
	}

	m=ecdmode*255;
	bmp=bm->pBit;
	for(cnt1=0; cnt1<cx*cy; cnt1++)
	{
		p=cnt1*640+48;
		z=cnt1%cx*32+(cy-1-cnt1/cx)*cx*1024;

		//Z
		for(cnt2=0; cnt2<128; cnt2++)
		{
			off=(31-cnt2/4)*x+(cnt2%4*8)+z;
			ecd_off=cnt2+p;
			d2_putpix(ecd,bmp,ecd_off,off,128,m,cp);
		}
	}
	i=bsave(filename,ecd,ecdsize);
	free(ecd);
	if (i==1) return -256;

	return 0;
}


//DANTE98ŨX^[^^Cg^ꖇG^퓬wi̕ۑ
//.dat/.ebd/.egd
EXPORT BOOL WINAPI D2_save (BMSCR *bm, char *filename, int cp, int p2)
{
	int x,y,z,cx,cy,i,p,sl,ds,cnt1,cnt2,ecdmode,off1,off2,datsize,dat_off,off;
	BYTE m;
	BYTE *dat,*RGB,*bmp;

	x=bm->sx;
	y=bm->sy;
	datsize=0;

	if (x== 80 && y== 96){ datsize=  4850; ds=  960; sl=50; }	//X^[
	if (x==160 && y==128){ datsize= 12850; ds= 2560; sl=50; }
	if (x==640 && y==128){ datsize= 41008; ds=10240; sl=48; }	//퓬wi
	if (x==640 && y==400){ datsize=128048; ds=32000; sl=48; }	//^Cg^ꖇG

	if (datsize==1) return -1;

	dat=(BYTE *)malloc(datsize);
	RGB=(BYTE *)bm->pal;
	if (datsize==128048) p=17; else p=1;
	for(i=0; i<48; i++)
	{
		*(dat+i*3+0)=*(RGB+i*4+2)/17*p;
		*(dat+i*3+1)=*(RGB+i*4+1)/17*p;
		*(dat+i*3+2)=*(RGB+i*4+0)/17*p;
	}

	if (datsize== 12850) *(dat+0x30)=1;
	bmp=bm->pBit;

	if (datsize<12851) m=0; else m=1;
	for(cnt1=0; cnt1<y; cnt1++)
	{
		off1=(y-1-cnt1)*x;
		off2=cnt1*x/8+sl;
		for(cnt2=0; cnt2<x/8; cnt2++)
		{
			off=cnt2*8+off1;
			dat_off=cnt2+off2;
			d2_putpix(dat,bmp,dat_off,off,ds,m,cp);
		}
	}

	i=bsave(filename,dat,datsize);
	free(dat);
	if (i==1) return -256;

	return 0;
}


EXPORT BOOL WINAPI arv_load (BMSCR *bm, char *filename, int p1, BYTE *pRGB)
{
	BYTE *data;
	BYTE *apPAL,*apBMP,*pBit;
	BYTE c;
	int i,p,opn,x,y,sx,sy,bw,prn,datasize;
	int bbit,acnt,bcnt,end;
	int aw,ah;

	datasize=bload(&data,filename);

	i=data[0]<<24|data[1]<<16|data[2]<<8|data[3];
	if ( i!=0x53535F53 ){
		free(data);
		return 0;
	}

	aw=data[0x18]+(data[0x19]<<8);
	ah=data[0x1A]+(data[0x1B]<<8);
	end=aw*ah;

	sx=bm->sx;
	bw=sx +3 & 0xFFFC;
	sy=bm->sy;
	pBit=bm->pBit;

	if (p1==1){
		free(data);
		return -( (ah<<16)+aw );
	}
	if (data[0x10]=='I'){	//vr[
		apPAL=data+0x0800;
		apBMP=data+0x0860;
		datasize-=0x0860;
	}else{
		apPAL=data+0x002A;
		apBMP=data+0x008A;
		datasize-=0x008A;
	}
	if( data[0x12]=='B' ){	//uN
		apBMP+=apBMP[0]+(apBMP[1]<<8);
	}

	for(i=0; i<16; i++){
		pRGB[i*3+0]=apPAL[i*6+0]*17;
		pRGB[i*3+1]=apPAL[i*6+2]*17;
		pRGB[i*3+2]=apPAL[i*6+4]*17;
	}
	memset(pBit,0,sy*bw);

	bbit=-1; acnt=0; bcnt=0; prn=0;
	while(acnt<datasize){
		c=apBMP[acnt];
		if (c == bbit){
			acnt++;
			opn=apBMP[acnt]; if (opn==0) opn=256;
			opn--;
			bbit=-1;
		}else{
			bbit=c;
			opn=1;
		}
		for(p=0; p<opn; p++){		//WJ
			x=bcnt%aw;
			y=bcnt/aw;
			for(i=7; i>=0; i--){	//rbgWJ
				*(pBit +(sy -1-y)*bw +x+(7-i)) |= (c>>i&1)<<prn;
			}
			bcnt+=8;
		}
		if (bcnt==end){
			bbit=-1;
			prn++;
			bcnt=0;
		}
		acnt++;
	}

	bms_setpal(bm,256,pRGB);

	free(data);
	return -1;
}

EXPORT BOOL WINAPI arv_save (BMSCR *bm, char *filename, int p1, int p2)
{
	BYTE *data;
	BYTE *apPAL,*apBMP,*prBMP,*pBit,*pRGB;
	BYTE c;
	int i,p,opn,x,y,sx,sy,bw,prn,datasize;
	int bbit,acnt,bcnt,end;
	int aw,ah;

	sx=bm->sx;
	sy=bm->sy;
	bw=sx +3 & 0xFFFC;
	pBit=bm->pBit;
	end=sx*sy;

	data=(BYTE *)malloc(sx*sy*2);
	memset(data,0,sx*sy*2);

	strcpy((char *)data,"SS_SIF    0.03");
	data[0xE]=0x1A;
	strcpy((char *)(data+0x10),"IR BRGI");

	data[0x17]=0x04;
	data[0x18]=sx   &0xFF;	//TCY
	data[0x19]=sx>>8&0xFF;
	data[0x1A]=sy   &0xFF;
	data[0x1B]=sy>>8&0xFF;

	if (p1==0){	//vr[
		apPAL=data+0x0800;
		apBMP=data+0x0860;
		prBMP=data+0x2E;
		datasize=0x0860;
		data[0x0028]=0xD6;
		data[0x0029]=0x07;
		data[0x002A]=0x50;
		data[0x002C]=0x32;
		data[0x07FE]='b';
	}else{
		data[0x10]=' ';
		apPAL=data+0x002A;
		apBMP=data+0x008A;
		datasize=0x008A;
		data[0x0028]='b';
	}


	//pbg
	pRGB=(BYTE *)bm->pal;
	for(i=0; i<16; i++){
		apPAL[i*6+0]=pRGB[i*4+2]>>4;
		apPAL[i*6+2]=pRGB[i*4+1]>>4;
		apPAL[i*6+4]=pRGB[i*4+0]>>4;
	}

	//vr[f[^
	if (p1==0){
	acnt=0;
	for(prn=0; prn<4; prn++){
		bcnt=0;
		while(bcnt<end/64){
			c=0;
			x=bcnt*8%sx;
			y=bcnt*8/sx*8;
			for(i=7; i>=0; i--){
				c |= ( *(pBit +(sy -1-y)*bw +x+(7-i)*8)>>prn &1 )  <<i;
			}
			bcnt+=8;
			prBMP[acnt]=c;
			acnt++;
		}
	}
	}
	//C
	acnt=0;
	for(prn=0; prn<4; prn++){
		bbit=-1; bcnt=0; opn=1;
		while(bcnt<end){
			c=0;
			x=bcnt%sx;
			y=bcnt/sx;
			for(i=7; i>=0; i--){
				c |= ( *(pBit +(sy -1-y)*bw +x+(7-i))>>prn &1 )  <<i;
			}
			bcnt+=8;
			if (c==bbit) opn++;
			if (c!=bbit || opn==256 || bcnt==end){
				if (opn>1){
					apBMP[acnt]=bbit;
					apBMP[acnt+1]=opn&255;
					acnt+=2;
				}
				if (bcnt<end && opn<256){
					apBMP[acnt]=c;
					acnt++;
				}
				
				if (opn==256) bbit=-1;
				else bbit=c;
				opn=1;
			}
		}
	}
	datasize+=acnt;
//	i=bsave(filename,data,datasize);
	i=0;
	if (bsave(filename,data,datasize)==1) i=1;

	return -i;
}

int getALfunc ()
{
	static AL_FUNC al_func;

	al_func.AL_pget=pget2;
	al_func.bsave=bsave;
	al_func.bload=bload;
	al_func.AL_lpset=AL_lpset;
	al_func.pal_app=pal_app2;
	al_func.bms_setpal=bms_setpal;

	return (int)&al_func;
}
