#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <math.h>

#include "..\Hspdll.h"
#include "Hspsdk.c"
#include "RGBtoHSV2.c"

#define ERROR_LIMIT 255<<16
#define AT_MAX 9
#define VERSION_NAME "0.05"
#define VERSION_CODE 5
typedef struct APP_TABLE
{
	BYTE at[32][32][32][AT_MAX];
}APP_TABLE;

APP_TABLE *app_table;
//int appm_table[32][32][32];
BYTE HSVset[1024];

int mBFW,mW,mH,mPal;		//cDown_setŐݒ肳f[^
BMSCR *mbm;

BYTE *mpBMP;
RGBQUAD *mpRGB;
int *impRGB;
int mod2_tb[513];
int *mod2;
BYTE *enPal;
int enPalcnt;
int atMax;
int mask[17]={
	0xffff,0xfffe,0xfbfe,0xfbfa,
	0xfafa,0xfada,0x7ada,0x7a5a,
	0x5a5a,0x5a58,0x5258,0x5250,
	0x5050,0x5040,0x1040,0x1000,0x0000 };

BYTE *notpalHSP=NULL;
BYTE *notpal=NULL;

EXPORT BOOL WINAPI DllMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
	switch (fdwReason){
		case DLL_PROCESS_ATTACH:
			int i;
			for(i=0; i<256; i++) mod2_tb[i+256]=i*i;
			for(i=0; i<256; i++) mod2_tb[i+1]=mod2_tb[511-i];
			mod2_tb[512]=256*256;
			mod2=mod2_tb+256;
		break;
	default:
		break;
	}
	return TRUE;
}
////////////////////////////////////////////
EXPORT BOOL WINAPI cDown_getver (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	strcpy(hei->refstr,VERSION_NAME);
	*hei->strsize=strlen(VERSION_NAME);

	return -(VERSION_CODE);
}

EXPORT BOOL WINAPI cDown_set (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	//p[^擾///////
		BMSCR *bm;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		if (*hei->er) return *hei->er;
	///////////////////////

		mPal    =(bm->palmode==0)*2+1;
		mBFW	=bm->sx*mPal +3 & 0xFFFC;	//1ӂ̃obt@TCY
		mpBMP	=bm->pBit;
		mpRGB	=bm->pal;
		mW		=bm->sx;					//̃EBhẼTCY
		mH		=bm->sy;
		mbm		=bm;
	impRGB=(int *)mpRGB;

	return 0;
}

//gpȂpbg̐ݒ
//p1 ϐA܂̓|C^̓ϐ
//p2 0 p1̕ϐ|C^
//   1 p1̒l|C^ɂ
EXPORT BOOL WINAPI cDown_notpal (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	//p[^擾///////
		int *p1,p2;
		p1=(int *)hei->HspFunc_prm_getv();
		p2=hei->HspFunc_prm_getdi(0);
		if (*hei->er) return *hei->er;
	///////////////////////

	if (p2==0) notpalHSP=(BYTE *)p1; else notpalHSP=(BYTE *)*p1;

	return 0;
}

//F̋o---------------------
int RGBlenge(BYTE *pRGB,int r,int g,int b){
	return mod2[pRGB[2]-r]+mod2[pRGB[1]-g]+mod2[pRGB[0]-b];
}
int HSVlenge(BYTE *pHSV,int h,int s,int v){
	int y1=v;
	int x1=min(h-*pHSV&255,*pHSV-h&255)*y1*s>>15;
	int x2=(pHSV[1]-s)*y1>>8;
	return mod2[x1]+mod2[x2]+mod2[pHSV[2]-v];
}
int HSLlenge(BYTE *pHSL,int h,int s,int l){
	int y1=(128-abs(l-128))*2;
	int x1=min(h-*pHSL&255,*pHSL-h&255)*y1*s>>15;
	int x2=(pHSL[1]-s)*y1>>8;
	return mod2[x1]+mod2[x2]+mod2[pHSL[2]-l];
}
int YUVlenge(BYTE *pYUV,int y,int u,int v){
	return mod2[pYUV[0]-y]+mod2[pYUV[1]-u]+mod2[pYUV[2]-v];
}
//-----------------------------------

int app_pal3(BYTE *table,RGBQUAD *pRGB,int r,int g,int b)
{
	int p,i,c,t,ss;
	int sp[AT_MAX]={0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,
	                0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF};
	BYTE *tpRGB =(BYTE *)pRGB;
	t=0;

	for(i=0; i<enPalcnt; i++)
	{
		p=RGBlenge(tpRGB+enPal[i]*4,r,g,b);
		if (p<sp[t]){
			sp[t]=p; table[t]=enPal[i];
			ss=0;
			for(c=0; c<atMax; c++){ if (sp[c]>ss){ss=sp[c]; t=c;} }
		}
	}

	return 0;
}
int appTable(BYTE *pRGB,int r,int g,int b,int type){
	int sp=0x7FFFFFFF;
	int i,p,s;
	int hsv[3];
	BYTE *a_t=&app_table->at[r>>3][g>>3][b>>3][0];
	hsv[0]=r; hsv[1]=g; hsv[2]=b;

	switch(type){
		case 1:
			RGBtoHSV(hsv);
			for(i=0; i<atMax; i++){
				p=HSVlenge(HSVset+a_t[i]*4,hsv[0],hsv[1],hsv[2]);
				if (p<sp){ sp=p; s=i; }
			}
			break;
		case 2:
			RGBtoHSL(hsv);
			for(i=0; i<atMax; i++){
				p=HSLlenge(HSVset+a_t[i]*4,hsv[0],hsv[1],hsv[2]);
				if (p<sp){ sp=p; s=i; }
			}
			break;
		case 3:
			RGBtoYUV(hsv);
			for(i=0; i<atMax; i++){
				p=YUVlenge(HSVset+a_t[i]*4,hsv[0],hsv[1],hsv[2]);
				if (p<sp){ sp=p; s=i; }
			}
			break;
		default:
			for(i=0; i<atMax; i++){
				p=RGBlenge(pRGB+a_t[i]*4,r,g,b);
				if (p<sp){ sp=p; s=i; }
			}
			break;
	}
	return a_t[s];
}

void createHSVtable(RGBQUAD *tpRGB, int p1){
	int i;
	int rgb[3];

	if (p1==0) return;
	ZeroMemory(HSVset,sizeof(HSVset));

	for(i=0; i<256; i++){
		rgb[0]=tpRGB[i].rgbRed;
		rgb[1]=tpRGB[i].rgbGreen;
		rgb[2]=tpRGB[i].rgbBlue;
		switch(p1){
			case 1: RGBtoHSV(rgb); break;
			case 2: RGBtoHSL(rgb); break;
			case 3: RGBtoYUV(rgb); break;
		}
		HSVset[i*4+0]=rgb[0];
		HSVset[i*4+1]=rgb[1];
		HSVset[i*4+2]=rgb[2];
	}
	return;
}

int hsv_app (BYTE *table,int r, int g, int b, int p1)
{
	int rgb[3];
	int h,s,v,t,c,ss;
	int sp[AT_MAX]={0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,
	                0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF,0x7FFFFFFF};
	int appPalette;
	int p,i,a,x1,y1,x2,y2;
	BYTE *mpHSV=HSVset;
	BYTE *mHSVset=HSVset;

	rgb[0]=r; rgb[1]=g; rgb[2]=b;
	switch(p1){
		case 1: RGBtoHSV(rgb); break;
		case 2: RGBtoHSL(rgb); break;
		case 3: RGBtoYUV(rgb); break;
	}
	h=rgb[0]; s=rgb[1]; v=rgb[2];

	t=0;
	switch(p1){
	case 1:		//HSV
		for(i=0; i<enPalcnt; i++){
				p=HSVlenge(HSVset+enPal[i]*4,h,s,v);
				if (p<sp[t]){
					sp[t]=p; table[t]=enPal[i];
					ss=0;
					for(c=0; c<atMax; c++){ if (sp[c]>ss){ss=sp[c]; t=c;} }
				}
		}
		break;
	case 2:		//HSL
		for(i=0; i<enPalcnt; i++){
				p=HSLlenge(HSVset+enPal[i]*4,h,s,v);
				if (p<sp[t]){
					sp[t]=p; table[t]=enPal[i];
					ss=0;
					for(c=0; c<atMax; c++){ if (sp[c]>ss){ss=sp[c]; t=c;} }
				}
		}
		break;
	case 3:		//YUV
		for(i=0; i<enPalcnt; i++){
			p=YUVlenge(HSVset+enPal[i]*4,h,s,v);
			if (p<sp[t]){
				sp[t]=p; table[t]=enPal[i];
				ss=0;
				for(c=0; c<atMax; c++){ if (sp[c]>ss){ss=sp[c]; t=c;} }
			}
		}
		break;
	}
	return 0;
}


void createApppal(RGBQUAD *tpRGB, int p1){
	int r,g,b;
	if (app_table==NULL) app_table=(APP_TABLE *)malloc(sizeof(APP_TABLE));
	ZeroMemory(app_table,sizeof(APP_TABLE));

	switch(p1){
		case 0:
			for(r=0; r<32; r++){
			for(g=0; g<32; g++){
			for(b=0; b<32; b++){
				app_pal3(&app_table->at[r][g][b][0],tpRGB,r*8+4,g*8+4,b*8+4);
			}}}
		break;
		default:
			for(r=0; r<32; r++){
			for(g=0; g<32; g++){
			for(b=0; b<32; b++){
				hsv_app(&app_table->at[r][g][b][0],r*8+4,g*8+4,b*8+4,p1);
			}}}
		break;
	}
	return;
}
/*
void createAppmeth(RGBQUAD *tpRGB){
	for(r=0; r<32; r++){
	for(g=0; g<32; g++){
	for(b=0; b<32; b++){
		appm_table[r][g][b]=app_meth(r*8+4,g*8+4,b*8+4);
	}}}
	return;
}
*/
//get_meth
int app_meth(BYTE *pRGB,int r,int g,int b,int add)
{
	int p,p2,i,k,s2,len,alen,blen;
	int a1,a2,a3;
	int s=0;
	int R,G,B,R2,G2,B2,RGB;
	int sp=0x7FFFFFFF;

	if (r<0) r=0; if (g<0) g=0; if (b<0) b=0;
	if (r>255) r=255; if (g>255) g=255; if (b>255) b=255;

	s=appTable(pRGB,r,g,b,0);
	R=pRGB[s*4+2];
	G=pRGB[s*4+1];
	B=pRGB[s*4+0];
	if (r==R && g==G && b==B) return (s<<8)+s;

	int pm=abs(B-b)+abs(G-g)+abs(R-r);	//ߎFƐ^̐FƂ̍
	for(i=0 ;i<enPalcnt ; i++)
	{
		p=enPal[i]*4;
		R2=pRGB[p+2];					//⊮F
		G2=pRGB[p+1];
		B2=pRGB[p+0];

		p=abs(B2-b)+abs(G2-g)+abs(R2-r);
		k=pm*16/(p+pm);					//Kɔ
		p+=mod2[(B2*k+B*(16-k)>>4)-b]+mod2[(G2*k+G*(16-k)>>4)-g]+mod2[(R2*k+R*(16-k)>>4)-r];

		if (p<sp){ sp=p; s2=enPal[i]; }
	}

	R2=pRGB[s2*4+2];
	G2=pRGB[s2*4+1];
	B2=pRGB[s2*4+0];
	sp=0x7FFFFFFF;
	for(k=0; k<9; k+=add){
		p=mod2[(B2*k+B*(16-k)>>4)-b]+mod2[(G2*k+G*(16-k)>>4)-g]+mod2[(R2*k+R*(16-k)>>4)-r];
		if (p>sp) break;
		sp=p;
	}
	len=k-add;

	if (s>s2){ i=s; s=s2; s2=i; len=16-len; }

	s=(len<<16)+(s2<<8)+s;
	return s;
}

void Floyd(int *VRAM,int w,int h,int x,int y,int r,int g,int b)
{
	int i,pR,pG,pB;
	int *V;
	int jX[4]={1,-1,0,1};
	int jY[4]={0,1,1,1};
	int jZ[4]={7,3,5,1};

	V=VRAM+y*w*3+x*3;
	for(i=0; i<3; i++){
		if (V[i]<(255<<16)-ERROR_LIMIT) V[i]=(255<<16)-ERROR_LIMIT;
		if (V[i]>ERROR_LIMIT) V[i]=ERROR_LIMIT;
	}

	pB=V[0]-(b<<16);
	pG=V[1]-(g<<16);
	pR=V[2]-(r<<16);

	for(i=0; i<4; i++)
	{
		if (x+jX[i]>-1 && x+jX[i]<w && y+jY[i]<h)
		{
			V = VRAM+(y+jY[i])*w*3+(x+jX[i])*3;
			V[0]+=pB*jZ[i]/16;
			V[1]+=pG*jZ[i]/16;
			V[2]+=pR*jZ[i]/16;
		}
	}

	return;
}
void Jarvice(int *VRAM,int w,int h,int x,int y,int r,int g,int b)
{
	int i,pR,pG,pB;
	int *V;
	int jX[12]={1,2,-2,-1,0,1,2,-2,-1,0,1,2};
	int jY[12]={0,0,1,1,1,1,1,2,2,2,2,2};
	int jZ[12]={7,5,3,5,7,5,3,1,3,5,3,1};

	V=VRAM+y*w*3+x*3;

	for(i=0; i<3; i++){
		if (V[i]<(255<<16)-ERROR_LIMIT) V[i]=(255<<16)-ERROR_LIMIT;
		if (V[i]>ERROR_LIMIT) V[i]=ERROR_LIMIT;
	}

	pB=V[0]-(b<<16);
	pG=V[1]-(g<<16);
	pR=V[2]-(r<<16);

	for(i=0; i<12; i++)
	{
		if (x+jX[i]>-1 && x+jX[i]<w && y+jY[i]<h)
		{
			V = VRAM+(y+jY[i])*w*3+(x+jX[i])*3;
			V[0]+=pB*jZ[i]/48;
			V[1]+=pG*jZ[i]/48;
			V[2]+=pR*jZ[i]/48;
		}
	}

	return;
}


EXPORT BOOL WINAPI createPal (HSPEXINFO *hei, int p1, int p2, int p3)
{
	//p[^擾///////
		BMSCR *bm;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		if (*hei->er) return *hei->er;
	///////////////////////

	int x,y,i,R,G,B;
	BYTE *pPal,*pBYTE;
	UINT *tb,*tm;
	tm=(UINT *)malloc(4096);
	pPal=(BYTE *)malloc(768);
	ZeroMemory(tm,4096);
	ZeroMemory(pPal,768);
	int rgb[3],t;

	for(y=0; y<mH; y++){
		pBYTE=mpBMP+(mH-1-y)*mBFW;
		for(x=0; x<mW; x++){
			R=pBYTE[2]; G=pBYTE[1]; B=pBYTE[0];
			rgb[0]=R; rgb[1]=G; rgb[2]=B; RGBtoHSV(rgb);

			for(t=0; t<3; t++){
				tb=tm+(rgb[t]/4+t*80)*4;
				tb[0]+=rgb[0]; tb[1]+=rgb[1]; tb[2]+=rgb[2];
				tb[3]++;
			}
			pBYTE+=3;
		}
	}
	tb=tm;
	for(i=0; i<64; i++){
		if (tb[3]){
				pPal[i*3+0]=i*4; pPal[i*3+1]=tb[1]/tb[3]; pPal[i*3+2]=tb[2]/tb[3];
		}
		tb+=4;
	}
	tb=tm+80*4;
	for(i=0; i<64; i++){
		if (tb[3]){
				pPal[i*3+240]=tb[0]/tb[3]; pPal[i*3+241]=i*4; pPal[i*3+242]=tb[2]/tb[3];
		}
		tb+=4;
	}
	tb=tm+160*4;
	for(i=0; i<64; i++){
		if (tb[3]){
				pPal[i*3+480]=tb[0]/tb[3]; pPal[i*3+481]=tb[1]/tb[3]; pPal[i*3+482]=i*4;
		}
		tb+=4;
	}

	for(i=0; i<768; i+=3){
		rgb[0]=pPal[i+0]; rgb[1]=pPal[i+1]; rgb[2]=pPal[i+2];
		HSVtoRGB(rgb);
		pPal[i+0]=rgb[0]; pPal[i+1]=rgb[1]; pPal[i+2]=rgb[2];
	}

	bms_setpal(bm,256,pPal);
	free(pPal);
	free(tm);
	return 0;
}

int getenpal(RGBQUAD *tpRGB){
	static int cRGB[256];
	int a,x,i,t,np=0;
	int *piRGB=(int *)tpRGB;

	enPalcnt=0;
	for(i=255; i>=0; i--){
		t=((notpal[i]&1)<<24)+piRGB[i];
		if (cRGB[i]!=t) np=-1;	//ȑOƃpbgႤ
		cRGB[i]=t;
		if (notpal[i]&1) continue;

		a=(tpRGB[i].rgbBlue<<16)+(tpRGB[i].rgbGreen<<8)+tpRGB[i].rgbRed;
		for(x=i-1; x>=0; x--){
			if ( a==(tpRGB[x].rgbBlue<<16)+(tpRGB[x].rgbGreen<<8)+tpRGB[x].rgbRed && (notpal[x]&1)==0 ) break;
		}
		if (x==-1){
			enPal[enPalcnt]=i;
			enPalcnt++;
		}
	}
	if (enPalcnt<AT_MAX) atMax=enPalcnt; else atMax=AT_MAX;
	return np;
}

void bf_intgcopy(int *pINT,int *pC,int p1, int p2, int gx, int gy){
	BYTE *pBYTE,*pm;
	int x,y;

	if (mPal==3){	//tJ[
		for(y=0; y<gy; y++){
			pBYTE=mpBMP+(mH-1-y-p2)*mBFW+p1*3;
			for(x=0; x<gx; x++){
				pINT[0]=pBYTE[0] <<16;
				pINT[1]=pBYTE[1] <<16;
				pINT[2]=pBYTE[2] <<16;
				*pC=(pBYTE[2]<<16)+(pBYTE[1]<<8)+pBYTE[0];
				pBYTE+=3; pINT+=3; pC++;
			}
		}
	}else{			//pbg
		for(y=0; y<gy; y++){
			pm=mpBMP+(mH-1-y-p2)*mBFW+p1;
			for(x=0; x<gx; x++){
				pBYTE=(BYTE *)mpRGB+ *(pm+x)*4;
				pINT[0]=pBYTE[0] <<16;
				pINT[1]=pBYTE[1] <<16;
				pINT[2]=pBYTE[2] <<16;
				*pC=(pBYTE[2]<<16)+(pBYTE[1]<<8)+pBYTE[0];
				pINT+=3; pC++;
			}
		}
	}
	return;
}


void app_copy(BMSCR *bm,int cx,int cy,int p1,int p2,int gx,int gy,int type)
{
	int i,x,y,p,s,sp;
	int rgb[3];
	BYTE *appTB,*hs,*by,*mby;
	RGBQUAD *tpRGB =bm->pal;
	appTB=(BYTE *)malloc(256);

	createHSVtable(tpRGB,type);
	notpal=(BYTE *)malloc(256);	ZeroMemory(notpal,256);
	if (notpalHSP) memcpy(notpal,notpalHSP,256);

	for(i=0; i<256; i++)
	{
		//pbgȂ炻̂܂
		if (((notpal[i]&1)==0) && mpRGB[i].rgbRed==tpRGB[i].rgbRed
			&& mpRGB[i].rgbGreen==tpRGB[i].rgbGreen && mpRGB[i].rgbBlue==tpRGB[i].rgbBlue){
			appTB[i]=i; continue;
		}
		rgb[0]=mpRGB[i].rgbRed; rgb[1]=mpRGB[i].rgbGreen; rgb[2]=mpRGB[i].rgbBlue;
		switch(type)
		{
			case 1: RGBtoHSV(rgb); break;
			case 2: RGBtoHSL(rgb); break;
			case 3: RGBtoYUV(rgb); break;
			default: break;
		}

		if (type==0) hs=(BYTE *)tpRGB; else hs=HSVset;
		sp=0x7FFFFFFF;
		for(x=0; x<256; x++)
		{
			if (notpal[x]&1){ hs+=4; continue; }
			switch(type)
			{
				case 1:  p=HSVlenge(hs,rgb[0],rgb[1],rgb[2]); break;
				case 2:  p=HSLlenge(hs,rgb[0],rgb[1],rgb[2]); break;
				case 3:  p=YUVlenge(hs,rgb[0],rgb[1],rgb[2]); break;
				default: p=RGBlenge(hs,rgb[0],rgb[1],rgb[2]); break;
			}
			hs+=4;
			if (p<sp){ sp=p; s=x; }
		}
		appTB[i]=s;
	}

	for(y=0; y<gy; y++){
		by=bm->pBit+(bm->sy-1-y-cy)*(bm->sx+3&0xFFFC)+cx;
		mby=mpBMP+(mH-1-y-p2)*mBFW+p1;
		for(x=0; x<gx; x++) *(by+x)=appTB[*(mby+x)];
	}

	free(appTB);
	free(notpal); notpal=NULL;

	return;
}


//p1,p2
//p3 0 ߎF
//   1 Floyd
//   2 Jarvice
//   3 ^C  ^C16iK
//		+0x100 ^C2iK
//		+0x200 ^C4iK
//		+0x300 ^C8iK
//		+0x400 ^C16iK
// +0x00000 RGB
// +0x10000 HSV
// +0x20000 HSL
// +0x30000 YUV

EXPORT BOOL WINAPI cDown (HSPEXINFO *hei, int p1, int p2, int p3)
{
	//p[^擾///////
		BMSCR *bm;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		p1=hei->HspFunc_prm_getdi(0);
		p2=hei->HspFunc_prm_getdi(0);
		p3=hei->HspFunc_prm_getdi(0);
		if (*hei->er) return *hei->er;
	///////////////////////

	int i,a,x,y,by,pno,cx,cy,gx,gy,bw,r,g,b,p,sp;
	int *pIntVRAM,*pINT,*pColor,*pC;
	int trPal=-1,trColor=-1;
	BYTE *pBYTE,*pBF,*chRGB;
	RGBQUAD *tpRGB =bm->pal;
	BYTE *pRGB=(BYTE *)tpRGB;
	static int cRGB[256];
	static int cmdl=-1;
	
	cx=bm->cx; cy=bm->cy;
	gx=bm->gx; gy=bm->gy;

	if (cx<0)			{ gx+=cx; p1-=cx; cx=0; }
	if (cy<0)			{ gy+=cy; p2-=cy; cy=0; }
	if (gx+cx >bm->sx)	{ gx =bm->sx-cx; }
	if (gy+cy >bm->sy)	{ gy =bm->sy-cy; }

	if (p1<0)			{ gx+=p1; cx-=p1; p1=0; }
	if (p2<0)			{ gy+=p2; cy-=p2; p2=0; }
	if (gx+p1 >mW)		{ gx =mW-p1; }
	if (gy+p2 >mH)		{ gy =mH-p2; }


	if (mPal==1 && (p3&0xFF)==0){
		app_copy(bm,cx,cy,p1,p2,gx,gy,p3>>16&0xFF);
		return 0;
	}

	pColor   =(int *)malloc(gx*gy*4);
	chRGB    =(BYTE *)malloc(16*16*16*257); ZeroMemory(chRGB,16*16*16*257);
	pIntVRAM =(int *)malloc(gx*gy*12);
	pBF      =(BYTE *)malloc(gx*gy);
	enPal    =(BYTE *)malloc(256);
	notpal   =(BYTE *)malloc(256); ZeroMemory(notpal,256);
	if (notpalHSP) memcpy(notpal,notpalHSP,256);
/*
	if ((p3>>20&0xF)==1){
		i=(int)bm->color;
		a=(i>>16)+(i&0xFF00)+((i&0xFF)<<16);
		for(i=0; i<256; i++){
			if ( ((int *)tpRGB)[i]==a ){
				trColor=a;
				trPal=i;
				notpal[i]|=1;
				break;
			}
		}
	}
*/
	by=getenpal(tpRGB);	//Lpbg̑I
	if (enPalcnt==0){
		free(chRGB);
		free(pIntVRAM);
		free(pBF);
		free(enPal);
		free(pColor);
		free(notpal);
		return 311;
	}
	bf_intgcopy(pIntVRAM,pColor,p1,p2,gx,gy);	//INT^̃obt@փRs[


	//e[u쐬
	if (by==-1 || app_table==NULL || ((p3>>16&0xF)!=cmdl)){
		cmdl=p3>>16&0xF;
		createHSVtable(tpRGB,cmdl);
		createApppal(tpRGB,cmdl);
	}

	//F
	pINT=pIntVRAM;
	pC=pColor;
	pBYTE=pBF;
	int add=(p3>>8)&0xFF;
	if (add==0) add=4;
	add=16>>add;

	p3=p3&0xFF;
	for(y=0; y<gy; y++){ for(x=0; x<gx; x++){
			r=pINT[2]>>16; g=pINT[1]>>16; b=pINT[0]>>16;
			if (r<0) r=0; if (g<0) g=0; if (b<0) b=0;
			if (r>255) r=255; if (g>255) g=255; if (b>255) b=255;

			if ( *pC == trColor )
				a=256;
			else
				a=p3;

			switch(a)
			{
					case 1:
						pno=appTable(pRGB,r,g,b,cmdl);
						Floyd(pIntVRAM,gx,gy,x,y,
							tpRGB[pno].rgbRed,tpRGB[pno].rgbGreen,tpRGB[pno].rgbBlue);
						break;
					case 2:
						pno=appTable(pRGB,r,g,b,cmdl);
						Jarvice(pIntVRAM,gx,gy,x,y,
							tpRGB[pno].rgbRed,tpRGB[pno].rgbGreen,tpRGB[pno].rgbBlue);
						break;
					case 3:
						a=app_meth(pRGB,r,g,b,add);
						i=(x+cx&3)+(y+cy&3)*4;
						(1<<i)&mask[a>>16] ? pno=a&0xFF : pno=a>>8&0xFF;
						break;
					case 256:
						pno=trPal;
						break;
					default:
						pno=appTable(pRGB,r,g,b,cmdl);
						break;
			}

			*pBYTE=pno;
			pINT+=3; pC++;
			pBYTE++;
	}}

	//Rs[
	bw=bm->sx+3&0xFFFC;
	for(y=0; y<gy; y++){
		by=(bm->sy-1-y-cy)*bw;
		for(x=0; x<gx; x++){
			*(bm->pBit+by+x+cx)=*(pBF+y*gx+x);
		}
	}

	free(chRGB);
	free(pIntVRAM);
	free(pBF);
	free(enPal);
	free(pColor);
	free(notpal);

	return 0;
}

EXPORT BOOL WINAPI cDown_end (HSPEXINFO *hei, int p1, int p2, int p3)
{
	if (app_table) free(app_table);
	app_table=NULL;
	return 0;
}
