#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <math.h>

#include "..\Hspdll.h"
#include "common\bit.h"


int mhPal,mhBFW,mhW,mhH;
BMSCR *mhbm;
BYTE *mhpBMP;
RGBQUAD *mhpRGB;
BYTE *layerBMP;
int layermhPal,layermhW,layermhH,layermhBFW;

EXPORT BOOL WINAPI h2_set (BMSCR *bm, int p1, int p2, int p3)
{
	if (p1==1){
		layermhPal	=(bm->palmode==0)*2+1;
		layerBMP	=bm->pBit;
		layermhW	=bm->sx;
		layermhH	=bm->sy;
		layermhBFW	=bm->sx*layermhPal +3 & 0xFFFC;
	}else{
		mhPal   	=(bm->palmode==0)*2+1;
		mhBFW		=bm->sx*mhPal +3 & 0xFFFC;	//1ӂ̃obt@TCY
		mhpBMP		=bm->pBit;
		mhpRGB		=bm->pal;
		mhW			=bm->sx;					//̃EBhẼTCY
		mhH			=bm->sy;
		mhbm		=bm;
	}
	return 0;
}

EXPORT BOOL WINAPI h2_pget (BMSCR *bm, int p1, int p2, int p3)
{
	if (p1 <0 || p2 <0 || p1 >bm->sx || p2 >bm->sy) return -(0x1000000);
	if (bm->palmode==0)
	{
		BYTE *m;
		m=bm->pBit +((bm->sy -1-p2)*(bm->sx*3 +3 & 0xFFFC) )+p1*3;
		return -(m[2]<<16|m[1]<<8|m[0]);
	}
	else
	{
		return -( *(bm->pBit +((bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) )+p1) );
	}
}

//p3=0 p1p2̐Fɂ
//  =1 p1p2̐FւB
//gmode	͈
//pos	ʒu
EXPORT BOOL WINAPI h2_pchg (BMSCR *bm, int p1, int p2, int p3)
{
		int x,y;
		BYTE *p;

		for(y=0; y<bm->gy; y++){
			for(x=0; x<bm->gx; x++){
				p=bm->pBit +((bm->sy -1-bm->cy-y)*(bm->sx +3 & 0xFFFC) )+bm->cx+x;
				if (*p==p1){
					*p=p2;
				}else if (*p==p2 && p3==1){
					*p=p1;
				}		
			}
		}
		return 0;
}

//p3<0          ]
//p3==0x1000000 `悵Ȃ
//p3& 0x2000000 Z
EXPORT BOOL WINAPI h2_pset (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE *p;
	int c;

	if (p1 <0 || p2 <0 || p1 >=bm->sx || p2 >=bm->sy || p3==0x1000000) return -256;

	if (bm->palmode==0){
		p=bm->pBit +(bm->sy -1-p2)*(bm->sx*3 +3 & 0xFFFC) +p1*3;
		if (p3<0){
			p3=-p3;
			*p    ^=p3    &255;
			*(p+1)^=p3>> 8&255;
			*(p+2)^=p3>>16;
		}else{
			if (p3&0x2000000){
				p3=p3&0xFFFFFF;
				c=*p+(p3&255);		if (c>255) c=255; *p=c; p++;
				c=*p+(p3>>8&255);	if (c>255) c=255; *p=c; p++;
				c=*p+(p3>>16);		if (c>255) c=255; *p=c;
			}else{
				*p    =p3    &255;
				*(p+1)=p3>> 8&255;
				*(p+2)=p3>>16;
			}
		}
	}else{
		p=bm->pBit +(bm->sy -1-p2)*(bm->sx +3 & 0xFFFC) +p1;
		if (p3<0)
			*p^=-p3;
		else
			*p=p3;
	}

	return 0;
}

//posō̍W
//p1,p2E̍W
EXPORT BOOL WINAPI h2_box (BMSCR *bm, int p1, int p2, int p3)
{
	int cx,cy,w,h,mm,x,y,mx,my,sx,sy;
	BYTE *m,*mp;

	cx=bm->cx;
	cy=bm->cy;
	sx=bm->sx;
	sy=bm->sy;
	mx=p1;	if (mx>=sx) mx=sx-1;
	my=p2;	if (my>=sy) my=sy-1;
	if (cx>=sx || cy>=sy || p1<0 || p2<0) return 0;

	y=cy; if (y<0) y=0;
	m=bm->pBit +(sy-1-y)*(sx +3 & 0xFFFC);

	mm=sx +3 & 0xFFFC;
	w=mx-cx;
	h=my-cy;
	if (cx<0) w=mx;
	if (cy<0) h=my;
	h=mm*h;


	if (p3<0){
		p3=-p3;

		//
		if (cy>=0){
			x=cx;	if (cx<0) x=0;
			while(x<=mx){
				*(m+x)^=p3;
				x++;
			}
		}
		//
		if (p2<sy){
			x=cx;	if (cx<0) x=0;
			while(x<=mx){
				*(m-h+x)^=p3;
				x++;
			}
		}
		if (cx>0) m+=cx;
		cy+=1; my-=1;
		//
		if (cx>=0){
			mp=m;
			y=cy;	if (cy<0) y=0;
			while(y<=my){
				mp-=mm;
				*mp^=p3;
				y++;
			}
		}
		//E
		if (p1<sx){
			mp=m;
			y=cy;	if (cy<0) y=0;
			while(y<=my){
				mp-=mm;
				*(mp+w)^=p3;
				y++;
			}
		}
		return 0;
	}

	//
	if (cy>=0){
		x=cx;	if (cx<0) x=0;
		while(x<=mx){
			*(m+x)=p3;
			x++;
		}
	}
	//
	if (p2<sy){
		x=cx;	if (cx<0) x=0;
		while(x<=mx){
			*(m-h+x)=p3;
			x++;
		}
	}
	if (cx>0) m+=cx;
	//
	if (cx>=0){
		mp=m;
		y=cy;	if (cy<0) y=0;
		while(y<=my){
			*mp=p3;
			mp-=mm;
			y++;
		}
	}
	//E
	if (p1<sx){
		mp=m;
		y=cy;	if (cy<0) y=0;
		while(y<=my){
			*(mp+w)=p3;
			mp-=mm;
			y++;
		}
	}

	return 0;
}

EXPORT BOOL WINAPI h2_boxf (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	//-----------------------------------------------------
		BMSCR *bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		int p1=hei->HspFunc_prm_getdi(0);	// X
		int p2=hei->HspFunc_prm_getdi(0);	//@@ Y
		int p3=hei->HspFunc_prm_getdi(bm->sx-1);	//E X
		int p4=hei->HspFunc_prm_getdi(bm->sy-1);	//@@ Y
		int p5=hei->HspFunc_prm_getdi(0);	//pbgNo
		if (*hei->er) return *hei->er;
	//-----------------------------------------------------

	int bfx,x;
	BYTE *y,*sY,*eY;

	if (p1>=bm->sx||p2>=bm->sy||p3<0||p4<0) return 0;
	if (p1<0) p1=0;
	if (p2<0) p2=0;
	if (p3>=bm->sx) p3=bm->sx-1;
	if (p4>=bm->sy) p4=bm->sy-1;

	x=p3-p1+1;
	bfx=bm->sx +3 & 0xFFFC;

	sY=(bm->sy-1-p4)*bfx+bm->pBit +p1;
	eY=sY+bfx*(p4-p2);

	for (y=sY; y<=eY; y+=bfx) memset( y,p5,x );

	return 0;
}

//p1 x
//p2 Ԋu(1`)
//p3 FNo
EXPORT BOOL WINAPI h2_vline (BMSCR *bm, int p1, int p2, int p3)
{
	int y=0;
	int mm;
	BYTE *m;

	if (bm->palmode==0)
	{
		int r,g,b;
		m=bm->pBit +(bm->sy -1-(bm->sy-1))*(bm->sx*3 +3 & 0xFFFC)+p1*3;
		mm=(bm->sx*3 +3 & 0xFFFC)*p2;

		r=p3>>16;
		g=p3>>8&255;
		b=p3&255;

		while(y< bm->sy){
			m[0]=b; m[1]=g; m[2]=r;
			m+=mm;
			y+=p2;
		}
	}
	else
	{
		m=bm->pBit +(bm->sy -1-(bm->sy-1))*(bm->sx +3 & 0xFFFC)+p1;
		mm=(bm->sx +3 & 0xFFFC)*p2;

		while(y< bm->sy){
			*m=p3;
			m+=mm;
			y+=p2;
		}
	}
	return 0;
}
//p1 y
EXPORT BOOL WINAPI h2_hline (BMSCR *bm, int p1, int p2, int p3)
{
	int x=0;
	BYTE *m;
	if (bm->palmode==0)
	{
		int r,g,b;
		m=bm->pBit +(bm->sy -1-p1)*(bm->sx*3 +3 & 0xFFFC);

		r=p3>>16;
		g=p3>>8&255;
		b=p3&255;

		while(x< bm->sx){
			m[0]=b; m[1]=g; m[2]=r;
			m+=p2*3;
			x+=p2;
		}
	}
	else
	{
		m=bm->pBit +(bm->sy -1-p1)*(bm->sx +3 & 0xFFFC);
		while(x< bm->sx){
			*m=p3;
			m+=p2;
			x+=p2;
		}
	}
	return 0;
}

/*
	h2_setŃRs[
	p1,p2Rs[W
	p3 ߃pbgNo(-1œߖ)
*/
EXPORT BOOL WINAPI h2_gcopy (BMSCR *bm, int p1, int p2, int p3)
{
	int x,y;
	int cx,cy,gx,gy,sx,sy,i;
	int bf;
	BYTE *mm,*tm;
	BYTE *pm[2];

	cx=bm->cx; cy=bm->cy;
	gx=bm->gx; gy=bm->gy;
	sx=bm->sx; sy=bm->sy;

	if (cx<0){ gx+=cx; p1-=cx; cx=0; }
	if (cy<0){ gy+=cy; p2-=cy; cy=0; }
	if (gx<=0 || gy<=0) return 0;

	if (cx+gx>sx) gx=sx-cx;
	if (cy+gy>sy) gy=sy-cy;

	if (gx+p1>mhW) gx=mhW-p1;
	if (gy+p2>mhH) gy=mhH-p2;

	bf=bm->sx+3 & 0xFFFC;
	tm=mhpBMP +mhBFW *(mhH -1-p2) +p1;	//Rs[
	mm=bm->pBit +((bm->sy -1-cy)*bf )+cx;	//Rs[

	if (p3<0){
			i=0;
	}else{
		if (p3<256){
			i=1;
		}else{
			i=2; p3=p3&255;
			pm[0]=tm;
			pm[1]=layerBMP +layermhBFW *(layermhH -1-p2) +p1;	//C[
		}
	}

	y=0;
	switch (i){
		//ʏRs[
		case 0:
			while(y< gy){
				memcpy(mm,tm,gx);
				tm-=mhBFW;
				mm-=bf;
				y++;
			}
			break;

		//ߐFtRs[
		case 1:
			while(y< gy){
				x=0;
				while(x< gx){
					if (*(tm+x)==p3){
						x++;
						continue;
					}
					*(mm+x)=*(tm+x);
					x++;
				}
				tm-=mhBFW;
				mm-=bf;
				y++;
			}
			break;

		//C[߃Rs[
		case 2:
			while(y< gy){
				x=0;
				while(x< gx){
					*(mm+x)= *(pm[*(tm+x)==p3]+x);
					x++;
				}
				pm[0]-=mhBFW;
				pm[1]-=layermhBFW;
				mm-=bf;
				tm-=mhBFW;
				y++;
			}
			break;
	}


	return 0;
}

/*
p3 &0 
   &1 j
   &2 ]
EXPORT BOOL WINAPI _Polygon (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	//-----------------------------------------------------
	BMSCR *bm; int p2,p3,p4; int *p1;
	bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
	p1=(int *)hei->HspFunc_prm_getv();
	p2=hei->HspFunc_prm_getdi(0);	//p2 _̐
	p3=hei->HspFunc_prm_getdi(0);	//p3 X^C
	p4=hei->HspFunc_prm_getdi(0);	//hԂtO
	//-----------------------------------------------------

	HPEN hPen;
	HBRUSH hBrush;

	if (p3&2) SetROP2(bm->hdc,R2_NOT);

	hPen=CreatePen((p3&1)*PS_DOT, 1,bm->color);
	hPen=(HPEN)SelectObject(bm->hdc,hPen);

	if (p4==0)
		SelectObject(bm->hdc,GetStockObject(NULL_BRUSH) );
	else
		hBrush=(HBRUSH)SelectObject(bm->hdc,CreateSolidBrush(bm->color) );

	Polygon(bm->hdc,(POINT *)p1,p2);

	DeleteObject(hPen);
	if (p4) DeleteObject(hBrush);

	return 0;
}
*/


//h2_setŃRs[
//p1,p2	Rs[
//p3 ]
//
EXPORT BOOL WINAPI h2_rot90 (BMSCR *bm, int p1, int p2, int p3)
{
	int gx,gy,x,y,cx,cy,px,py,tx,ty,my;

	gx=bm->gy;
	gy=bm->gx;
	cx=bm->cx;
	cy=bm->cy;
	px=p1;
	tx=1; ty=-1;
	my=p2+bm->gy-1;

	if (p3!=0){
		px=p1+bm->gx-1;
		tx=-1; ty=1;
		my=p2;
	}

	for(y=0; y<gy; y++){
			py=my;
		for(x=0; x<gx; x++){
			h2_pset(bm,x+cx,y+cy,-h2_pget(mhbm,px,py,0));
			py+=ty;
		}
		px+=tx;
	}

	return 0;
}

//h2_setŌʎw
//p1 GATCY
//p2 ItZbg
//p3 F
EXPORT BOOL WINAPI area_chk (BMSCR *bm, int p1, int p2, int p3)
{
	int x,y,a0,a,b,ax,ay,tx,ty,ox,oy;
	BYTE *pt,*pm;
	ax=p1>>16;
	ay=p1&0xFFFF;
	ox=(p2>>16   )%ax;
	oy=(p2&0xFFFF)%ay;
	a=p3>>8;
	b=p3&0xFF;

	for(y=bm->sy-1; y>=0; y--){
		for(x=0; x<bm->sx; x++){
			pt=bm->pBit +(bm->sy-y-1)*(bm->sx +3 & 0xFFFC) +x;
			pm=mhpBMP +(mhH-y-1)*mhBFW +x;
			tx=x/ax*ax+ox; if (tx>=bm->sx) tx=bm->sx-1;
			ty=y/ay*ay+oy; if (ty>=bm->sy) ty=bm->sy-1;
			a0=*( mhpBMP +(mhH-ty-1)*mhBFW +tx);
			if (*pm/16 == a0/16) *pt=a; else *pt=b;
		}
	}

	return 0;
}


//F̃JEg(tJ[)
//p1 
EXPORT BOOL WINAPI h2_colorcountF (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	int x,y,ccnt,rgb;
	int *clist;
	BYTE *fcol,*pt;

	//-----------------------------------------------------
		BMSCR *bm;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);
		clist=(int *)hei->HspFunc_prm_getv();
	//-----------------------------------------------------

	fcol=(BYTE *)malloc(256*256*256/8); //2MB
	ZeroMemory(fcol,256*256*256/8);

	ccnt=0;

	for(y=bm->cy; y<bm->gy; y++)
	{
		for(x=bm->cx; x<bm->gx; x++)
		{
			pt=bm->pBit +(bm->sy-y-1)*(bm->sx*3 +3 & 0xFFFC) +x*3;
			rgb=pt[0]<<16|pt[1]<<8|pt[2];
			if (bpeek(fcol,rgb)==0)
			{
				bpoke(fcol,rgb,1);
				if (ccnt<256) clist[ccnt]=rgb;
				ccnt++;
			}
		}
	}
	free(fcol);
	return -ccnt;
}

//F̃JEg
EXPORT BOOL WINAPI h2_colorcount (BMSCR *bm, int p1, int p2, int p3)
{
	BYTE pal[256];
	ZeroMemory(&pal,256);

	int x,y,ex,c,ccnt=0,cmax=0;
	int sw8=bm->sx +3 & 0xFFFC;
	for(y=0; y<bm->sy; y++)
	{
		x=(bm->sy -1-y)*sw8;
		ex=x+bm->sx;
		for(x; x<ex; x++)
		{
			c=*(bm->pBit +x);
			if (pal[c]==0){	pal[c]=1; ccnt++; }
			if (c>cmax) cmax=c;
		}
	}

	switch(p1)
	{
		case 1:
			for(x=0; x<8; x++) { if (cmax&(1<<x)) y=x+1; }
			return -y;
		default:
			return -ccnt;
	}

}

//pbg̐FJEg
EXPORT BOOL WINAPI h2_palcount (BMSCR *bm, int p1, int p2, int p3)
{
	int y,sx,sy,bf;
	int *pc;
	BYTE *plBit,*x;

	pc=(int *)p1;
	sx=bm->sx;
	sy=bm->sy;
	bf=sx +3 & 0xFFFC;
	plBit=bm->pBit;

	ZeroMemory(pc,1024);
	for(y=0; y<sy; y++){
		for(x=plBit; x<(plBit+sx); x++) pc[*x]++;
		plBit += bf;
	}
	return 0;
}

int hl_c[2]={0,0};	//F
int hl_step=2;
int hl_scnt=0;
int hl_fcol=0;
int hl_len=0;		//C̒
//p1,p2 F܂̓pbgNo
//p3 Xebv
//p4 XebvVtg
EXPORT BOOL WINAPI h2_lineset (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{

	//p[^擾///////
		int p1,p2,p3,p4,p5;
		p1=hei->HspFunc_prm_getdi(0);
		p2=hei->HspFunc_prm_getdi(0);
		p3=hei->HspFunc_prm_getdi(0);
		p4=hei->HspFunc_prm_getdi(0);
		p5=hei->HspFunc_prm_getdi(0);
		if (*hei->er) return *hei->er;
	///////////////////////


	hl_c[0]=p1;
	hl_c[1]=p2;
	hl_step=p3&0xFF;
	if (hl_step==0){
		hl_scnt=0;
		hl_c[1]=hl_c[0];
	}
	if (p4!=-1 && hl_step>0){
		p4=p4%(hl_step*2);
		hl_scnt=p4%hl_step;
		hl_fcol= p4>=hl_step;
	}
	hl_len=p5;

	return 0;
}
EXPORT BOOL WINAPI h2_line (BMSCR *bm, int p1, int p2, int p3)
{
	int wx,wy;	//
	int wx2,wy2,i,e;
	int dx,dy;	//

	wx=p1-bm->cx;
	wy=p2-bm->cy;
	if (wx<0){ dx=-1; wx=-wx; }else{ dx=1; }
	if (wy<0){ dy=-1; wy=-wy; }else{ dy=1; }
	wx++; wy++;
	wx2=wx/2;
	wy2=wy/2;

	if (wx>wy){
		e=wx;
		if (hl_len>0 && hl_len<e) e=hl_len;
		for (i=0; i<e ;i++){
			hl_scnt++;
			if (hl_scnt==hl_step){
				hl_scnt=0;
				hl_fcol=hl_fcol^1;
			}
			h2_pset(bm, i*dx+bm->cx, (i*wy +wy2)/wx*dy +bm->cy, hl_c[hl_fcol]);
		}
	}else{
		e=wy;
		if (hl_len>0 && hl_len<e) e=hl_len;
		for (i=0; i<e ;i++){
			hl_scnt++;
			if (hl_scnt==hl_step){
				hl_scnt=0;
				hl_fcol=hl_fcol^1;
			}
			h2_pset(bm, (i*wx +wx2)/wy*dx +bm->cx, i*dy+bm->cy, hl_c[hl_fcol]);
		}
	}
	bm->cx=p1;
	bm->cy=p2;

	return 0;
}

//p3	x
EXPORT BOOL WINAPI bezier (int *p1, int p2, int p3, int p4)
{
	double Tm;
	double p,s,t,q1,q2,q3,q0;
	t=p2;
	Tm=p3;
	q0=p1[0]; q1=p1[1]; q2=p1[2]; q3=p1[3];

	p=(Tm-t)/Tm;
	t=t/Tm;

	s =p*p*p*q0 + 3*t*p*p*q1 + 3*t*t*p*q2 + t*t*t*q3;

	p1[4]=int(s*Tm +0.5);

	return 0;
}

EXPORT BOOL WINAPI h2_rgnframe (BMSCR *bm, int p1, int p2, int p3)
{
	HRGN hrgn;
	RECT rect;
	int x,y,hl_fcol;

	hrgn=(HRGN)p1;

	GetRgnBox(hrgn,&rect);

	for(y=rect.top; y<rect.bottom; y++)
	{
		hl_fcol=y&1;
		for(x=rect.left; x<rect.right; x++)
		{
			hl_fcol^=1;
			if (PtInRegion(hrgn,x,y)==0) continue;
			if (PtInRegion(hrgn,x,y-1)==0||PtInRegion(hrgn,x+1,y)==0||PtInRegion(hrgn,x,y+1)==0||PtInRegion(hrgn,x-1,y)==0)
				h2_pset (bm,x,y,hl_c[hl_fcol]);
		}
	}
	return 0;
}

//p2 (p4{l)
//p3 RGB̊evf
//p4 x
EXPORT BOOL WINAPI gamma (int *p1, int p2, int p3, int p4)
{
	double r,c;
	r=p2;
	c=p3;
	if (p4<1) p4=256;

	*p1=int(pow(c/255,p4/r)*255 *p4 +0.5);
	return 0;
}



//pos ʒu
//gmode TCY
//p1   擾ϐ
//p1.0  X
//p1.1      Y
//p1.2 TCY X
//p1.3        Y
//p2 pbgR[h J[R[h(0x000000)
//p3 P
EXPORT BOOL WINAPI min_area (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	//p[^擾///////
		BMSCR *bm;
		bm=(BMSCR *)hei->HspFunc_getbmscr(*hei->actscr);

		int *p1,p2,p3;
		p1=(int *)hei->HspFunc_prm_getv();
		p2=hei->HspFunc_prm_getdi(0);
		p3=hei->HspFunc_prm_getdi(1); if (p3<1) p3=1;
		if (*hei->er) return *hei->er;
	///////////////////////

	int bfx,x,y;
	int lx=65535,ly=65535,hx=-1,hy=-1;
	BYTE *p;

	switch(bm->palmode){
		case 0:
			bfx=bm->sx*3 +3 & 0xFFFC;
			for (y=0; y<bm->gy; y++){
				p=(bm->sy-1-y-bm->cy)*bfx +bm->cx*3 +bm->pBit;
				for(x=0; x<bm->gx; x++){
					if ( ((p[2]<<16)+(p[1]<<8)+p[0]) !=p2 ){
						if (lx>x) lx=x;
						if (ly>y) ly=y;
						if (hx<x) hx=x;
						if (hy<y) hy=y;
					}
					p+=3;
				}
			}
		break;

		case 1:
			bfx=bm->sx +3 & 0xFFFC;
			for (y=0; y<bm->gy; y++){
				p=(bm->sy-1-y-bm->cy)*bfx +bm->cx +bm->pBit;
				for(x=0; x<bm->gx; x++){
					if (p[x]!=p2){
						if (lx>x) lx=x;
						if (ly>y) ly=y;
						if (hx<x) hx=x;
						if (hy<y) hy=y;
					}
				}
			}
		break;
	}
	if (hx==-1 || hy==-1){
		p1[0]=-1;
		p1[1]=-1;
		p1[2]=-1;
		p1[3]=-1;
		return -1;
	}
	lx=lx/p3*p3;
	ly=ly/p3*p3;
	p1[0]=lx;
	p1[1]=ly;
	p1[2]=(hx-lx+p3)/p3*p3;
	p1[3]=(hy-ly+p3)/p3*p3;

	return 0;
}


/*
EXPORT BOOL WINAPI h2_rgnexp (int *p1, int p2, int p3, int p4)
{
	int i,r_size;
	HRGN hrgn;
	hrgn=(HRGN)*p1;
	RGNDATA *pRgn;
	RECT *rect;

	r_size=GetRegionData(hrgn,0,NULL);
	if (r_size<=sizeof(RGNDATAHEADER)) return 0;

	pRgn=(RGNDATA *)malloc(r_size);
	ZeroMemory(pRgn,r_size);

	GetRegionData(hrgn,r_size,pRgn);
	rect=(RECT *)pRgn->Buffer;

	for(i=0; i<pRgn->rdh.nCount; i++)
	{
		rect[i].right++;
		rect[i].bottom++;
	}

	pRgn->rdh.rcBound.right++;
	pRgn->rdh.rcBound.bottom++;

	DeleteObject(hrgn);
	*p1=(int)ExtCreateRegion(NULL,r_size,pRgn);

	free(pRgn);

	return 0;
}
*/


EXPORT BOOL WINAPI h2_ifinpoly (HSPEXINFO *hei, int _p1, int _p2, int _p3)
{
	//p[^擾///////
		POINT *pt;
		int p2,px,py;
		pt=(POINT *)hei->HspFunc_prm_getv();	//_̔z
		p2=hei->HspFunc_prm_getdi(0);			//_̐
		px=hei->HspFunc_prm_getdi(0);
		py=hei->HspFunc_prm_getdi(0);
		if (*hei->er) return *hei->er;
	///////////////////////
	int s0,s1,i,x1,y1,x2,y2;

	s0=2;
	for (i=0; i<p2; i++)
	{
		x1=pt[i].x; x2=pt[(i+1)%p2].x;
		y1=pt[i].y; y2=pt[(i+1)%p2].y;

		s1=(x2-x1)*(py-y1)-(y2-y1)*(px-x1);
		if (s1<0) s1=-1;
		if (s1>=0) s1=1; // s1==0 C
		if (s0==s1 || i==0){
			s0=s1;
		}else{ i=-1; break; }
	}

	return -(i!=-1);
}
#define PI 3.141592653589793

EXPORT BOOL WINAPI h2_sin (int *p1, int p2, int p3, int p4)
{
	if (p4==0) p4=256;
	*p1=int(sin(p2 *PI/2/p3)*p4);

	return 0;
}
EXPORT BOOL WINAPI h2_cos (int *p1, int p2, int p3, int p4)
{
	if (p4==0) p4=256;
	*p1=int(cos(p2 *PI/2/p3)*p4);
	return 0;
}

EXPORT BOOL WINAPI h2_atan (int *p1, int p2, int p3, int p4)
{
	int i;

	i=int(atan2(p2,p3)*p4/-2/PI);
	if (i<0) i+=p4;
	*p1=i;
	return 0;
}

