#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdlib.h>
#include "..\Hspdll.h"

#define MAXmsg_cnt 256
#define MAXproc_cnt 64

	FARPROC proc_org[MAXproc_cnt];
	HWND proc_hwnd[MAXproc_cnt];
	int us_return[MAXmsg_cnt];
	int us_command[MAXmsg_cnt];
	HWND us_hwnd[MAXmsg_cnt];
	int us_rng[MAXmsg_cnt];

	int *p_msg, *p_wP, *p_lP, *p_hwnd;
	int proc_cnt=0;
	int msg_cnt=0;
	//int hsp_buttonID;
	//int hsp_buttonIDhnd;

LRESULT CALLBACK h2_spiProc(int nNum, int nDenom, long lData)
{
	return 0;
}
BOOL textSet(){
		static HWND hlvEdit;
		static int drag=0;
		int cName[4];
		int cn=0;
		HWND hwndFrom;
		LV_DISPINFO *info;

		info=(LV_DISPINFO *)*p_lP;
		hwndFrom=info->hdr.hwndFrom;

		GetClassName(hwndFrom,(char *)cName,sizeof(cName));

		if (cName[0]==0x4c737953 && cName[1]==0x56747369 &&		//SysListView32
		    cName[2]==0x33776569 && (cName[3]&0xFF)==0x32 ) cn=1;

		if (cName[0]==0x54737953 && cName[1]==0x56656572 &&		//SysTreeView32
		    cName[2]==0x33776569 && (cName[3]&0xFF)==0x32 ) cn=2;

		switch(cn){
			case 1:
				p_msg[4]=(int)hwndFrom;
				p_msg[5]=(int)info->hdr.idFrom;
				p_msg[6]=(int)info->hdr.code;
				switch (info->hdr.code) {
					case LVN_BEGINLABELEDIT:
						p_msg[7]=1;
						hlvEdit = ListView_GetEditControl(hwndFrom);
						break;
					case LVN_ENDLABELEDIT:
						char buf[256];
						p_msg[7]=0;
						GetWindowText(hlvEdit, buf, sizeof(buf));
						ListView_SetItemText(hwndFrom, info->item.iItem, 0, buf);
						break;
					case LVN_BEGINDRAG:
						drag=1;
						break;
					default:
						break;
				}
				break;
			case 2:
				break;
			default:
				break;
		}

}
BOOL scrollSet()
{
	int i,pos,s_flag;
	HWND hscroll=(HWND)*p_lP;
	SCROLLINFO SBinfo;
	SBinfo.cbSize=sizeof(SBinfo);
	SBinfo.fMask=SIF_POS|SIF_RANGE;

	if ((HWND)*p_hwnd==hscroll)
	{
		if (*p_msg==WM_HSCROLL) s_flag=SB_HORZ;
		if (*p_msg==WM_VSCROLL) s_flag=SB_VERT;
	}
	else
	{
		s_flag=SB_CTL;
	}
	
	GetScrollInfo(hscroll,s_flag,&SBinfo);
	pos=SBinfo.nPos;

	i=1;
	switch ( LOWORD(*p_wP) )
	{
		case SB_LINEUP:
			SBinfo.nPos--;
			break;
		case SB_LINEDOWN:
			SBinfo.nPos++;
			break;
		case SB_PAGEUP:
			SBinfo.nPos-=1;
			break;
		case SB_PAGEDOWN:
			SBinfo.nPos+=1;
			break;

		case SB_TOP:
			SBinfo.nPos=SBinfo.nMin;
			break;
		case SB_BOTTOM:
			SBinfo.nPos=SBinfo.nMax;
			break;
		case SB_THUMBPOSITION:		//܂݂𗣂
			SBinfo.nPos=HIWORD(*p_wP);
			break;

		default:
			i=0;
			break;
	}
	if (SBinfo.nPos<SBinfo.nMin) SBinfo.nPos=SBinfo.nMin;
	if (SBinfo.nPos>SBinfo.nMax) SBinfo.nPos=SBinfo.nMax;

	SBinfo.fMask=SIF_POS;
	if (i) SetScrollInfo(hscroll,s_flag,&SBinfo,TRUE);
}

LRESULT CALLBACK h2_Proc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	int i,L,H,wP;
	wP=wParam&0xFFFF;

	for (i=0; i<msg_cnt; i++)
	{
		if (us_command[i]==msg && (us_hwnd[i]==hwnd || us_hwnd[i]==0))
		{

			L=us_rng[i]&0xFFFF;
			H=us_rng[i]>>16;

			if ( us_return[i]!=-3 || wP<16384 || wP>16447 )
			{
				*p_msg	=msg;
				*p_wP	=wParam;
				*p_lP	=lParam;
				*p_hwnd	=(int)hwnd;
			}

			if (msg==WM_NOTIFY) textSet();
			if ( (msg==WM_HSCROLL || msg==WM_VSCROLL)&&(us_rng[i]==*p_lP) ){ scrollSet(); return 0; }
			if (us_return[i]==-1 && wParam>=L && wParam<=H) return 0;
			if (us_return[i]==-2 && wParam>=L && wParam<=H){
 				if (wP<16384 || wP>16447) return 0;
 			}else if (us_return[i]>0) msg=us_return[i];		//bZ[Wւ
			break;
		}
	}

	for (i=0; i<proc_cnt; i++)
	{
		if (hwnd==proc_hwnd[i]) break;
	}

	return CallWindowProc((WNDPROC)proc_org[i] ,hwnd, msg, wParam, lParam);
}

EXPORT BOOL WINAPI h2_setproc ( int *p1, int p2, int p3, int p4 )
{
	if (p2==0){
		*p1=(int)h2_spiProc;
		return 0;
	}

	if (proc_cnt>=MAXproc_cnt) return -1;

	p_msg	=p1;
	p_wP	=p1+1;
	p_lP	=p1+2;
	p_hwnd	=p1+3;

//	hsp_buttonID=p3;
//	hsp_buttonIDhnd=p4;

	proc_hwnd[proc_cnt]=(HWND)p2;
	proc_org[proc_cnt] =(FARPROC)GetWindowLong((HWND)p2,GWL_WNDPROC);
	SetWindowLong((HWND)p2,GWL_WNDPROC,(LONG)h2_Proc);

	proc_cnt++;
	
	return 0;
}

//p1 bZ[W
//p2 nh 0ŋ
//p3 ւ郁bZ[W
//   -1 EBhEɈ؂̃bZ[W𑗂Ȃ
//   -2 HSPȊÕR}hEBhE֑Ȃ
//   -3  HSP̃R}h擾Ȃ
//p4 wP̍ŏő ܂ XN[o[̃nh
EXPORT BOOL WINAPI h2_setmsg ( int p1, int p2, int p3, int p4 )
{
	int i,a,p;

	if (msg_cnt>=MAXmsg_cnt) return -2;

	us_rng[msg_cnt]=p4;
	if (p3<0 && p4==0){
		us_rng[msg_cnt]=0xFFFF0000;
	}

	//R}hȂ`FbN
	for(i=0; i<msg_cnt; i++){
		if (us_command[i]==p1 && us_hwnd[i]==(HWND)p2){
			us_return[i]=p3;
			return -1;
		}
	}
	us_command[msg_cnt]=p1;
	us_hwnd[msg_cnt]=(HWND)p2;
	us_return[msg_cnt]=p3;

	msg_cnt++;

	//\[g
	//SEBhEʃbZ[W͌
	for (i=0; i<msg_cnt; i++){
		if (us_hwnd[i]!=0) continue;

		for (p=i+1; p<msg_cnt; p++){
			if (us_hwnd[p]==0) continue;
			
			a=(int)us_hwnd[i];	us_hwnd[i]=us_hwnd[p];			us_hwnd[p]=(HWND)a;
			a=us_return[i];		us_return[i]=us_return[p];		us_return[p]=a;
			a=us_command[i];	us_command[i]=us_command[p];	us_command[p]=a;
			a=us_rng[i];		us_rng[i]=us_rng[p];			us_rng[p]=a;
			break;
		}
	}

	return 0;
}

