#define IDC_ARROW	32512
#define IDC_IBEAM	32513
#define IDC_WAIT	32514
#define IDC_CROSS	32515
#define IDC_UPARROW	32516

#define IDC_SIZE	32640
#define IDC_ICON	32641
#define IDC_SIZENWSE	32642
#define IDC_SIZENESW	32643
#define IDC_SIZEWE	32644
#define IDC_SIZENS	32645
#define IDC_SIZEALL	32646
#define IDC_NO		32648
#define IDC_APPSTARTING	32650
#define IDC_HELP	32651

#define BS_3STATE		5
#define BS_AUTO3STATE		6
#define BS_AUTOCHECKBOX		3
#define BS_AUTORADIOBUTTON	9
#define BS_BITMAP		128
#define BS_BOTTOM		$800
#define BS_CENTER		$300
#define BS_CHECKBOX		2
#define BS_DEFPUSHBUTTON	1
#define BS_GROUPBOX		7
#define BS_ICON			64
#define BS_LEFT			256
#define BS_LEFTTEXT		32
#define BS_MULTILINE		$2000
#define BS_NOTIFY		$4000
#define BS_OWNERDRAW		$b
#define BS_PUSHBUTTON		0
#define BS_PUSHLIKE		4096
#define BS_RADIOBUTTON		4
#define BS_RIGHT		512
#define BS_RIGHTBUTTON		32
#define BS_TEXT			0
#define BS_TOP			$400
#define BS_USERBUTTON		8
#define BS_VCENTER		$c00
#define BS_FLAT			$8000

#define CCS_TOP			$1
#define CCS_NOMOVEY		$2
#define CCS_BOTTOM		$3
#define CCS_NORESIZE		$4
#define CCS_NOPARENTALIGN	$8
#define CCS_ADJUSTABLE		$20
#define CCS_NODIVIDER 		$40
#define CCS_VERT		$80
#define CCS_LEFT		$80
#define CCS_RIGHT		$81
#define CCS_NOMOVEX		$82

#define COLOR_3DDKSHADOW 21
#define COLOR_3DFACE 15
#define COLOR_3DHILIGHT 20
#define COLOR_3DHIGHLIGHT 20
#define COLOR_3DLIGHT 22
#define COLOR_BTNHILIGHT 20
#define COLOR_3DSHADOW 16
#define COLOR_ACTIVEBORDER 10
#define COLOR_ACTIVECAPTION 2
#define COLOR_APPWORKSPACE 12
#define COLOR_BACKGROUND 1
#define COLOR_DESKTOP 1
#define COLOR_BTNFACE 15
#define COLOR_BTNHIGHLIGHT 20
#define COLOR_BTNSHADOW 16
#define COLOR_BTNTEXT 18
#define COLOR_CAPTIONTEXT 9
#define COLOR_GRAYTEXT 17
#define COLOR_HIGHLIGHT 13
#define COLOR_HIGHLIGHTTEXT 14
#define COLOR_INACTIVEBORDER 11
#define COLOR_INACTIVECAPTION 3
#define COLOR_INACTIVECAPTIONTEXT 19
#define COLOR_INFOBK 24
#define COLOR_INFOTEXT 23
#define COLOR_MENU 4
#define COLOR_MENUTEXT 7
#define COLOR_SCROLLBAR 0
#define COLOR_WINDOW 5
#define COLOR_WINDOWFRAME 6
#define COLOR_WINDOWTEXT 8

#define ILC_COLOR		0
#define ILC_COLOR4		4
#define ILC_COLOR8		8
#define ILC_COLOR16		16
#define ILC_COLOR24		24
#define ILC_COLOR32		32
#define ILC_COLORDDB		254
#define ILC_MASK		1
#define ILC_PALETTE		2048

#define LVS_ICON		0
#define LVS_REPORT		1
#define LVS_SMALLICON		2
#define LVS_LIST		3
#define LVS_TYPEMASK		3
#define LVS_SINGLESEL		4
#define LVS_SHOWSELALWAYS	8
#define LVS_SORTASCENDING	16
#define LVS_SORTDESCENDING	32
#define LVS_SHAREIMAGELISTS	64
#define LVS_NOLABELWRAP		128
#define LVS_AUTOARRANGE		256
#define LVS_EDITLABELS		512
#define LVS_NOSCROLL		0x2000
#define LVS_TYPESTYLEMASK	0xfc00
#define LVS_ALIGNTOP		0
#define LVS_ALIGNLEFT		0x800
#define LVS_ALIGNMASK		0xc00
#define LVS_OWNERDRAWFIXED	0x400
#define LVS_NOCOLUMNHEADER	0x4000
#define LVS_NOSORTHEADER	0x8000

#define LVNI_ALL		0
#define LVNI_FOCUSED		1
#define LVNI_SELECTED		2
#define LVNI_CUT		4
#define LVNI_DROPHILITED	8
#define LVNI_ABOVE		256
#define LVNI_BELOW		512
#define LVNI_TOLEFT		1024
#define LVNI_TORIGHT		2048
#define LVNI_CHECKED		8196	;???

#define TBSTATE_CHECKED		$1
#define TBSTATE_PRESSED		$2
#define TBSTATE_ENABLED		$4
#define TBSTATE_HIDDEN		$8
#define TBSTATE_INDETERMINATE	$10
#define TBSTATE_WRAP		$20
#define TBSTATE_ELLIPSES	$40
#define TBSTATE_MARKED		$80

#define TBSTYLE_BUTTON		$0
#define TBSTYLE_SEP		$1
#define TBSTYLE_CHECK		$2
#define TBSTYLE_GROUP		$4
#define TBSTYLE_CHECKGROUP	$6
#define TBSTYLE_DROPDOWN	$8
#define TBSTYLE_AUTOSIZE	$010
#define TBSTYLE_NOPREFIX	$020
#define TBSTYLE_TOOLTIPS	$100
#define TBSTYLE_WRAPABLE	$200
#define TBSTYLE_ALTDRAG		$400
#define TBSTYLE_FLAT		$800
#define TBSTYLE_LIST		$1000
#define TBSTYLE_CUSTOMERASE	$2000
#define TBSTYLE_REGISTERDROP	$4000
#define TBSTYLE_TRANSPARENT	$8000
#define TBSTYLE_EX_DRAWDDARROWS	$1

#define HINST_COMMCTRL		$FFFFFFFF
#define IDB_STD_SMALL_COLOR	0
#define IDB_STD_LARGE_COLOR	1
#define IDB_VIEW_SMALL_COLOR	4
#define IDB_VIEW_LARGE_COLOR	5

#define STD_CUT			$10000	;(0)
#define STD_COPY		$20000	;(1)
#define STD_PASTE		$30000	;(2)
#define STD_UNDO		$40000	;(3)
#define STD_REDOW		$50000	;(4)
#define STD_DELETE		$60000	;(5)
#define STD_FILENEW		$70000	;(6)
#define STD_FILEOPEN		$80000	;(7)
#define STD_FILESAVE		$90000	;(8)
#define STD_PRINTPRE		$A0000	;(9)
#define STD_PROPERTIES		$B0000	;(10)
#define STD_HELP		$C0000	;(11)
#define STD_FIND		$D0000	;(12)
#define STD_REPLACE		$E0000	;(13)
#define STD_PRINT		$F0000	;(14)

#define WS_EX_DLGMODALFRAME	$1
#define WS_EX_NOPARENTNOTIFY	$4
#define WS_EX_TOPMOST		$8
#define WS_EX_ACCEPTFILES	$10
#define WS_EX_TRANSPARENT	$20
#define WS_EX_MDICHILD		$40
#define WS_EX_TOOLWINDOW	$80
#define WS_EX_WINDOWEDGE	$100
#define WS_EX_CLIENTEDGE	$200
#define WS_EX_CONTEXTHELP	$400
#define WS_EX_RIGHT		$1000
#define WS_EX_LEFT		$0
#define WS_EX_RTLREADING	$2000
#define WS_EX_LTRREADING	$0
#define WS_EX_LEFTSCROLLBAR	$4000
#define WS_EX_RIGHTSCROLLBAR	$0
#define WS_EX_CONTROLPARENT	$10000
#define WS_EX_STATICEDGE	$20000
#define WS_EX_APPWINDOW		$40000
#define WS_EX_OVERLAPPEDWINDOW	$300	;(WS_EX_WINDOWEDGE Or WS_EX_CLIENTEDGE)
#define WS_EX_PALETTEWINDOW	$188	;(WS_EX_WINDOWEDGE Or WS_EX_TOOLWINDOW Or WS_EX_TOPMOST

#define WS_BORDER		$800000
#define WS_CAPTION		$C00000
#define WS_CHILD		$40000000
#define WS_CHILDWINDOW		$40000000	;(WS_CHILD)
#define WS_CLIPCHILDREN		$2000000
#define WS_CLIPSIBLINGS		$4000000
#define WS_DISABLED		$8000000
#define WS_DLGFRAME		$400000

#define WS_GROUP		$20000
#define WS_HSCROLL		$100000
#define WS_ICONIC		$20000000	;(WS_MINIMIZ)
#define WS_MAXIMIZE		$1000000
#define WS_MAXIMIZEBOX		$10000
#define WS_MINIMIZE		$20000000
#define WS_MINIMIZEBOX		$20000
#define WS_OVERLAPPED		$0
#define WS_OVERLAPPEDWINDOW	$$14CF0000	;(WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)
#define WS_POPUP		$80000000
#define WS_POPUPWINDOW		$80880000	;(WS_POPUP Or WS_BORDER Or WS_SYSMENU)
#define WS_SIZEBOX		$40000		;(WS_THICKFRAME)
#define WS_SYSMENU		$80000
#define WS_TABSTOP		$10000
#define WS_THICKFRAME		$40000
#define WS_TILED		$0		;(WS_OVERLAPPED)
#define WS_TILEDWINDOW		$CF0000		;(WS_OVERLAPPEDWINDOW)
#define WS_VISIBLE		$10000000
#define WS_VSCROLL		$200000

#define HWND_TOP		0
#define HWND_BOTTOM		1
#define HWND_TOPMOST		$FFFFFFFF
#define HWND_NOTOPMOST		$FFFFFFFE
#define SWP_NOSIZE		$1
#define SWP_NOMOVE		$2
#define SWP_NOZORDER		$4
#define SWP_NOREDRAW		$8
#define SWP_NOACTIVATE		$10
#define SWP_FRAMECHANGED	$20
#define SWP_SHOWWINDOW		$40
#define SWP_HIDEWINDO		$80
#define SWP_NOCOPYBITS		$100
#define SWP_NOOWNERZORDER	$200
#define SWP_DRAWFRAME		$20	;SWP_FRAMECHANGED
#define SWP_NOREPOSITION	$200	;SWP_NOOWNERZORDER

#define UDS_WRAP $0001
#define UDS_SETBUDDYINT $0002
#define UDS_ALIGNRIGHT $0004
#define UDS_ALIGNLEFT $0008
#define UDS_AUTOBUDDY $0010
#define UDS_ARROWKEYS $0020
#define UDS_HORZ $0040
#define UDS_NOTHOUSANDS $0080
